<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAccountMigrationStatusesInfo ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfAccountMigrationStatusesInfo
 * @subpackage Arrays
 */
class ArrayOfAccountMigrationStatusesInfo extends AbstractStructArrayBase
{
    /**
     * The AccountMigrationStatusesInfo
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\AccountMigrationStatusesInfo[]
     */
    public $AccountMigrationStatusesInfo;
    /**
     * Constructor method for ArrayOfAccountMigrationStatusesInfo
     * @uses ArrayOfAccountMigrationStatusesInfo::setAccountMigrationStatusesInfo()
     * @param \StructType\AccountMigrationStatusesInfo[] $accountMigrationStatusesInfo
     */
    public function __construct(array $accountMigrationStatusesInfo = array())
    {
        $this
            ->setAccountMigrationStatusesInfo($accountMigrationStatusesInfo);
    }
    /**
     * Get AccountMigrationStatusesInfo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\AccountMigrationStatusesInfo[]|null
     */
    public function getAccountMigrationStatusesInfo()
    {
        return isset($this->AccountMigrationStatusesInfo) ? $this->AccountMigrationStatusesInfo : null;
    }
    /**
     * This method is responsible for validating the values passed to the setAccountMigrationStatusesInfo method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAccountMigrationStatusesInfo method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAccountMigrationStatusesInfoForArrayConstraintsFromSetAccountMigrationStatusesInfo(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfAccountMigrationStatusesInfoAccountMigrationStatusesInfoItem) {
            // validation for constraint: itemType
            if (!$arrayOfAccountMigrationStatusesInfoAccountMigrationStatusesInfoItem instanceof \StructType\AccountMigrationStatusesInfo) {
                $invalidValues[] = is_object($arrayOfAccountMigrationStatusesInfoAccountMigrationStatusesInfoItem) ? get_class($arrayOfAccountMigrationStatusesInfoAccountMigrationStatusesInfoItem) : sprintf('%s(%s)', gettype($arrayOfAccountMigrationStatusesInfoAccountMigrationStatusesInfoItem), var_export($arrayOfAccountMigrationStatusesInfoAccountMigrationStatusesInfoItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The AccountMigrationStatusesInfo property can only contain items of type \StructType\AccountMigrationStatusesInfo, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AccountMigrationStatusesInfo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\AccountMigrationStatusesInfo[] $accountMigrationStatusesInfo
     * @return \ArrayType\ArrayOfAccountMigrationStatusesInfo
     */
    public function setAccountMigrationStatusesInfo(array $accountMigrationStatusesInfo = array())
    {
        // validation for constraint: array
        if ('' !== ($accountMigrationStatusesInfoArrayErrorMessage = self::validateAccountMigrationStatusesInfoForArrayConstraintsFromSetAccountMigrationStatusesInfo($accountMigrationStatusesInfo))) {
            throw new \InvalidArgumentException($accountMigrationStatusesInfoArrayErrorMessage, __LINE__);
        }
        if (is_null($accountMigrationStatusesInfo) || (is_array($accountMigrationStatusesInfo) && empty($accountMigrationStatusesInfo))) {
            unset($this->AccountMigrationStatusesInfo);
        } else {
            $this->AccountMigrationStatusesInfo = $accountMigrationStatusesInfo;
        }
        return $this;
    }
    /**
     * Add item to AccountMigrationStatusesInfo value
     * @throws \InvalidArgumentException
     * @param \StructType\AccountMigrationStatusesInfo $item
     * @return \ArrayType\ArrayOfAccountMigrationStatusesInfo
     */
    public function addToAccountMigrationStatusesInfo(\StructType\AccountMigrationStatusesInfo $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AccountMigrationStatusesInfo) {
            throw new \InvalidArgumentException(sprintf('The AccountMigrationStatusesInfo property can only contain items of type \StructType\AccountMigrationStatusesInfo, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->AccountMigrationStatusesInfo[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\AccountMigrationStatusesInfo|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\AccountMigrationStatusesInfo|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\AccountMigrationStatusesInfo|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\AccountMigrationStatusesInfo|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\AccountMigrationStatusesInfo|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AccountMigrationStatusesInfo
     */
    public function getAttributeName()
    {
        return 'AccountMigrationStatusesInfo';
    }
}
