<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAdApiError ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfAdApiError
 * @subpackage Arrays
 */
class ArrayOfAdApiError extends AbstractStructArrayBase
{
    /**
     * The AdApiError
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\AdApiError[]
     */
    public $AdApiError;
    /**
     * Constructor method for ArrayOfAdApiError
     * @uses ArrayOfAdApiError::setAdApiError()
     * @param \StructType\AdApiError[] $adApiError
     */
    public function __construct(array $adApiError = array())
    {
        $this
            ->setAdApiError($adApiError);
    }
    /**
     * Get AdApiError value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\AdApiError[]|null
     */
    public function getAdApiError()
    {
        return isset($this->AdApiError) ? $this->AdApiError : null;
    }
    /**
     * This method is responsible for validating the values passed to the setAdApiError method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAdApiError method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAdApiErrorForArrayConstraintsFromSetAdApiError(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfAdApiErrorAdApiErrorItem) {
            // validation for constraint: itemType
            if (!$arrayOfAdApiErrorAdApiErrorItem instanceof \StructType\AdApiError) {
                $invalidValues[] = is_object($arrayOfAdApiErrorAdApiErrorItem) ? get_class($arrayOfAdApiErrorAdApiErrorItem) : sprintf('%s(%s)', gettype($arrayOfAdApiErrorAdApiErrorItem), var_export($arrayOfAdApiErrorAdApiErrorItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The AdApiError property can only contain items of type \StructType\AdApiError, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AdApiError value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\AdApiError[] $adApiError
     * @return \ArrayType\ArrayOfAdApiError
     */
    public function setAdApiError(array $adApiError = array())
    {
        // validation for constraint: array
        if ('' !== ($adApiErrorArrayErrorMessage = self::validateAdApiErrorForArrayConstraintsFromSetAdApiError($adApiError))) {
            throw new \InvalidArgumentException($adApiErrorArrayErrorMessage, __LINE__);
        }
        if (is_null($adApiError) || (is_array($adApiError) && empty($adApiError))) {
            unset($this->AdApiError);
        } else {
            $this->AdApiError = $adApiError;
        }
        return $this;
    }
    /**
     * Add item to AdApiError value
     * @throws \InvalidArgumentException
     * @param \StructType\AdApiError $item
     * @return \ArrayType\ArrayOfAdApiError
     */
    public function addToAdApiError(\StructType\AdApiError $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AdApiError) {
            throw new \InvalidArgumentException(sprintf('The AdApiError property can only contain items of type \StructType\AdApiError, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->AdApiError[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\AdApiError|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\AdApiError|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\AdApiError|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\AdApiError|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\AdApiError|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AdApiError
     */
    public function getAttributeName()
    {
        return 'AdApiError';
    }
}
