<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAdExtension ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfAdExtension
 * @subpackage Arrays
 */
class ArrayOfAdExtension extends AbstractStructArrayBase
{
    /**
     * The AdExtension
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\AdExtension[]
     */
    public $AdExtension;
    /**
     * Constructor method for ArrayOfAdExtension
     * @uses ArrayOfAdExtension::setAdExtension()
     * @param \StructType\AdExtension[] $adExtension
     */
    public function __construct(array $adExtension = array())
    {
        $this
            ->setAdExtension($adExtension);
    }
    /**
     * Get AdExtension value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\AdExtension[]|null
     */
    public function getAdExtension()
    {
        return isset($this->AdExtension) ? $this->AdExtension : null;
    }
    /**
     * This method is responsible for validating the values passed to the setAdExtension method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAdExtension method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAdExtensionForArrayConstraintsFromSetAdExtension(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfAdExtensionAdExtensionItem) {
            // validation for constraint: itemType
            if (!$arrayOfAdExtensionAdExtensionItem instanceof \StructType\AdExtension) {
                $invalidValues[] = is_object($arrayOfAdExtensionAdExtensionItem) ? get_class($arrayOfAdExtensionAdExtensionItem) : sprintf('%s(%s)', gettype($arrayOfAdExtensionAdExtensionItem), var_export($arrayOfAdExtensionAdExtensionItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The AdExtension property can only contain items of type \StructType\AdExtension, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AdExtension value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\AdExtension[] $adExtension
     * @return \ArrayType\ArrayOfAdExtension
     */
    public function setAdExtension(array $adExtension = array())
    {
        // validation for constraint: array
        if ('' !== ($adExtensionArrayErrorMessage = self::validateAdExtensionForArrayConstraintsFromSetAdExtension($adExtension))) {
            throw new \InvalidArgumentException($adExtensionArrayErrorMessage, __LINE__);
        }
        if (is_null($adExtension) || (is_array($adExtension) && empty($adExtension))) {
            unset($this->AdExtension);
        } else {
            $this->AdExtension = $adExtension;
        }
        return $this;
    }
    /**
     * Add item to AdExtension value
     * @throws \InvalidArgumentException
     * @param \StructType\AdExtension $item
     * @return \ArrayType\ArrayOfAdExtension
     */
    public function addToAdExtension(\StructType\AdExtension $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AdExtension) {
            throw new \InvalidArgumentException(sprintf('The AdExtension property can only contain items of type \StructType\AdExtension, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->AdExtension[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\AdExtension|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\AdExtension|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\AdExtension|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\AdExtension|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\AdExtension|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AdExtension
     */
    public function getAttributeName()
    {
        return 'AdExtension';
    }
}
