<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAdExtensionAssociation ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfAdExtensionAssociation
 * @subpackage Arrays
 */
class ArrayOfAdExtensionAssociation extends AbstractStructArrayBase
{
    /**
     * The AdExtensionAssociation
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\AdExtensionAssociation[]
     */
    public $AdExtensionAssociation;
    /**
     * Constructor method for ArrayOfAdExtensionAssociation
     * @uses ArrayOfAdExtensionAssociation::setAdExtensionAssociation()
     * @param \StructType\AdExtensionAssociation[] $adExtensionAssociation
     */
    public function __construct(array $adExtensionAssociation = array())
    {
        $this
            ->setAdExtensionAssociation($adExtensionAssociation);
    }
    /**
     * Get AdExtensionAssociation value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\AdExtensionAssociation[]|null
     */
    public function getAdExtensionAssociation()
    {
        return isset($this->AdExtensionAssociation) ? $this->AdExtensionAssociation : null;
    }
    /**
     * This method is responsible for validating the values passed to the setAdExtensionAssociation method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAdExtensionAssociation method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAdExtensionAssociationForArrayConstraintsFromSetAdExtensionAssociation(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfAdExtensionAssociationAdExtensionAssociationItem) {
            // validation for constraint: itemType
            if (!$arrayOfAdExtensionAssociationAdExtensionAssociationItem instanceof \StructType\AdExtensionAssociation) {
                $invalidValues[] = is_object($arrayOfAdExtensionAssociationAdExtensionAssociationItem) ? get_class($arrayOfAdExtensionAssociationAdExtensionAssociationItem) : sprintf('%s(%s)', gettype($arrayOfAdExtensionAssociationAdExtensionAssociationItem), var_export($arrayOfAdExtensionAssociationAdExtensionAssociationItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The AdExtensionAssociation property can only contain items of type \StructType\AdExtensionAssociation, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AdExtensionAssociation value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\AdExtensionAssociation[] $adExtensionAssociation
     * @return \ArrayType\ArrayOfAdExtensionAssociation
     */
    public function setAdExtensionAssociation(array $adExtensionAssociation = array())
    {
        // validation for constraint: array
        if ('' !== ($adExtensionAssociationArrayErrorMessage = self::validateAdExtensionAssociationForArrayConstraintsFromSetAdExtensionAssociation($adExtensionAssociation))) {
            throw new \InvalidArgumentException($adExtensionAssociationArrayErrorMessage, __LINE__);
        }
        if (is_null($adExtensionAssociation) || (is_array($adExtensionAssociation) && empty($adExtensionAssociation))) {
            unset($this->AdExtensionAssociation);
        } else {
            $this->AdExtensionAssociation = $adExtensionAssociation;
        }
        return $this;
    }
    /**
     * Add item to AdExtensionAssociation value
     * @throws \InvalidArgumentException
     * @param \StructType\AdExtensionAssociation $item
     * @return \ArrayType\ArrayOfAdExtensionAssociation
     */
    public function addToAdExtensionAssociation(\StructType\AdExtensionAssociation $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AdExtensionAssociation) {
            throw new \InvalidArgumentException(sprintf('The AdExtensionAssociation property can only contain items of type \StructType\AdExtensionAssociation, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->AdExtensionAssociation[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\AdExtensionAssociation|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\AdExtensionAssociation|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\AdExtensionAssociation|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\AdExtensionAssociation|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\AdExtensionAssociation|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AdExtensionAssociation
     */
    public function getAttributeName()
    {
        return 'AdExtensionAssociation';
    }
}
