<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAdExtensionAssociationCollection ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfAdExtensionAssociationCollection
 * @subpackage Arrays
 */
class ArrayOfAdExtensionAssociationCollection extends AbstractStructArrayBase
{
    /**
     * The AdExtensionAssociationCollection
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\AdExtensionAssociationCollection[]
     */
    public $AdExtensionAssociationCollection;
    /**
     * Constructor method for ArrayOfAdExtensionAssociationCollection
     * @uses ArrayOfAdExtensionAssociationCollection::setAdExtensionAssociationCollection()
     * @param \StructType\AdExtensionAssociationCollection[] $adExtensionAssociationCollection
     */
    public function __construct(array $adExtensionAssociationCollection = array())
    {
        $this
            ->setAdExtensionAssociationCollection($adExtensionAssociationCollection);
    }
    /**
     * Get AdExtensionAssociationCollection value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\AdExtensionAssociationCollection[]|null
     */
    public function getAdExtensionAssociationCollection()
    {
        return isset($this->AdExtensionAssociationCollection) ? $this->AdExtensionAssociationCollection : null;
    }
    /**
     * This method is responsible for validating the values passed to the setAdExtensionAssociationCollection method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAdExtensionAssociationCollection method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAdExtensionAssociationCollectionForArrayConstraintsFromSetAdExtensionAssociationCollection(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfAdExtensionAssociationCollectionAdExtensionAssociationCollectionItem) {
            // validation for constraint: itemType
            if (!$arrayOfAdExtensionAssociationCollectionAdExtensionAssociationCollectionItem instanceof \StructType\AdExtensionAssociationCollection) {
                $invalidValues[] = is_object($arrayOfAdExtensionAssociationCollectionAdExtensionAssociationCollectionItem) ? get_class($arrayOfAdExtensionAssociationCollectionAdExtensionAssociationCollectionItem) : sprintf('%s(%s)', gettype($arrayOfAdExtensionAssociationCollectionAdExtensionAssociationCollectionItem), var_export($arrayOfAdExtensionAssociationCollectionAdExtensionAssociationCollectionItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The AdExtensionAssociationCollection property can only contain items of type \StructType\AdExtensionAssociationCollection, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AdExtensionAssociationCollection value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\AdExtensionAssociationCollection[] $adExtensionAssociationCollection
     * @return \ArrayType\ArrayOfAdExtensionAssociationCollection
     */
    public function setAdExtensionAssociationCollection(array $adExtensionAssociationCollection = array())
    {
        // validation for constraint: array
        if ('' !== ($adExtensionAssociationCollectionArrayErrorMessage = self::validateAdExtensionAssociationCollectionForArrayConstraintsFromSetAdExtensionAssociationCollection($adExtensionAssociationCollection))) {
            throw new \InvalidArgumentException($adExtensionAssociationCollectionArrayErrorMessage, __LINE__);
        }
        if (is_null($adExtensionAssociationCollection) || (is_array($adExtensionAssociationCollection) && empty($adExtensionAssociationCollection))) {
            unset($this->AdExtensionAssociationCollection);
        } else {
            $this->AdExtensionAssociationCollection = $adExtensionAssociationCollection;
        }
        return $this;
    }
    /**
     * Add item to AdExtensionAssociationCollection value
     * @throws \InvalidArgumentException
     * @param \StructType\AdExtensionAssociationCollection $item
     * @return \ArrayType\ArrayOfAdExtensionAssociationCollection
     */
    public function addToAdExtensionAssociationCollection(\StructType\AdExtensionAssociationCollection $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AdExtensionAssociationCollection) {
            throw new \InvalidArgumentException(sprintf('The AdExtensionAssociationCollection property can only contain items of type \StructType\AdExtensionAssociationCollection, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->AdExtensionAssociationCollection[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\AdExtensionAssociationCollection|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\AdExtensionAssociationCollection|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\AdExtensionAssociationCollection|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\AdExtensionAssociationCollection|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\AdExtensionAssociationCollection|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AdExtensionAssociationCollection
     */
    public function getAttributeName()
    {
        return 'AdExtensionAssociationCollection';
    }
}
