<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAdExtensionEditorialReason ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfAdExtensionEditorialReason
 * @subpackage Arrays
 */
class ArrayOfAdExtensionEditorialReason extends AbstractStructArrayBase
{
    /**
     * The AdExtensionEditorialReason
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\AdExtensionEditorialReason[]
     */
    public $AdExtensionEditorialReason;
    /**
     * Constructor method for ArrayOfAdExtensionEditorialReason
     * @uses ArrayOfAdExtensionEditorialReason::setAdExtensionEditorialReason()
     * @param \StructType\AdExtensionEditorialReason[] $adExtensionEditorialReason
     */
    public function __construct(array $adExtensionEditorialReason = array())
    {
        $this
            ->setAdExtensionEditorialReason($adExtensionEditorialReason);
    }
    /**
     * Get AdExtensionEditorialReason value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\AdExtensionEditorialReason[]|null
     */
    public function getAdExtensionEditorialReason()
    {
        return isset($this->AdExtensionEditorialReason) ? $this->AdExtensionEditorialReason : null;
    }
    /**
     * This method is responsible for validating the values passed to the setAdExtensionEditorialReason method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAdExtensionEditorialReason method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAdExtensionEditorialReasonForArrayConstraintsFromSetAdExtensionEditorialReason(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfAdExtensionEditorialReasonAdExtensionEditorialReasonItem) {
            // validation for constraint: itemType
            if (!$arrayOfAdExtensionEditorialReasonAdExtensionEditorialReasonItem instanceof \StructType\AdExtensionEditorialReason) {
                $invalidValues[] = is_object($arrayOfAdExtensionEditorialReasonAdExtensionEditorialReasonItem) ? get_class($arrayOfAdExtensionEditorialReasonAdExtensionEditorialReasonItem) : sprintf('%s(%s)', gettype($arrayOfAdExtensionEditorialReasonAdExtensionEditorialReasonItem), var_export($arrayOfAdExtensionEditorialReasonAdExtensionEditorialReasonItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The AdExtensionEditorialReason property can only contain items of type \StructType\AdExtensionEditorialReason, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AdExtensionEditorialReason value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\AdExtensionEditorialReason[] $adExtensionEditorialReason
     * @return \ArrayType\ArrayOfAdExtensionEditorialReason
     */
    public function setAdExtensionEditorialReason(array $adExtensionEditorialReason = array())
    {
        // validation for constraint: array
        if ('' !== ($adExtensionEditorialReasonArrayErrorMessage = self::validateAdExtensionEditorialReasonForArrayConstraintsFromSetAdExtensionEditorialReason($adExtensionEditorialReason))) {
            throw new \InvalidArgumentException($adExtensionEditorialReasonArrayErrorMessage, __LINE__);
        }
        if (is_null($adExtensionEditorialReason) || (is_array($adExtensionEditorialReason) && empty($adExtensionEditorialReason))) {
            unset($this->AdExtensionEditorialReason);
        } else {
            $this->AdExtensionEditorialReason = $adExtensionEditorialReason;
        }
        return $this;
    }
    /**
     * Add item to AdExtensionEditorialReason value
     * @throws \InvalidArgumentException
     * @param \StructType\AdExtensionEditorialReason $item
     * @return \ArrayType\ArrayOfAdExtensionEditorialReason
     */
    public function addToAdExtensionEditorialReason(\StructType\AdExtensionEditorialReason $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AdExtensionEditorialReason) {
            throw new \InvalidArgumentException(sprintf('The AdExtensionEditorialReason property can only contain items of type \StructType\AdExtensionEditorialReason, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->AdExtensionEditorialReason[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\AdExtensionEditorialReason|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\AdExtensionEditorialReason|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\AdExtensionEditorialReason|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\AdExtensionEditorialReason|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\AdExtensionEditorialReason|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AdExtensionEditorialReason
     */
    public function getAttributeName()
    {
        return 'AdExtensionEditorialReason';
    }
}
