<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAdExtensionIdToEntityIdAssociation ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfAdExtensionIdToEntityIdAssociation
 * @subpackage Arrays
 */
class ArrayOfAdExtensionIdToEntityIdAssociation extends AbstractStructArrayBase
{
    /**
     * The AdExtensionIdToEntityIdAssociation
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\AdExtensionIdToEntityIdAssociation[]
     */
    public $AdExtensionIdToEntityIdAssociation;
    /**
     * Constructor method for ArrayOfAdExtensionIdToEntityIdAssociation
     * @uses ArrayOfAdExtensionIdToEntityIdAssociation::setAdExtensionIdToEntityIdAssociation()
     * @param \StructType\AdExtensionIdToEntityIdAssociation[] $adExtensionIdToEntityIdAssociation
     */
    public function __construct(array $adExtensionIdToEntityIdAssociation = array())
    {
        $this
            ->setAdExtensionIdToEntityIdAssociation($adExtensionIdToEntityIdAssociation);
    }
    /**
     * Get AdExtensionIdToEntityIdAssociation value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\AdExtensionIdToEntityIdAssociation[]|null
     */
    public function getAdExtensionIdToEntityIdAssociation()
    {
        return isset($this->AdExtensionIdToEntityIdAssociation) ? $this->AdExtensionIdToEntityIdAssociation : null;
    }
    /**
     * This method is responsible for validating the values passed to the setAdExtensionIdToEntityIdAssociation method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAdExtensionIdToEntityIdAssociation method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAdExtensionIdToEntityIdAssociationForArrayConstraintsFromSetAdExtensionIdToEntityIdAssociation(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfAdExtensionIdToEntityIdAssociationAdExtensionIdToEntityIdAssociationItem) {
            // validation for constraint: itemType
            if (!$arrayOfAdExtensionIdToEntityIdAssociationAdExtensionIdToEntityIdAssociationItem instanceof \StructType\AdExtensionIdToEntityIdAssociation) {
                $invalidValues[] = is_object($arrayOfAdExtensionIdToEntityIdAssociationAdExtensionIdToEntityIdAssociationItem) ? get_class($arrayOfAdExtensionIdToEntityIdAssociationAdExtensionIdToEntityIdAssociationItem) : sprintf('%s(%s)', gettype($arrayOfAdExtensionIdToEntityIdAssociationAdExtensionIdToEntityIdAssociationItem), var_export($arrayOfAdExtensionIdToEntityIdAssociationAdExtensionIdToEntityIdAssociationItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The AdExtensionIdToEntityIdAssociation property can only contain items of type \StructType\AdExtensionIdToEntityIdAssociation, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AdExtensionIdToEntityIdAssociation value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\AdExtensionIdToEntityIdAssociation[] $adExtensionIdToEntityIdAssociation
     * @return \ArrayType\ArrayOfAdExtensionIdToEntityIdAssociation
     */
    public function setAdExtensionIdToEntityIdAssociation(array $adExtensionIdToEntityIdAssociation = array())
    {
        // validation for constraint: array
        if ('' !== ($adExtensionIdToEntityIdAssociationArrayErrorMessage = self::validateAdExtensionIdToEntityIdAssociationForArrayConstraintsFromSetAdExtensionIdToEntityIdAssociation($adExtensionIdToEntityIdAssociation))) {
            throw new \InvalidArgumentException($adExtensionIdToEntityIdAssociationArrayErrorMessage, __LINE__);
        }
        if (is_null($adExtensionIdToEntityIdAssociation) || (is_array($adExtensionIdToEntityIdAssociation) && empty($adExtensionIdToEntityIdAssociation))) {
            unset($this->AdExtensionIdToEntityIdAssociation);
        } else {
            $this->AdExtensionIdToEntityIdAssociation = $adExtensionIdToEntityIdAssociation;
        }
        return $this;
    }
    /**
     * Add item to AdExtensionIdToEntityIdAssociation value
     * @throws \InvalidArgumentException
     * @param \StructType\AdExtensionIdToEntityIdAssociation $item
     * @return \ArrayType\ArrayOfAdExtensionIdToEntityIdAssociation
     */
    public function addToAdExtensionIdToEntityIdAssociation(\StructType\AdExtensionIdToEntityIdAssociation $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AdExtensionIdToEntityIdAssociation) {
            throw new \InvalidArgumentException(sprintf('The AdExtensionIdToEntityIdAssociation property can only contain items of type \StructType\AdExtensionIdToEntityIdAssociation, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->AdExtensionIdToEntityIdAssociation[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\AdExtensionIdToEntityIdAssociation|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\AdExtensionIdToEntityIdAssociation|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\AdExtensionIdToEntityIdAssociation|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\AdExtensionIdToEntityIdAssociation|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\AdExtensionIdToEntityIdAssociation|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AdExtensionIdToEntityIdAssociation
     */
    public function getAttributeName()
    {
        return 'AdExtensionIdToEntityIdAssociation';
    }
}
