<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAdExtensionIdentity ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfAdExtensionIdentity
 * @subpackage Arrays
 */
class ArrayOfAdExtensionIdentity extends AbstractStructArrayBase
{
    /**
     * The AdExtensionIdentity
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\AdExtensionIdentity[]
     */
    public $AdExtensionIdentity;
    /**
     * Constructor method for ArrayOfAdExtensionIdentity
     * @uses ArrayOfAdExtensionIdentity::setAdExtensionIdentity()
     * @param \StructType\AdExtensionIdentity[] $adExtensionIdentity
     */
    public function __construct(array $adExtensionIdentity = array())
    {
        $this
            ->setAdExtensionIdentity($adExtensionIdentity);
    }
    /**
     * Get AdExtensionIdentity value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\AdExtensionIdentity[]|null
     */
    public function getAdExtensionIdentity()
    {
        return isset($this->AdExtensionIdentity) ? $this->AdExtensionIdentity : null;
    }
    /**
     * This method is responsible for validating the values passed to the setAdExtensionIdentity method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAdExtensionIdentity method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAdExtensionIdentityForArrayConstraintsFromSetAdExtensionIdentity(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfAdExtensionIdentityAdExtensionIdentityItem) {
            // validation for constraint: itemType
            if (!$arrayOfAdExtensionIdentityAdExtensionIdentityItem instanceof \StructType\AdExtensionIdentity) {
                $invalidValues[] = is_object($arrayOfAdExtensionIdentityAdExtensionIdentityItem) ? get_class($arrayOfAdExtensionIdentityAdExtensionIdentityItem) : sprintf('%s(%s)', gettype($arrayOfAdExtensionIdentityAdExtensionIdentityItem), var_export($arrayOfAdExtensionIdentityAdExtensionIdentityItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The AdExtensionIdentity property can only contain items of type \StructType\AdExtensionIdentity, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AdExtensionIdentity value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\AdExtensionIdentity[] $adExtensionIdentity
     * @return \ArrayType\ArrayOfAdExtensionIdentity
     */
    public function setAdExtensionIdentity(array $adExtensionIdentity = array())
    {
        // validation for constraint: array
        if ('' !== ($adExtensionIdentityArrayErrorMessage = self::validateAdExtensionIdentityForArrayConstraintsFromSetAdExtensionIdentity($adExtensionIdentity))) {
            throw new \InvalidArgumentException($adExtensionIdentityArrayErrorMessage, __LINE__);
        }
        if (is_null($adExtensionIdentity) || (is_array($adExtensionIdentity) && empty($adExtensionIdentity))) {
            unset($this->AdExtensionIdentity);
        } else {
            $this->AdExtensionIdentity = $adExtensionIdentity;
        }
        return $this;
    }
    /**
     * Add item to AdExtensionIdentity value
     * @throws \InvalidArgumentException
     * @param \StructType\AdExtensionIdentity $item
     * @return \ArrayType\ArrayOfAdExtensionIdentity
     */
    public function addToAdExtensionIdentity(\StructType\AdExtensionIdentity $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AdExtensionIdentity) {
            throw new \InvalidArgumentException(sprintf('The AdExtensionIdentity property can only contain items of type \StructType\AdExtensionIdentity, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->AdExtensionIdentity[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\AdExtensionIdentity|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\AdExtensionIdentity|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\AdExtensionIdentity|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\AdExtensionIdentity|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\AdExtensionIdentity|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AdExtensionIdentity
     */
    public function getAttributeName()
    {
        return 'AdExtensionIdentity';
    }
}
