<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAdGroupNegativeSites ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfAdGroupNegativeSites
 * @subpackage Arrays
 */
class ArrayOfAdGroupNegativeSites extends AbstractStructArrayBase
{
    /**
     * The AdGroupNegativeSites
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\AdGroupNegativeSites[]
     */
    public $AdGroupNegativeSites;
    /**
     * Constructor method for ArrayOfAdGroupNegativeSites
     * @uses ArrayOfAdGroupNegativeSites::setAdGroupNegativeSites()
     * @param \StructType\AdGroupNegativeSites[] $adGroupNegativeSites
     */
    public function __construct(array $adGroupNegativeSites = array())
    {
        $this
            ->setAdGroupNegativeSites($adGroupNegativeSites);
    }
    /**
     * Get AdGroupNegativeSites value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\AdGroupNegativeSites[]|null
     */
    public function getAdGroupNegativeSites()
    {
        return isset($this->AdGroupNegativeSites) ? $this->AdGroupNegativeSites : null;
    }
    /**
     * This method is responsible for validating the values passed to the setAdGroupNegativeSites method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAdGroupNegativeSites method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAdGroupNegativeSitesForArrayConstraintsFromSetAdGroupNegativeSites(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfAdGroupNegativeSitesAdGroupNegativeSitesItem) {
            // validation for constraint: itemType
            if (!$arrayOfAdGroupNegativeSitesAdGroupNegativeSitesItem instanceof \StructType\AdGroupNegativeSites) {
                $invalidValues[] = is_object($arrayOfAdGroupNegativeSitesAdGroupNegativeSitesItem) ? get_class($arrayOfAdGroupNegativeSitesAdGroupNegativeSitesItem) : sprintf('%s(%s)', gettype($arrayOfAdGroupNegativeSitesAdGroupNegativeSitesItem), var_export($arrayOfAdGroupNegativeSitesAdGroupNegativeSitesItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The AdGroupNegativeSites property can only contain items of type \StructType\AdGroupNegativeSites, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AdGroupNegativeSites value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\AdGroupNegativeSites[] $adGroupNegativeSites
     * @return \ArrayType\ArrayOfAdGroupNegativeSites
     */
    public function setAdGroupNegativeSites(array $adGroupNegativeSites = array())
    {
        // validation for constraint: array
        if ('' !== ($adGroupNegativeSitesArrayErrorMessage = self::validateAdGroupNegativeSitesForArrayConstraintsFromSetAdGroupNegativeSites($adGroupNegativeSites))) {
            throw new \InvalidArgumentException($adGroupNegativeSitesArrayErrorMessage, __LINE__);
        }
        if (is_null($adGroupNegativeSites) || (is_array($adGroupNegativeSites) && empty($adGroupNegativeSites))) {
            unset($this->AdGroupNegativeSites);
        } else {
            $this->AdGroupNegativeSites = $adGroupNegativeSites;
        }
        return $this;
    }
    /**
     * Add item to AdGroupNegativeSites value
     * @throws \InvalidArgumentException
     * @param \StructType\AdGroupNegativeSites $item
     * @return \ArrayType\ArrayOfAdGroupNegativeSites
     */
    public function addToAdGroupNegativeSites(\StructType\AdGroupNegativeSites $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AdGroupNegativeSites) {
            throw new \InvalidArgumentException(sprintf('The AdGroupNegativeSites property can only contain items of type \StructType\AdGroupNegativeSites, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->AdGroupNegativeSites[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\AdGroupNegativeSites|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\AdGroupNegativeSites|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\AdGroupNegativeSites|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\AdGroupNegativeSites|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\AdGroupNegativeSites|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AdGroupNegativeSites
     */
    public function getAttributeName()
    {
        return 'AdGroupNegativeSites';
    }
}
