<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfArrayOfMediaAssociation ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfArrayOfMediaAssociation
 * @subpackage Arrays
 */
class ArrayOfArrayOfMediaAssociation extends AbstractStructArrayBase
{
    /**
     * The ArrayOfMediaAssociation
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfMediaAssociation[]
     */
    public $ArrayOfMediaAssociation;
    /**
     * Constructor method for ArrayOfArrayOfMediaAssociation
     * @uses ArrayOfArrayOfMediaAssociation::setArrayOfMediaAssociation()
     * @param \ArrayType\ArrayOfMediaAssociation[] $arrayOfMediaAssociation
     */
    public function __construct(array $arrayOfMediaAssociation = array())
    {
        $this
            ->setArrayOfMediaAssociation($arrayOfMediaAssociation);
    }
    /**
     * Get ArrayOfMediaAssociation value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfMediaAssociation[]|null
     */
    public function getArrayOfMediaAssociation()
    {
        return isset($this->ArrayOfMediaAssociation) ? $this->ArrayOfMediaAssociation : null;
    }
    /**
     * This method is responsible for validating the values passed to the setArrayOfMediaAssociation method
     * This method is willingly generated in order to preserve the one-line inline validation within the setArrayOfMediaAssociation method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateArrayOfMediaAssociationForArrayConstraintsFromSetArrayOfMediaAssociation(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfArrayOfMediaAssociationArrayOfMediaAssociationItem) {
            // validation for constraint: itemType
            if (!$arrayOfArrayOfMediaAssociationArrayOfMediaAssociationItem instanceof \ArrayType\ArrayOfMediaAssociation) {
                $invalidValues[] = is_object($arrayOfArrayOfMediaAssociationArrayOfMediaAssociationItem) ? get_class($arrayOfArrayOfMediaAssociationArrayOfMediaAssociationItem) : sprintf('%s(%s)', gettype($arrayOfArrayOfMediaAssociationArrayOfMediaAssociationItem), var_export($arrayOfArrayOfMediaAssociationArrayOfMediaAssociationItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ArrayOfMediaAssociation property can only contain items of type \ArrayType\ArrayOfMediaAssociation, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ArrayOfMediaAssociation value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \ArrayType\ArrayOfMediaAssociation[] $arrayOfMediaAssociation
     * @return \ArrayType\ArrayOfArrayOfMediaAssociation
     */
    public function setArrayOfMediaAssociation(array $arrayOfMediaAssociation = array())
    {
        // validation for constraint: array
        if ('' !== ($arrayOfMediaAssociationArrayErrorMessage = self::validateArrayOfMediaAssociationForArrayConstraintsFromSetArrayOfMediaAssociation($arrayOfMediaAssociation))) {
            throw new \InvalidArgumentException($arrayOfMediaAssociationArrayErrorMessage, __LINE__);
        }
        if (is_null($arrayOfMediaAssociation) || (is_array($arrayOfMediaAssociation) && empty($arrayOfMediaAssociation))) {
            unset($this->ArrayOfMediaAssociation);
        } else {
            $this->ArrayOfMediaAssociation = $arrayOfMediaAssociation;
        }
        return $this;
    }
    /**
     * Add item to ArrayOfMediaAssociation value
     * @throws \InvalidArgumentException
     * @param \ArrayType\ArrayOfMediaAssociation $item
     * @return \ArrayType\ArrayOfArrayOfMediaAssociation
     */
    public function addToArrayOfMediaAssociation(\ArrayType\ArrayOfMediaAssociation $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \ArrayType\ArrayOfMediaAssociation) {
            throw new \InvalidArgumentException(sprintf('The ArrayOfMediaAssociation property can only contain items of type \ArrayType\ArrayOfMediaAssociation, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ArrayOfMediaAssociation[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \ArrayType\ArrayOfMediaAssociation|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \ArrayType\ArrayOfMediaAssociation|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \ArrayType\ArrayOfMediaAssociation|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \ArrayType\ArrayOfMediaAssociation|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \ArrayType\ArrayOfMediaAssociation|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ArrayOfMediaAssociation
     */
    public function getAttributeName()
    {
        return 'ArrayOfMediaAssociation';
    }
}
