<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAssetLink ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfAssetLink
 * @subpackage Arrays
 */
class ArrayOfAssetLink extends AbstractStructArrayBase
{
    /**
     * The AssetLink
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\AssetLink[]
     */
    public $AssetLink;
    /**
     * Constructor method for ArrayOfAssetLink
     * @uses ArrayOfAssetLink::setAssetLink()
     * @param \StructType\AssetLink[] $assetLink
     */
    public function __construct(array $assetLink = array())
    {
        $this
            ->setAssetLink($assetLink);
    }
    /**
     * Get AssetLink value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\AssetLink[]|null
     */
    public function getAssetLink()
    {
        return isset($this->AssetLink) ? $this->AssetLink : null;
    }
    /**
     * This method is responsible for validating the values passed to the setAssetLink method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAssetLink method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAssetLinkForArrayConstraintsFromSetAssetLink(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfAssetLinkAssetLinkItem) {
            // validation for constraint: itemType
            if (!$arrayOfAssetLinkAssetLinkItem instanceof \StructType\AssetLink) {
                $invalidValues[] = is_object($arrayOfAssetLinkAssetLinkItem) ? get_class($arrayOfAssetLinkAssetLinkItem) : sprintf('%s(%s)', gettype($arrayOfAssetLinkAssetLinkItem), var_export($arrayOfAssetLinkAssetLinkItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The AssetLink property can only contain items of type \StructType\AssetLink, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AssetLink value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\AssetLink[] $assetLink
     * @return \ArrayType\ArrayOfAssetLink
     */
    public function setAssetLink(array $assetLink = array())
    {
        // validation for constraint: array
        if ('' !== ($assetLinkArrayErrorMessage = self::validateAssetLinkForArrayConstraintsFromSetAssetLink($assetLink))) {
            throw new \InvalidArgumentException($assetLinkArrayErrorMessage, __LINE__);
        }
        if (is_null($assetLink) || (is_array($assetLink) && empty($assetLink))) {
            unset($this->AssetLink);
        } else {
            $this->AssetLink = $assetLink;
        }
        return $this;
    }
    /**
     * Add item to AssetLink value
     * @throws \InvalidArgumentException
     * @param \StructType\AssetLink $item
     * @return \ArrayType\ArrayOfAssetLink
     */
    public function addToAssetLink(\StructType\AssetLink $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AssetLink) {
            throw new \InvalidArgumentException(sprintf('The AssetLink property can only contain items of type \StructType\AssetLink, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->AssetLink[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\AssetLink|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\AssetLink|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\AssetLink|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\AssetLink|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\AssetLink|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AssetLink
     */
    public function getAttributeName()
    {
        return 'AssetLink';
    }
}
