<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfBatchErrorCollection ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfBatchErrorCollection
 * @subpackage Arrays
 */
class ArrayOfBatchErrorCollection extends AbstractStructArrayBase
{
    /**
     * The BatchErrorCollection
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\BatchErrorCollection[]
     */
    public $BatchErrorCollection;
    /**
     * Constructor method for ArrayOfBatchErrorCollection
     * @uses ArrayOfBatchErrorCollection::setBatchErrorCollection()
     * @param \StructType\BatchErrorCollection[] $batchErrorCollection
     */
    public function __construct(array $batchErrorCollection = array())
    {
        $this
            ->setBatchErrorCollection($batchErrorCollection);
    }
    /**
     * Get BatchErrorCollection value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\BatchErrorCollection[]|null
     */
    public function getBatchErrorCollection()
    {
        return isset($this->BatchErrorCollection) ? $this->BatchErrorCollection : null;
    }
    /**
     * This method is responsible for validating the values passed to the setBatchErrorCollection method
     * This method is willingly generated in order to preserve the one-line inline validation within the setBatchErrorCollection method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateBatchErrorCollectionForArrayConstraintsFromSetBatchErrorCollection(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfBatchErrorCollectionBatchErrorCollectionItem) {
            // validation for constraint: itemType
            if (!$arrayOfBatchErrorCollectionBatchErrorCollectionItem instanceof \StructType\BatchErrorCollection) {
                $invalidValues[] = is_object($arrayOfBatchErrorCollectionBatchErrorCollectionItem) ? get_class($arrayOfBatchErrorCollectionBatchErrorCollectionItem) : sprintf('%s(%s)', gettype($arrayOfBatchErrorCollectionBatchErrorCollectionItem), var_export($arrayOfBatchErrorCollectionBatchErrorCollectionItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The BatchErrorCollection property can only contain items of type \StructType\BatchErrorCollection, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set BatchErrorCollection value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\BatchErrorCollection[] $batchErrorCollection
     * @return \ArrayType\ArrayOfBatchErrorCollection
     */
    public function setBatchErrorCollection(array $batchErrorCollection = array())
    {
        // validation for constraint: array
        if ('' !== ($batchErrorCollectionArrayErrorMessage = self::validateBatchErrorCollectionForArrayConstraintsFromSetBatchErrorCollection($batchErrorCollection))) {
            throw new \InvalidArgumentException($batchErrorCollectionArrayErrorMessage, __LINE__);
        }
        if (is_null($batchErrorCollection) || (is_array($batchErrorCollection) && empty($batchErrorCollection))) {
            unset($this->BatchErrorCollection);
        } else {
            $this->BatchErrorCollection = $batchErrorCollection;
        }
        return $this;
    }
    /**
     * Add item to BatchErrorCollection value
     * @throws \InvalidArgumentException
     * @param \StructType\BatchErrorCollection $item
     * @return \ArrayType\ArrayOfBatchErrorCollection
     */
    public function addToBatchErrorCollection(\StructType\BatchErrorCollection $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\BatchErrorCollection) {
            throw new \InvalidArgumentException(sprintf('The BatchErrorCollection property can only contain items of type \StructType\BatchErrorCollection, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->BatchErrorCollection[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\BatchErrorCollection|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\BatchErrorCollection|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\BatchErrorCollection|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\BatchErrorCollection|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\BatchErrorCollection|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string BatchErrorCollection
     */
    public function getAttributeName()
    {
        return 'BatchErrorCollection';
    }
}
