<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfBidStrategy ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfBidStrategy
 * @subpackage Arrays
 */
class ArrayOfBidStrategy extends AbstractStructArrayBase
{
    /**
     * The BidStrategy
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\BidStrategy[]
     */
    public $BidStrategy;
    /**
     * Constructor method for ArrayOfBidStrategy
     * @uses ArrayOfBidStrategy::setBidStrategy()
     * @param \StructType\BidStrategy[] $bidStrategy
     */
    public function __construct(array $bidStrategy = array())
    {
        $this
            ->setBidStrategy($bidStrategy);
    }
    /**
     * Get BidStrategy value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\BidStrategy[]|null
     */
    public function getBidStrategy()
    {
        return isset($this->BidStrategy) ? $this->BidStrategy : null;
    }
    /**
     * This method is responsible for validating the values passed to the setBidStrategy method
     * This method is willingly generated in order to preserve the one-line inline validation within the setBidStrategy method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateBidStrategyForArrayConstraintsFromSetBidStrategy(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfBidStrategyBidStrategyItem) {
            // validation for constraint: itemType
            if (!$arrayOfBidStrategyBidStrategyItem instanceof \StructType\BidStrategy) {
                $invalidValues[] = is_object($arrayOfBidStrategyBidStrategyItem) ? get_class($arrayOfBidStrategyBidStrategyItem) : sprintf('%s(%s)', gettype($arrayOfBidStrategyBidStrategyItem), var_export($arrayOfBidStrategyBidStrategyItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The BidStrategy property can only contain items of type \StructType\BidStrategy, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set BidStrategy value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\BidStrategy[] $bidStrategy
     * @return \ArrayType\ArrayOfBidStrategy
     */
    public function setBidStrategy(array $bidStrategy = array())
    {
        // validation for constraint: array
        if ('' !== ($bidStrategyArrayErrorMessage = self::validateBidStrategyForArrayConstraintsFromSetBidStrategy($bidStrategy))) {
            throw new \InvalidArgumentException($bidStrategyArrayErrorMessage, __LINE__);
        }
        if (is_null($bidStrategy) || (is_array($bidStrategy) && empty($bidStrategy))) {
            unset($this->BidStrategy);
        } else {
            $this->BidStrategy = $bidStrategy;
        }
        return $this;
    }
    /**
     * Add item to BidStrategy value
     * @throws \InvalidArgumentException
     * @param \StructType\BidStrategy $item
     * @return \ArrayType\ArrayOfBidStrategy
     */
    public function addToBidStrategy(\StructType\BidStrategy $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\BidStrategy) {
            throw new \InvalidArgumentException(sprintf('The BidStrategy property can only contain items of type \StructType\BidStrategy, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->BidStrategy[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\BidStrategy|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\BidStrategy|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\BidStrategy|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\BidStrategy|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\BidStrategy|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string BidStrategy
     */
    public function getAttributeName()
    {
        return 'BidStrategy';
    }
}
