<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfCampaignAdGroupIds ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfCampaignAdGroupIds
 * @subpackage Arrays
 */
class ArrayOfCampaignAdGroupIds extends AbstractStructArrayBase
{
    /**
     * The CampaignAdGroupIds
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\CampaignAdGroupIds[]
     */
    public $CampaignAdGroupIds;
    /**
     * Constructor method for ArrayOfCampaignAdGroupIds
     * @uses ArrayOfCampaignAdGroupIds::setCampaignAdGroupIds()
     * @param \StructType\CampaignAdGroupIds[] $campaignAdGroupIds
     */
    public function __construct(array $campaignAdGroupIds = array())
    {
        $this
            ->setCampaignAdGroupIds($campaignAdGroupIds);
    }
    /**
     * Get CampaignAdGroupIds value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\CampaignAdGroupIds[]|null
     */
    public function getCampaignAdGroupIds()
    {
        return isset($this->CampaignAdGroupIds) ? $this->CampaignAdGroupIds : null;
    }
    /**
     * This method is responsible for validating the values passed to the setCampaignAdGroupIds method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCampaignAdGroupIds method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCampaignAdGroupIdsForArrayConstraintsFromSetCampaignAdGroupIds(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfCampaignAdGroupIdsCampaignAdGroupIdsItem) {
            // validation for constraint: itemType
            if (!$arrayOfCampaignAdGroupIdsCampaignAdGroupIdsItem instanceof \StructType\CampaignAdGroupIds) {
                $invalidValues[] = is_object($arrayOfCampaignAdGroupIdsCampaignAdGroupIdsItem) ? get_class($arrayOfCampaignAdGroupIdsCampaignAdGroupIdsItem) : sprintf('%s(%s)', gettype($arrayOfCampaignAdGroupIdsCampaignAdGroupIdsItem), var_export($arrayOfCampaignAdGroupIdsCampaignAdGroupIdsItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The CampaignAdGroupIds property can only contain items of type \StructType\CampaignAdGroupIds, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CampaignAdGroupIds value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\CampaignAdGroupIds[] $campaignAdGroupIds
     * @return \ArrayType\ArrayOfCampaignAdGroupIds
     */
    public function setCampaignAdGroupIds(array $campaignAdGroupIds = array())
    {
        // validation for constraint: array
        if ('' !== ($campaignAdGroupIdsArrayErrorMessage = self::validateCampaignAdGroupIdsForArrayConstraintsFromSetCampaignAdGroupIds($campaignAdGroupIds))) {
            throw new \InvalidArgumentException($campaignAdGroupIdsArrayErrorMessage, __LINE__);
        }
        if (is_null($campaignAdGroupIds) || (is_array($campaignAdGroupIds) && empty($campaignAdGroupIds))) {
            unset($this->CampaignAdGroupIds);
        } else {
            $this->CampaignAdGroupIds = $campaignAdGroupIds;
        }
        return $this;
    }
    /**
     * Add item to CampaignAdGroupIds value
     * @throws \InvalidArgumentException
     * @param \StructType\CampaignAdGroupIds $item
     * @return \ArrayType\ArrayOfCampaignAdGroupIds
     */
    public function addToCampaignAdGroupIds(\StructType\CampaignAdGroupIds $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CampaignAdGroupIds) {
            throw new \InvalidArgumentException(sprintf('The CampaignAdGroupIds property can only contain items of type \StructType\CampaignAdGroupIds, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->CampaignAdGroupIds[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\CampaignAdGroupIds|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\CampaignAdGroupIds|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\CampaignAdGroupIds|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\CampaignAdGroupIds|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\CampaignAdGroupIds|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CampaignAdGroupIds
     */
    public function getAttributeName()
    {
        return 'CampaignAdGroupIds';
    }
}
