<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfCampaignCriterion ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfCampaignCriterion
 * @subpackage Arrays
 */
class ArrayOfCampaignCriterion extends AbstractStructArrayBase
{
    /**
     * The CampaignCriterion
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\CampaignCriterion[]
     */
    public $CampaignCriterion;
    /**
     * Constructor method for ArrayOfCampaignCriterion
     * @uses ArrayOfCampaignCriterion::setCampaignCriterion()
     * @param \StructType\CampaignCriterion[] $campaignCriterion
     */
    public function __construct(array $campaignCriterion = array())
    {
        $this
            ->setCampaignCriterion($campaignCriterion);
    }
    /**
     * Get CampaignCriterion value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\CampaignCriterion[]|null
     */
    public function getCampaignCriterion()
    {
        return isset($this->CampaignCriterion) ? $this->CampaignCriterion : null;
    }
    /**
     * This method is responsible for validating the values passed to the setCampaignCriterion method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCampaignCriterion method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCampaignCriterionForArrayConstraintsFromSetCampaignCriterion(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfCampaignCriterionCampaignCriterionItem) {
            // validation for constraint: itemType
            if (!$arrayOfCampaignCriterionCampaignCriterionItem instanceof \StructType\CampaignCriterion) {
                $invalidValues[] = is_object($arrayOfCampaignCriterionCampaignCriterionItem) ? get_class($arrayOfCampaignCriterionCampaignCriterionItem) : sprintf('%s(%s)', gettype($arrayOfCampaignCriterionCampaignCriterionItem), var_export($arrayOfCampaignCriterionCampaignCriterionItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The CampaignCriterion property can only contain items of type \StructType\CampaignCriterion, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CampaignCriterion value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\CampaignCriterion[] $campaignCriterion
     * @return \ArrayType\ArrayOfCampaignCriterion
     */
    public function setCampaignCriterion(array $campaignCriterion = array())
    {
        // validation for constraint: array
        if ('' !== ($campaignCriterionArrayErrorMessage = self::validateCampaignCriterionForArrayConstraintsFromSetCampaignCriterion($campaignCriterion))) {
            throw new \InvalidArgumentException($campaignCriterionArrayErrorMessage, __LINE__);
        }
        if (is_null($campaignCriterion) || (is_array($campaignCriterion) && empty($campaignCriterion))) {
            unset($this->CampaignCriterion);
        } else {
            $this->CampaignCriterion = $campaignCriterion;
        }
        return $this;
    }
    /**
     * Add item to CampaignCriterion value
     * @throws \InvalidArgumentException
     * @param \StructType\CampaignCriterion $item
     * @return \ArrayType\ArrayOfCampaignCriterion
     */
    public function addToCampaignCriterion(\StructType\CampaignCriterion $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CampaignCriterion) {
            throw new \InvalidArgumentException(sprintf('The CampaignCriterion property can only contain items of type \StructType\CampaignCriterion, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->CampaignCriterion[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\CampaignCriterion|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\CampaignCriterion|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\CampaignCriterion|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\CampaignCriterion|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\CampaignCriterion|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CampaignCriterion
     */
    public function getAttributeName()
    {
        return 'CampaignCriterion';
    }
}
