<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfCampaignNegativeSites ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfCampaignNegativeSites
 * @subpackage Arrays
 */
class ArrayOfCampaignNegativeSites extends AbstractStructArrayBase
{
    /**
     * The CampaignNegativeSites
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\CampaignNegativeSites[]
     */
    public $CampaignNegativeSites;
    /**
     * Constructor method for ArrayOfCampaignNegativeSites
     * @uses ArrayOfCampaignNegativeSites::setCampaignNegativeSites()
     * @param \StructType\CampaignNegativeSites[] $campaignNegativeSites
     */
    public function __construct(array $campaignNegativeSites = array())
    {
        $this
            ->setCampaignNegativeSites($campaignNegativeSites);
    }
    /**
     * Get CampaignNegativeSites value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\CampaignNegativeSites[]|null
     */
    public function getCampaignNegativeSites()
    {
        return isset($this->CampaignNegativeSites) ? $this->CampaignNegativeSites : null;
    }
    /**
     * This method is responsible for validating the values passed to the setCampaignNegativeSites method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCampaignNegativeSites method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCampaignNegativeSitesForArrayConstraintsFromSetCampaignNegativeSites(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfCampaignNegativeSitesCampaignNegativeSitesItem) {
            // validation for constraint: itemType
            if (!$arrayOfCampaignNegativeSitesCampaignNegativeSitesItem instanceof \StructType\CampaignNegativeSites) {
                $invalidValues[] = is_object($arrayOfCampaignNegativeSitesCampaignNegativeSitesItem) ? get_class($arrayOfCampaignNegativeSitesCampaignNegativeSitesItem) : sprintf('%s(%s)', gettype($arrayOfCampaignNegativeSitesCampaignNegativeSitesItem), var_export($arrayOfCampaignNegativeSitesCampaignNegativeSitesItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The CampaignNegativeSites property can only contain items of type \StructType\CampaignNegativeSites, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CampaignNegativeSites value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\CampaignNegativeSites[] $campaignNegativeSites
     * @return \ArrayType\ArrayOfCampaignNegativeSites
     */
    public function setCampaignNegativeSites(array $campaignNegativeSites = array())
    {
        // validation for constraint: array
        if ('' !== ($campaignNegativeSitesArrayErrorMessage = self::validateCampaignNegativeSitesForArrayConstraintsFromSetCampaignNegativeSites($campaignNegativeSites))) {
            throw new \InvalidArgumentException($campaignNegativeSitesArrayErrorMessage, __LINE__);
        }
        if (is_null($campaignNegativeSites) || (is_array($campaignNegativeSites) && empty($campaignNegativeSites))) {
            unset($this->CampaignNegativeSites);
        } else {
            $this->CampaignNegativeSites = $campaignNegativeSites;
        }
        return $this;
    }
    /**
     * Add item to CampaignNegativeSites value
     * @throws \InvalidArgumentException
     * @param \StructType\CampaignNegativeSites $item
     * @return \ArrayType\ArrayOfCampaignNegativeSites
     */
    public function addToCampaignNegativeSites(\StructType\CampaignNegativeSites $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CampaignNegativeSites) {
            throw new \InvalidArgumentException(sprintf('The CampaignNegativeSites property can only contain items of type \StructType\CampaignNegativeSites, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->CampaignNegativeSites[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\CampaignNegativeSites|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\CampaignNegativeSites|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\CampaignNegativeSites|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\CampaignNegativeSites|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\CampaignNegativeSites|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CampaignNegativeSites
     */
    public function getAttributeName()
    {
        return 'CampaignNegativeSites';
    }
}
