<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfCampaignSize ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfCampaignSize
 * @subpackage Arrays
 */
class ArrayOfCampaignSize extends AbstractStructArrayBase
{
    /**
     * The CampaignSize
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\CampaignSize[]
     */
    public $CampaignSize;
    /**
     * Constructor method for ArrayOfCampaignSize
     * @uses ArrayOfCampaignSize::setCampaignSize()
     * @param \StructType\CampaignSize[] $campaignSize
     */
    public function __construct(array $campaignSize = array())
    {
        $this
            ->setCampaignSize($campaignSize);
    }
    /**
     * Get CampaignSize value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\CampaignSize[]|null
     */
    public function getCampaignSize()
    {
        return isset($this->CampaignSize) ? $this->CampaignSize : null;
    }
    /**
     * This method is responsible for validating the values passed to the setCampaignSize method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCampaignSize method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCampaignSizeForArrayConstraintsFromSetCampaignSize(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfCampaignSizeCampaignSizeItem) {
            // validation for constraint: itemType
            if (!$arrayOfCampaignSizeCampaignSizeItem instanceof \StructType\CampaignSize) {
                $invalidValues[] = is_object($arrayOfCampaignSizeCampaignSizeItem) ? get_class($arrayOfCampaignSizeCampaignSizeItem) : sprintf('%s(%s)', gettype($arrayOfCampaignSizeCampaignSizeItem), var_export($arrayOfCampaignSizeCampaignSizeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The CampaignSize property can only contain items of type \StructType\CampaignSize, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CampaignSize value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\CampaignSize[] $campaignSize
     * @return \ArrayType\ArrayOfCampaignSize
     */
    public function setCampaignSize(array $campaignSize = array())
    {
        // validation for constraint: array
        if ('' !== ($campaignSizeArrayErrorMessage = self::validateCampaignSizeForArrayConstraintsFromSetCampaignSize($campaignSize))) {
            throw new \InvalidArgumentException($campaignSizeArrayErrorMessage, __LINE__);
        }
        if (is_null($campaignSize) || (is_array($campaignSize) && empty($campaignSize))) {
            unset($this->CampaignSize);
        } else {
            $this->CampaignSize = $campaignSize;
        }
        return $this;
    }
    /**
     * Add item to CampaignSize value
     * @throws \InvalidArgumentException
     * @param \StructType\CampaignSize $item
     * @return \ArrayType\ArrayOfCampaignSize
     */
    public function addToCampaignSize(\StructType\CampaignSize $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CampaignSize) {
            throw new \InvalidArgumentException(sprintf('The CampaignSize property can only contain items of type \StructType\CampaignSize, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->CampaignSize[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\CampaignSize|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\CampaignSize|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\CampaignSize|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\CampaignSize|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\CampaignSize|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CampaignSize
     */
    public function getAttributeName()
    {
        return 'CampaignSize';
    }
}
