<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfCombinationRule ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfCombinationRule
 * @subpackage Arrays
 */
class ArrayOfCombinationRule extends AbstractStructArrayBase
{
    /**
     * The CombinationRule
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\CombinationRule[]
     */
    public $CombinationRule;
    /**
     * Constructor method for ArrayOfCombinationRule
     * @uses ArrayOfCombinationRule::setCombinationRule()
     * @param \StructType\CombinationRule[] $combinationRule
     */
    public function __construct(array $combinationRule = array())
    {
        $this
            ->setCombinationRule($combinationRule);
    }
    /**
     * Get CombinationRule value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\CombinationRule[]|null
     */
    public function getCombinationRule()
    {
        return isset($this->CombinationRule) ? $this->CombinationRule : null;
    }
    /**
     * This method is responsible for validating the values passed to the setCombinationRule method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCombinationRule method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCombinationRuleForArrayConstraintsFromSetCombinationRule(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfCombinationRuleCombinationRuleItem) {
            // validation for constraint: itemType
            if (!$arrayOfCombinationRuleCombinationRuleItem instanceof \StructType\CombinationRule) {
                $invalidValues[] = is_object($arrayOfCombinationRuleCombinationRuleItem) ? get_class($arrayOfCombinationRuleCombinationRuleItem) : sprintf('%s(%s)', gettype($arrayOfCombinationRuleCombinationRuleItem), var_export($arrayOfCombinationRuleCombinationRuleItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The CombinationRule property can only contain items of type \StructType\CombinationRule, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CombinationRule value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\CombinationRule[] $combinationRule
     * @return \ArrayType\ArrayOfCombinationRule
     */
    public function setCombinationRule(array $combinationRule = array())
    {
        // validation for constraint: array
        if ('' !== ($combinationRuleArrayErrorMessage = self::validateCombinationRuleForArrayConstraintsFromSetCombinationRule($combinationRule))) {
            throw new \InvalidArgumentException($combinationRuleArrayErrorMessage, __LINE__);
        }
        if (is_null($combinationRule) || (is_array($combinationRule) && empty($combinationRule))) {
            unset($this->CombinationRule);
        } else {
            $this->CombinationRule = $combinationRule;
        }
        return $this;
    }
    /**
     * Add item to CombinationRule value
     * @throws \InvalidArgumentException
     * @param \StructType\CombinationRule $item
     * @return \ArrayType\ArrayOfCombinationRule
     */
    public function addToCombinationRule(\StructType\CombinationRule $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CombinationRule) {
            throw new \InvalidArgumentException(sprintf('The CombinationRule property can only contain items of type \StructType\CombinationRule, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->CombinationRule[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\CombinationRule|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\CombinationRule|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\CombinationRule|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\CombinationRule|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\CombinationRule|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CombinationRule
     */
    public function getAttributeName()
    {
        return 'CombinationRule';
    }
}
