<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfConversionGoal ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfConversionGoal
 * @subpackage Arrays
 */
class ArrayOfConversionGoal extends AbstractStructArrayBase
{
    /**
     * The ConversionGoal
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ConversionGoal[]
     */
    public $ConversionGoal;
    /**
     * Constructor method for ArrayOfConversionGoal
     * @uses ArrayOfConversionGoal::setConversionGoal()
     * @param \StructType\ConversionGoal[] $conversionGoal
     */
    public function __construct(array $conversionGoal = array())
    {
        $this
            ->setConversionGoal($conversionGoal);
    }
    /**
     * Get ConversionGoal value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ConversionGoal[]|null
     */
    public function getConversionGoal()
    {
        return isset($this->ConversionGoal) ? $this->ConversionGoal : null;
    }
    /**
     * This method is responsible for validating the values passed to the setConversionGoal method
     * This method is willingly generated in order to preserve the one-line inline validation within the setConversionGoal method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateConversionGoalForArrayConstraintsFromSetConversionGoal(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfConversionGoalConversionGoalItem) {
            // validation for constraint: itemType
            if (!$arrayOfConversionGoalConversionGoalItem instanceof \StructType\ConversionGoal) {
                $invalidValues[] = is_object($arrayOfConversionGoalConversionGoalItem) ? get_class($arrayOfConversionGoalConversionGoalItem) : sprintf('%s(%s)', gettype($arrayOfConversionGoalConversionGoalItem), var_export($arrayOfConversionGoalConversionGoalItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ConversionGoal property can only contain items of type \StructType\ConversionGoal, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ConversionGoal value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ConversionGoal[] $conversionGoal
     * @return \ArrayType\ArrayOfConversionGoal
     */
    public function setConversionGoal(array $conversionGoal = array())
    {
        // validation for constraint: array
        if ('' !== ($conversionGoalArrayErrorMessage = self::validateConversionGoalForArrayConstraintsFromSetConversionGoal($conversionGoal))) {
            throw new \InvalidArgumentException($conversionGoalArrayErrorMessage, __LINE__);
        }
        if (is_null($conversionGoal) || (is_array($conversionGoal) && empty($conversionGoal))) {
            unset($this->ConversionGoal);
        } else {
            $this->ConversionGoal = $conversionGoal;
        }
        return $this;
    }
    /**
     * Add item to ConversionGoal value
     * @throws \InvalidArgumentException
     * @param \StructType\ConversionGoal $item
     * @return \ArrayType\ArrayOfConversionGoal
     */
    public function addToConversionGoal(\StructType\ConversionGoal $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ConversionGoal) {
            throw new \InvalidArgumentException(sprintf('The ConversionGoal property can only contain items of type \StructType\ConversionGoal, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ConversionGoal[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ConversionGoal|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ConversionGoal|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ConversionGoal|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ConversionGoal|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ConversionGoal|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ConversionGoal
     */
    public function getAttributeName()
    {
        return 'ConversionGoal';
    }
}
