<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfCustomerAccountShare ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfCustomerAccountShare
 * @subpackage Arrays
 */
class ArrayOfCustomerAccountShare extends AbstractStructArrayBase
{
    /**
     * The CustomerAccountShare
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\CustomerAccountShare[]
     */
    public $CustomerAccountShare;
    /**
     * Constructor method for ArrayOfCustomerAccountShare
     * @uses ArrayOfCustomerAccountShare::setCustomerAccountShare()
     * @param \StructType\CustomerAccountShare[] $customerAccountShare
     */
    public function __construct(array $customerAccountShare = array())
    {
        $this
            ->setCustomerAccountShare($customerAccountShare);
    }
    /**
     * Get CustomerAccountShare value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\CustomerAccountShare[]|null
     */
    public function getCustomerAccountShare()
    {
        return isset($this->CustomerAccountShare) ? $this->CustomerAccountShare : null;
    }
    /**
     * This method is responsible for validating the values passed to the setCustomerAccountShare method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCustomerAccountShare method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCustomerAccountShareForArrayConstraintsFromSetCustomerAccountShare(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfCustomerAccountShareCustomerAccountShareItem) {
            // validation for constraint: itemType
            if (!$arrayOfCustomerAccountShareCustomerAccountShareItem instanceof \StructType\CustomerAccountShare) {
                $invalidValues[] = is_object($arrayOfCustomerAccountShareCustomerAccountShareItem) ? get_class($arrayOfCustomerAccountShareCustomerAccountShareItem) : sprintf('%s(%s)', gettype($arrayOfCustomerAccountShareCustomerAccountShareItem), var_export($arrayOfCustomerAccountShareCustomerAccountShareItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The CustomerAccountShare property can only contain items of type \StructType\CustomerAccountShare, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CustomerAccountShare value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\CustomerAccountShare[] $customerAccountShare
     * @return \ArrayType\ArrayOfCustomerAccountShare
     */
    public function setCustomerAccountShare(array $customerAccountShare = array())
    {
        // validation for constraint: array
        if ('' !== ($customerAccountShareArrayErrorMessage = self::validateCustomerAccountShareForArrayConstraintsFromSetCustomerAccountShare($customerAccountShare))) {
            throw new \InvalidArgumentException($customerAccountShareArrayErrorMessage, __LINE__);
        }
        if (is_null($customerAccountShare) || (is_array($customerAccountShare) && empty($customerAccountShare))) {
            unset($this->CustomerAccountShare);
        } else {
            $this->CustomerAccountShare = $customerAccountShare;
        }
        return $this;
    }
    /**
     * Add item to CustomerAccountShare value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomerAccountShare $item
     * @return \ArrayType\ArrayOfCustomerAccountShare
     */
    public function addToCustomerAccountShare(\StructType\CustomerAccountShare $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CustomerAccountShare) {
            throw new \InvalidArgumentException(sprintf('The CustomerAccountShare property can only contain items of type \StructType\CustomerAccountShare, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->CustomerAccountShare[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\CustomerAccountShare|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\CustomerAccountShare|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\CustomerAccountShare|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\CustomerAccountShare|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\CustomerAccountShare|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CustomerAccountShare
     */
    public function getAttributeName()
    {
        return 'CustomerAccountShare';
    }
}
