<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfCustomerAccountShareAssociation ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfCustomerAccountShareAssociation
 * @subpackage Arrays
 */
class ArrayOfCustomerAccountShareAssociation extends AbstractStructArrayBase
{
    /**
     * The CustomerAccountShareAssociation
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\CustomerAccountShareAssociation[]
     */
    public $CustomerAccountShareAssociation;
    /**
     * Constructor method for ArrayOfCustomerAccountShareAssociation
     * @uses ArrayOfCustomerAccountShareAssociation::setCustomerAccountShareAssociation()
     * @param \StructType\CustomerAccountShareAssociation[] $customerAccountShareAssociation
     */
    public function __construct(array $customerAccountShareAssociation = array())
    {
        $this
            ->setCustomerAccountShareAssociation($customerAccountShareAssociation);
    }
    /**
     * Get CustomerAccountShareAssociation value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\CustomerAccountShareAssociation[]|null
     */
    public function getCustomerAccountShareAssociation()
    {
        return isset($this->CustomerAccountShareAssociation) ? $this->CustomerAccountShareAssociation : null;
    }
    /**
     * This method is responsible for validating the values passed to the setCustomerAccountShareAssociation method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCustomerAccountShareAssociation method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCustomerAccountShareAssociationForArrayConstraintsFromSetCustomerAccountShareAssociation(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfCustomerAccountShareAssociationCustomerAccountShareAssociationItem) {
            // validation for constraint: itemType
            if (!$arrayOfCustomerAccountShareAssociationCustomerAccountShareAssociationItem instanceof \StructType\CustomerAccountShareAssociation) {
                $invalidValues[] = is_object($arrayOfCustomerAccountShareAssociationCustomerAccountShareAssociationItem) ? get_class($arrayOfCustomerAccountShareAssociationCustomerAccountShareAssociationItem) : sprintf('%s(%s)', gettype($arrayOfCustomerAccountShareAssociationCustomerAccountShareAssociationItem), var_export($arrayOfCustomerAccountShareAssociationCustomerAccountShareAssociationItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The CustomerAccountShareAssociation property can only contain items of type \StructType\CustomerAccountShareAssociation, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CustomerAccountShareAssociation value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\CustomerAccountShareAssociation[] $customerAccountShareAssociation
     * @return \ArrayType\ArrayOfCustomerAccountShareAssociation
     */
    public function setCustomerAccountShareAssociation(array $customerAccountShareAssociation = array())
    {
        // validation for constraint: array
        if ('' !== ($customerAccountShareAssociationArrayErrorMessage = self::validateCustomerAccountShareAssociationForArrayConstraintsFromSetCustomerAccountShareAssociation($customerAccountShareAssociation))) {
            throw new \InvalidArgumentException($customerAccountShareAssociationArrayErrorMessage, __LINE__);
        }
        if (is_null($customerAccountShareAssociation) || (is_array($customerAccountShareAssociation) && empty($customerAccountShareAssociation))) {
            unset($this->CustomerAccountShareAssociation);
        } else {
            $this->CustomerAccountShareAssociation = $customerAccountShareAssociation;
        }
        return $this;
    }
    /**
     * Add item to CustomerAccountShareAssociation value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomerAccountShareAssociation $item
     * @return \ArrayType\ArrayOfCustomerAccountShareAssociation
     */
    public function addToCustomerAccountShareAssociation(\StructType\CustomerAccountShareAssociation $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CustomerAccountShareAssociation) {
            throw new \InvalidArgumentException(sprintf('The CustomerAccountShareAssociation property can only contain items of type \StructType\CustomerAccountShareAssociation, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->CustomerAccountShareAssociation[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\CustomerAccountShareAssociation|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\CustomerAccountShareAssociation|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\CustomerAccountShareAssociation|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\CustomerAccountShareAssociation|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\CustomerAccountShareAssociation|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CustomerAccountShareAssociation
     */
    public function getAttributeName()
    {
        return 'CustomerAccountShareAssociation';
    }
}
