<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfEditorialReason ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfEditorialReason
 * @subpackage Arrays
 */
class ArrayOfEditorialReason extends AbstractStructArrayBase
{
    /**
     * The EditorialReason
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\EditorialReason[]
     */
    public $EditorialReason;
    /**
     * Constructor method for ArrayOfEditorialReason
     * @uses ArrayOfEditorialReason::setEditorialReason()
     * @param \StructType\EditorialReason[] $editorialReason
     */
    public function __construct(array $editorialReason = array())
    {
        $this
            ->setEditorialReason($editorialReason);
    }
    /**
     * Get EditorialReason value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\EditorialReason[]|null
     */
    public function getEditorialReason()
    {
        return isset($this->EditorialReason) ? $this->EditorialReason : null;
    }
    /**
     * This method is responsible for validating the values passed to the setEditorialReason method
     * This method is willingly generated in order to preserve the one-line inline validation within the setEditorialReason method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateEditorialReasonForArrayConstraintsFromSetEditorialReason(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfEditorialReasonEditorialReasonItem) {
            // validation for constraint: itemType
            if (!$arrayOfEditorialReasonEditorialReasonItem instanceof \StructType\EditorialReason) {
                $invalidValues[] = is_object($arrayOfEditorialReasonEditorialReasonItem) ? get_class($arrayOfEditorialReasonEditorialReasonItem) : sprintf('%s(%s)', gettype($arrayOfEditorialReasonEditorialReasonItem), var_export($arrayOfEditorialReasonEditorialReasonItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The EditorialReason property can only contain items of type \StructType\EditorialReason, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set EditorialReason value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\EditorialReason[] $editorialReason
     * @return \ArrayType\ArrayOfEditorialReason
     */
    public function setEditorialReason(array $editorialReason = array())
    {
        // validation for constraint: array
        if ('' !== ($editorialReasonArrayErrorMessage = self::validateEditorialReasonForArrayConstraintsFromSetEditorialReason($editorialReason))) {
            throw new \InvalidArgumentException($editorialReasonArrayErrorMessage, __LINE__);
        }
        if (is_null($editorialReason) || (is_array($editorialReason) && empty($editorialReason))) {
            unset($this->EditorialReason);
        } else {
            $this->EditorialReason = $editorialReason;
        }
        return $this;
    }
    /**
     * Add item to EditorialReason value
     * @throws \InvalidArgumentException
     * @param \StructType\EditorialReason $item
     * @return \ArrayType\ArrayOfEditorialReason
     */
    public function addToEditorialReason(\StructType\EditorialReason $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\EditorialReason) {
            throw new \InvalidArgumentException(sprintf('The EditorialReason property can only contain items of type \StructType\EditorialReason, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->EditorialReason[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\EditorialReason|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\EditorialReason|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\EditorialReason|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\EditorialReason|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\EditorialReason|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string EditorialReason
     */
    public function getAttributeName()
    {
        return 'EditorialReason';
    }
}
