<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfEditorialReasonCollection ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfEditorialReasonCollection
 * @subpackage Arrays
 */
class ArrayOfEditorialReasonCollection extends AbstractStructArrayBase
{
    /**
     * The EditorialReasonCollection
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\EditorialReasonCollection[]
     */
    public $EditorialReasonCollection;
    /**
     * Constructor method for ArrayOfEditorialReasonCollection
     * @uses ArrayOfEditorialReasonCollection::setEditorialReasonCollection()
     * @param \StructType\EditorialReasonCollection[] $editorialReasonCollection
     */
    public function __construct(array $editorialReasonCollection = array())
    {
        $this
            ->setEditorialReasonCollection($editorialReasonCollection);
    }
    /**
     * Get EditorialReasonCollection value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\EditorialReasonCollection[]|null
     */
    public function getEditorialReasonCollection()
    {
        return isset($this->EditorialReasonCollection) ? $this->EditorialReasonCollection : null;
    }
    /**
     * This method is responsible for validating the values passed to the setEditorialReasonCollection method
     * This method is willingly generated in order to preserve the one-line inline validation within the setEditorialReasonCollection method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateEditorialReasonCollectionForArrayConstraintsFromSetEditorialReasonCollection(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfEditorialReasonCollectionEditorialReasonCollectionItem) {
            // validation for constraint: itemType
            if (!$arrayOfEditorialReasonCollectionEditorialReasonCollectionItem instanceof \StructType\EditorialReasonCollection) {
                $invalidValues[] = is_object($arrayOfEditorialReasonCollectionEditorialReasonCollectionItem) ? get_class($arrayOfEditorialReasonCollectionEditorialReasonCollectionItem) : sprintf('%s(%s)', gettype($arrayOfEditorialReasonCollectionEditorialReasonCollectionItem), var_export($arrayOfEditorialReasonCollectionEditorialReasonCollectionItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The EditorialReasonCollection property can only contain items of type \StructType\EditorialReasonCollection, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set EditorialReasonCollection value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\EditorialReasonCollection[] $editorialReasonCollection
     * @return \ArrayType\ArrayOfEditorialReasonCollection
     */
    public function setEditorialReasonCollection(array $editorialReasonCollection = array())
    {
        // validation for constraint: array
        if ('' !== ($editorialReasonCollectionArrayErrorMessage = self::validateEditorialReasonCollectionForArrayConstraintsFromSetEditorialReasonCollection($editorialReasonCollection))) {
            throw new \InvalidArgumentException($editorialReasonCollectionArrayErrorMessage, __LINE__);
        }
        if (is_null($editorialReasonCollection) || (is_array($editorialReasonCollection) && empty($editorialReasonCollection))) {
            unset($this->EditorialReasonCollection);
        } else {
            $this->EditorialReasonCollection = $editorialReasonCollection;
        }
        return $this;
    }
    /**
     * Add item to EditorialReasonCollection value
     * @throws \InvalidArgumentException
     * @param \StructType\EditorialReasonCollection $item
     * @return \ArrayType\ArrayOfEditorialReasonCollection
     */
    public function addToEditorialReasonCollection(\StructType\EditorialReasonCollection $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\EditorialReasonCollection) {
            throw new \InvalidArgumentException(sprintf('The EditorialReasonCollection property can only contain items of type \StructType\EditorialReasonCollection, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->EditorialReasonCollection[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\EditorialReasonCollection|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\EditorialReasonCollection|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\EditorialReasonCollection|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\EditorialReasonCollection|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\EditorialReasonCollection|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string EditorialReasonCollection
     */
    public function getAttributeName()
    {
        return 'EditorialReasonCollection';
    }
}
