<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfEntityIdToParentIdAssociation ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfEntityIdToParentIdAssociation
 * @subpackage Arrays
 */
class ArrayOfEntityIdToParentIdAssociation extends AbstractStructArrayBase
{
    /**
     * The EntityIdToParentIdAssociation
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\EntityIdToParentIdAssociation[]
     */
    public $EntityIdToParentIdAssociation;
    /**
     * Constructor method for ArrayOfEntityIdToParentIdAssociation
     * @uses ArrayOfEntityIdToParentIdAssociation::setEntityIdToParentIdAssociation()
     * @param \StructType\EntityIdToParentIdAssociation[] $entityIdToParentIdAssociation
     */
    public function __construct(array $entityIdToParentIdAssociation = array())
    {
        $this
            ->setEntityIdToParentIdAssociation($entityIdToParentIdAssociation);
    }
    /**
     * Get EntityIdToParentIdAssociation value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\EntityIdToParentIdAssociation[]|null
     */
    public function getEntityIdToParentIdAssociation()
    {
        return isset($this->EntityIdToParentIdAssociation) ? $this->EntityIdToParentIdAssociation : null;
    }
    /**
     * This method is responsible for validating the values passed to the setEntityIdToParentIdAssociation method
     * This method is willingly generated in order to preserve the one-line inline validation within the setEntityIdToParentIdAssociation method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateEntityIdToParentIdAssociationForArrayConstraintsFromSetEntityIdToParentIdAssociation(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfEntityIdToParentIdAssociationEntityIdToParentIdAssociationItem) {
            // validation for constraint: itemType
            if (!$arrayOfEntityIdToParentIdAssociationEntityIdToParentIdAssociationItem instanceof \StructType\EntityIdToParentIdAssociation) {
                $invalidValues[] = is_object($arrayOfEntityIdToParentIdAssociationEntityIdToParentIdAssociationItem) ? get_class($arrayOfEntityIdToParentIdAssociationEntityIdToParentIdAssociationItem) : sprintf('%s(%s)', gettype($arrayOfEntityIdToParentIdAssociationEntityIdToParentIdAssociationItem), var_export($arrayOfEntityIdToParentIdAssociationEntityIdToParentIdAssociationItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The EntityIdToParentIdAssociation property can only contain items of type \StructType\EntityIdToParentIdAssociation, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set EntityIdToParentIdAssociation value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\EntityIdToParentIdAssociation[] $entityIdToParentIdAssociation
     * @return \ArrayType\ArrayOfEntityIdToParentIdAssociation
     */
    public function setEntityIdToParentIdAssociation(array $entityIdToParentIdAssociation = array())
    {
        // validation for constraint: array
        if ('' !== ($entityIdToParentIdAssociationArrayErrorMessage = self::validateEntityIdToParentIdAssociationForArrayConstraintsFromSetEntityIdToParentIdAssociation($entityIdToParentIdAssociation))) {
            throw new \InvalidArgumentException($entityIdToParentIdAssociationArrayErrorMessage, __LINE__);
        }
        if (is_null($entityIdToParentIdAssociation) || (is_array($entityIdToParentIdAssociation) && empty($entityIdToParentIdAssociation))) {
            unset($this->EntityIdToParentIdAssociation);
        } else {
            $this->EntityIdToParentIdAssociation = $entityIdToParentIdAssociation;
        }
        return $this;
    }
    /**
     * Add item to EntityIdToParentIdAssociation value
     * @throws \InvalidArgumentException
     * @param \StructType\EntityIdToParentIdAssociation $item
     * @return \ArrayType\ArrayOfEntityIdToParentIdAssociation
     */
    public function addToEntityIdToParentIdAssociation(\StructType\EntityIdToParentIdAssociation $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\EntityIdToParentIdAssociation) {
            throw new \InvalidArgumentException(sprintf('The EntityIdToParentIdAssociation property can only contain items of type \StructType\EntityIdToParentIdAssociation, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->EntityIdToParentIdAssociation[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\EntityIdToParentIdAssociation|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\EntityIdToParentIdAssociation|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\EntityIdToParentIdAssociation|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\EntityIdToParentIdAssociation|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\EntityIdToParentIdAssociation|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string EntityIdToParentIdAssociation
     */
    public function getAttributeName()
    {
        return 'EntityIdToParentIdAssociation';
    }
}
