<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfEntityNegativeKeyword ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfEntityNegativeKeyword
 * @subpackage Arrays
 */
class ArrayOfEntityNegativeKeyword extends AbstractStructArrayBase
{
    /**
     * The EntityNegativeKeyword
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\EntityNegativeKeyword[]
     */
    public $EntityNegativeKeyword;
    /**
     * Constructor method for ArrayOfEntityNegativeKeyword
     * @uses ArrayOfEntityNegativeKeyword::setEntityNegativeKeyword()
     * @param \StructType\EntityNegativeKeyword[] $entityNegativeKeyword
     */
    public function __construct(array $entityNegativeKeyword = array())
    {
        $this
            ->setEntityNegativeKeyword($entityNegativeKeyword);
    }
    /**
     * Get EntityNegativeKeyword value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\EntityNegativeKeyword[]|null
     */
    public function getEntityNegativeKeyword()
    {
        return isset($this->EntityNegativeKeyword) ? $this->EntityNegativeKeyword : null;
    }
    /**
     * This method is responsible for validating the values passed to the setEntityNegativeKeyword method
     * This method is willingly generated in order to preserve the one-line inline validation within the setEntityNegativeKeyword method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateEntityNegativeKeywordForArrayConstraintsFromSetEntityNegativeKeyword(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfEntityNegativeKeywordEntityNegativeKeywordItem) {
            // validation for constraint: itemType
            if (!$arrayOfEntityNegativeKeywordEntityNegativeKeywordItem instanceof \StructType\EntityNegativeKeyword) {
                $invalidValues[] = is_object($arrayOfEntityNegativeKeywordEntityNegativeKeywordItem) ? get_class($arrayOfEntityNegativeKeywordEntityNegativeKeywordItem) : sprintf('%s(%s)', gettype($arrayOfEntityNegativeKeywordEntityNegativeKeywordItem), var_export($arrayOfEntityNegativeKeywordEntityNegativeKeywordItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The EntityNegativeKeyword property can only contain items of type \StructType\EntityNegativeKeyword, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set EntityNegativeKeyword value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\EntityNegativeKeyword[] $entityNegativeKeyword
     * @return \ArrayType\ArrayOfEntityNegativeKeyword
     */
    public function setEntityNegativeKeyword(array $entityNegativeKeyword = array())
    {
        // validation for constraint: array
        if ('' !== ($entityNegativeKeywordArrayErrorMessage = self::validateEntityNegativeKeywordForArrayConstraintsFromSetEntityNegativeKeyword($entityNegativeKeyword))) {
            throw new \InvalidArgumentException($entityNegativeKeywordArrayErrorMessage, __LINE__);
        }
        if (is_null($entityNegativeKeyword) || (is_array($entityNegativeKeyword) && empty($entityNegativeKeyword))) {
            unset($this->EntityNegativeKeyword);
        } else {
            $this->EntityNegativeKeyword = $entityNegativeKeyword;
        }
        return $this;
    }
    /**
     * Add item to EntityNegativeKeyword value
     * @throws \InvalidArgumentException
     * @param \StructType\EntityNegativeKeyword $item
     * @return \ArrayType\ArrayOfEntityNegativeKeyword
     */
    public function addToEntityNegativeKeyword(\StructType\EntityNegativeKeyword $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\EntityNegativeKeyword) {
            throw new \InvalidArgumentException(sprintf('The EntityNegativeKeyword property can only contain items of type \StructType\EntityNegativeKeyword, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->EntityNegativeKeyword[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\EntityNegativeKeyword|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\EntityNegativeKeyword|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\EntityNegativeKeyword|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\EntityNegativeKeyword|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\EntityNegativeKeyword|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string EntityNegativeKeyword
     */
    public function getAttributeName()
    {
        return 'EntityNegativeKeyword';
    }
}
