<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfImportEntityStatistics ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfImportEntityStatistics
 * @subpackage Arrays
 */
class ArrayOfImportEntityStatistics extends AbstractStructArrayBase
{
    /**
     * The ImportEntityStatistics
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ImportEntityStatistics[]
     */
    public $ImportEntityStatistics;
    /**
     * Constructor method for ArrayOfImportEntityStatistics
     * @uses ArrayOfImportEntityStatistics::setImportEntityStatistics()
     * @param \StructType\ImportEntityStatistics[] $importEntityStatistics
     */
    public function __construct(array $importEntityStatistics = array())
    {
        $this
            ->setImportEntityStatistics($importEntityStatistics);
    }
    /**
     * Get ImportEntityStatistics value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ImportEntityStatistics[]|null
     */
    public function getImportEntityStatistics()
    {
        return isset($this->ImportEntityStatistics) ? $this->ImportEntityStatistics : null;
    }
    /**
     * This method is responsible for validating the values passed to the setImportEntityStatistics method
     * This method is willingly generated in order to preserve the one-line inline validation within the setImportEntityStatistics method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateImportEntityStatisticsForArrayConstraintsFromSetImportEntityStatistics(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfImportEntityStatisticsImportEntityStatisticsItem) {
            // validation for constraint: itemType
            if (!$arrayOfImportEntityStatisticsImportEntityStatisticsItem instanceof \StructType\ImportEntityStatistics) {
                $invalidValues[] = is_object($arrayOfImportEntityStatisticsImportEntityStatisticsItem) ? get_class($arrayOfImportEntityStatisticsImportEntityStatisticsItem) : sprintf('%s(%s)', gettype($arrayOfImportEntityStatisticsImportEntityStatisticsItem), var_export($arrayOfImportEntityStatisticsImportEntityStatisticsItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ImportEntityStatistics property can only contain items of type \StructType\ImportEntityStatistics, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ImportEntityStatistics value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ImportEntityStatistics[] $importEntityStatistics
     * @return \ArrayType\ArrayOfImportEntityStatistics
     */
    public function setImportEntityStatistics(array $importEntityStatistics = array())
    {
        // validation for constraint: array
        if ('' !== ($importEntityStatisticsArrayErrorMessage = self::validateImportEntityStatisticsForArrayConstraintsFromSetImportEntityStatistics($importEntityStatistics))) {
            throw new \InvalidArgumentException($importEntityStatisticsArrayErrorMessage, __LINE__);
        }
        if (is_null($importEntityStatistics) || (is_array($importEntityStatistics) && empty($importEntityStatistics))) {
            unset($this->ImportEntityStatistics);
        } else {
            $this->ImportEntityStatistics = $importEntityStatistics;
        }
        return $this;
    }
    /**
     * Add item to ImportEntityStatistics value
     * @throws \InvalidArgumentException
     * @param \StructType\ImportEntityStatistics $item
     * @return \ArrayType\ArrayOfImportEntityStatistics
     */
    public function addToImportEntityStatistics(\StructType\ImportEntityStatistics $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ImportEntityStatistics) {
            throw new \InvalidArgumentException(sprintf('The ImportEntityStatistics property can only contain items of type \StructType\ImportEntityStatistics, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ImportEntityStatistics[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ImportEntityStatistics|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ImportEntityStatistics|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ImportEntityStatistics|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ImportEntityStatistics|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ImportEntityStatistics|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ImportEntityStatistics
     */
    public function getAttributeName()
    {
        return 'ImportEntityStatistics';
    }
}
