<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfImportJob ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfImportJob
 * @subpackage Arrays
 */
class ArrayOfImportJob extends AbstractStructArrayBase
{
    /**
     * The ImportJob
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ImportJob[]
     */
    public $ImportJob;
    /**
     * Constructor method for ArrayOfImportJob
     * @uses ArrayOfImportJob::setImportJob()
     * @param \StructType\ImportJob[] $importJob
     */
    public function __construct(array $importJob = array())
    {
        $this
            ->setImportJob($importJob);
    }
    /**
     * Get ImportJob value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ImportJob[]|null
     */
    public function getImportJob()
    {
        return isset($this->ImportJob) ? $this->ImportJob : null;
    }
    /**
     * This method is responsible for validating the values passed to the setImportJob method
     * This method is willingly generated in order to preserve the one-line inline validation within the setImportJob method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateImportJobForArrayConstraintsFromSetImportJob(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfImportJobImportJobItem) {
            // validation for constraint: itemType
            if (!$arrayOfImportJobImportJobItem instanceof \StructType\ImportJob) {
                $invalidValues[] = is_object($arrayOfImportJobImportJobItem) ? get_class($arrayOfImportJobImportJobItem) : sprintf('%s(%s)', gettype($arrayOfImportJobImportJobItem), var_export($arrayOfImportJobImportJobItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ImportJob property can only contain items of type \StructType\ImportJob, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ImportJob value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ImportJob[] $importJob
     * @return \ArrayType\ArrayOfImportJob
     */
    public function setImportJob(array $importJob = array())
    {
        // validation for constraint: array
        if ('' !== ($importJobArrayErrorMessage = self::validateImportJobForArrayConstraintsFromSetImportJob($importJob))) {
            throw new \InvalidArgumentException($importJobArrayErrorMessage, __LINE__);
        }
        if (is_null($importJob) || (is_array($importJob) && empty($importJob))) {
            unset($this->ImportJob);
        } else {
            $this->ImportJob = $importJob;
        }
        return $this;
    }
    /**
     * Add item to ImportJob value
     * @throws \InvalidArgumentException
     * @param \StructType\ImportJob $item
     * @return \ArrayType\ArrayOfImportJob
     */
    public function addToImportJob(\StructType\ImportJob $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ImportJob) {
            throw new \InvalidArgumentException(sprintf('The ImportJob property can only contain items of type \StructType\ImportJob, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ImportJob[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ImportJob|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ImportJob|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ImportJob|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ImportJob|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ImportJob|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ImportJob
     */
    public function getAttributeName()
    {
        return 'ImportJob';
    }
}
