<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfMigrationStatusInfo ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfMigrationStatusInfo
 * @subpackage Arrays
 */
class ArrayOfMigrationStatusInfo extends AbstractStructArrayBase
{
    /**
     * The MigrationStatusInfo
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\MigrationStatusInfo[]
     */
    public $MigrationStatusInfo;
    /**
     * Constructor method for ArrayOfMigrationStatusInfo
     * @uses ArrayOfMigrationStatusInfo::setMigrationStatusInfo()
     * @param \StructType\MigrationStatusInfo[] $migrationStatusInfo
     */
    public function __construct(array $migrationStatusInfo = array())
    {
        $this
            ->setMigrationStatusInfo($migrationStatusInfo);
    }
    /**
     * Get MigrationStatusInfo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\MigrationStatusInfo[]|null
     */
    public function getMigrationStatusInfo()
    {
        return isset($this->MigrationStatusInfo) ? $this->MigrationStatusInfo : null;
    }
    /**
     * This method is responsible for validating the values passed to the setMigrationStatusInfo method
     * This method is willingly generated in order to preserve the one-line inline validation within the setMigrationStatusInfo method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateMigrationStatusInfoForArrayConstraintsFromSetMigrationStatusInfo(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfMigrationStatusInfoMigrationStatusInfoItem) {
            // validation for constraint: itemType
            if (!$arrayOfMigrationStatusInfoMigrationStatusInfoItem instanceof \StructType\MigrationStatusInfo) {
                $invalidValues[] = is_object($arrayOfMigrationStatusInfoMigrationStatusInfoItem) ? get_class($arrayOfMigrationStatusInfoMigrationStatusInfoItem) : sprintf('%s(%s)', gettype($arrayOfMigrationStatusInfoMigrationStatusInfoItem), var_export($arrayOfMigrationStatusInfoMigrationStatusInfoItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The MigrationStatusInfo property can only contain items of type \StructType\MigrationStatusInfo, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set MigrationStatusInfo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\MigrationStatusInfo[] $migrationStatusInfo
     * @return \ArrayType\ArrayOfMigrationStatusInfo
     */
    public function setMigrationStatusInfo(array $migrationStatusInfo = array())
    {
        // validation for constraint: array
        if ('' !== ($migrationStatusInfoArrayErrorMessage = self::validateMigrationStatusInfoForArrayConstraintsFromSetMigrationStatusInfo($migrationStatusInfo))) {
            throw new \InvalidArgumentException($migrationStatusInfoArrayErrorMessage, __LINE__);
        }
        if (is_null($migrationStatusInfo) || (is_array($migrationStatusInfo) && empty($migrationStatusInfo))) {
            unset($this->MigrationStatusInfo);
        } else {
            $this->MigrationStatusInfo = $migrationStatusInfo;
        }
        return $this;
    }
    /**
     * Add item to MigrationStatusInfo value
     * @throws \InvalidArgumentException
     * @param \StructType\MigrationStatusInfo $item
     * @return \ArrayType\ArrayOfMigrationStatusInfo
     */
    public function addToMigrationStatusInfo(\StructType\MigrationStatusInfo $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\MigrationStatusInfo) {
            throw new \InvalidArgumentException(sprintf('The MigrationStatusInfo property can only contain items of type \StructType\MigrationStatusInfo, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->MigrationStatusInfo[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\MigrationStatusInfo|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\MigrationStatusInfo|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\MigrationStatusInfo|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\MigrationStatusInfo|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\MigrationStatusInfo|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string MigrationStatusInfo
     */
    public function getAttributeName()
    {
        return 'MigrationStatusInfo';
    }
}
