<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfNegativeKeyword ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfNegativeKeyword
 * @subpackage Arrays
 */
class ArrayOfNegativeKeyword extends AbstractStructArrayBase
{
    /**
     * The NegativeKeyword
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\NegativeKeyword[]
     */
    public $NegativeKeyword;
    /**
     * Constructor method for ArrayOfNegativeKeyword
     * @uses ArrayOfNegativeKeyword::setNegativeKeyword()
     * @param \StructType\NegativeKeyword[] $negativeKeyword
     */
    public function __construct(array $negativeKeyword = array())
    {
        $this
            ->setNegativeKeyword($negativeKeyword);
    }
    /**
     * Get NegativeKeyword value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\NegativeKeyword[]|null
     */
    public function getNegativeKeyword()
    {
        return isset($this->NegativeKeyword) ? $this->NegativeKeyword : null;
    }
    /**
     * This method is responsible for validating the values passed to the setNegativeKeyword method
     * This method is willingly generated in order to preserve the one-line inline validation within the setNegativeKeyword method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateNegativeKeywordForArrayConstraintsFromSetNegativeKeyword(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfNegativeKeywordNegativeKeywordItem) {
            // validation for constraint: itemType
            if (!$arrayOfNegativeKeywordNegativeKeywordItem instanceof \StructType\NegativeKeyword) {
                $invalidValues[] = is_object($arrayOfNegativeKeywordNegativeKeywordItem) ? get_class($arrayOfNegativeKeywordNegativeKeywordItem) : sprintf('%s(%s)', gettype($arrayOfNegativeKeywordNegativeKeywordItem), var_export($arrayOfNegativeKeywordNegativeKeywordItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The NegativeKeyword property can only contain items of type \StructType\NegativeKeyword, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set NegativeKeyword value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\NegativeKeyword[] $negativeKeyword
     * @return \ArrayType\ArrayOfNegativeKeyword
     */
    public function setNegativeKeyword(array $negativeKeyword = array())
    {
        // validation for constraint: array
        if ('' !== ($negativeKeywordArrayErrorMessage = self::validateNegativeKeywordForArrayConstraintsFromSetNegativeKeyword($negativeKeyword))) {
            throw new \InvalidArgumentException($negativeKeywordArrayErrorMessage, __LINE__);
        }
        if (is_null($negativeKeyword) || (is_array($negativeKeyword) && empty($negativeKeyword))) {
            unset($this->NegativeKeyword);
        } else {
            $this->NegativeKeyword = $negativeKeyword;
        }
        return $this;
    }
    /**
     * Add item to NegativeKeyword value
     * @throws \InvalidArgumentException
     * @param \StructType\NegativeKeyword $item
     * @return \ArrayType\ArrayOfNegativeKeyword
     */
    public function addToNegativeKeyword(\StructType\NegativeKeyword $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\NegativeKeyword) {
            throw new \InvalidArgumentException(sprintf('The NegativeKeyword property can only contain items of type \StructType\NegativeKeyword, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->NegativeKeyword[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\NegativeKeyword|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\NegativeKeyword|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\NegativeKeyword|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\NegativeKeyword|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\NegativeKeyword|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string NegativeKeyword
     */
    public function getAttributeName()
    {
        return 'NegativeKeyword';
    }
}
