<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfOfflineConversionAdjustment ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfOfflineConversionAdjustment
 * @subpackage Arrays
 */
class ArrayOfOfflineConversionAdjustment extends AbstractStructArrayBase
{
    /**
     * The OfflineConversionAdjustment
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\OfflineConversionAdjustment[]
     */
    public $OfflineConversionAdjustment;
    /**
     * Constructor method for ArrayOfOfflineConversionAdjustment
     * @uses ArrayOfOfflineConversionAdjustment::setOfflineConversionAdjustment()
     * @param \StructType\OfflineConversionAdjustment[] $offlineConversionAdjustment
     */
    public function __construct(array $offlineConversionAdjustment = array())
    {
        $this
            ->setOfflineConversionAdjustment($offlineConversionAdjustment);
    }
    /**
     * Get OfflineConversionAdjustment value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\OfflineConversionAdjustment[]|null
     */
    public function getOfflineConversionAdjustment()
    {
        return isset($this->OfflineConversionAdjustment) ? $this->OfflineConversionAdjustment : null;
    }
    /**
     * This method is responsible for validating the values passed to the setOfflineConversionAdjustment method
     * This method is willingly generated in order to preserve the one-line inline validation within the setOfflineConversionAdjustment method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateOfflineConversionAdjustmentForArrayConstraintsFromSetOfflineConversionAdjustment(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfOfflineConversionAdjustmentOfflineConversionAdjustmentItem) {
            // validation for constraint: itemType
            if (!$arrayOfOfflineConversionAdjustmentOfflineConversionAdjustmentItem instanceof \StructType\OfflineConversionAdjustment) {
                $invalidValues[] = is_object($arrayOfOfflineConversionAdjustmentOfflineConversionAdjustmentItem) ? get_class($arrayOfOfflineConversionAdjustmentOfflineConversionAdjustmentItem) : sprintf('%s(%s)', gettype($arrayOfOfflineConversionAdjustmentOfflineConversionAdjustmentItem), var_export($arrayOfOfflineConversionAdjustmentOfflineConversionAdjustmentItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The OfflineConversionAdjustment property can only contain items of type \StructType\OfflineConversionAdjustment, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set OfflineConversionAdjustment value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\OfflineConversionAdjustment[] $offlineConversionAdjustment
     * @return \ArrayType\ArrayOfOfflineConversionAdjustment
     */
    public function setOfflineConversionAdjustment(array $offlineConversionAdjustment = array())
    {
        // validation for constraint: array
        if ('' !== ($offlineConversionAdjustmentArrayErrorMessage = self::validateOfflineConversionAdjustmentForArrayConstraintsFromSetOfflineConversionAdjustment($offlineConversionAdjustment))) {
            throw new \InvalidArgumentException($offlineConversionAdjustmentArrayErrorMessage, __LINE__);
        }
        if (is_null($offlineConversionAdjustment) || (is_array($offlineConversionAdjustment) && empty($offlineConversionAdjustment))) {
            unset($this->OfflineConversionAdjustment);
        } else {
            $this->OfflineConversionAdjustment = $offlineConversionAdjustment;
        }
        return $this;
    }
    /**
     * Add item to OfflineConversionAdjustment value
     * @throws \InvalidArgumentException
     * @param \StructType\OfflineConversionAdjustment $item
     * @return \ArrayType\ArrayOfOfflineConversionAdjustment
     */
    public function addToOfflineConversionAdjustment(\StructType\OfflineConversionAdjustment $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\OfflineConversionAdjustment) {
            throw new \InvalidArgumentException(sprintf('The OfflineConversionAdjustment property can only contain items of type \StructType\OfflineConversionAdjustment, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->OfflineConversionAdjustment[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\OfflineConversionAdjustment|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\OfflineConversionAdjustment|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\OfflineConversionAdjustment|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\OfflineConversionAdjustment|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\OfflineConversionAdjustment|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string OfflineConversionAdjustment
     */
    public function getAttributeName()
    {
        return 'OfflineConversionAdjustment';
    }
}
