<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPriceTableRow ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfPriceTableRow
 * @subpackage Arrays
 */
class ArrayOfPriceTableRow extends AbstractStructArrayBase
{
    /**
     * The PriceTableRow
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\PriceTableRow[]
     */
    public $PriceTableRow;
    /**
     * Constructor method for ArrayOfPriceTableRow
     * @uses ArrayOfPriceTableRow::setPriceTableRow()
     * @param \StructType\PriceTableRow[] $priceTableRow
     */
    public function __construct(array $priceTableRow = array())
    {
        $this
            ->setPriceTableRow($priceTableRow);
    }
    /**
     * Get PriceTableRow value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\PriceTableRow[]|null
     */
    public function getPriceTableRow()
    {
        return isset($this->PriceTableRow) ? $this->PriceTableRow : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPriceTableRow method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPriceTableRow method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePriceTableRowForArrayConstraintsFromSetPriceTableRow(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPriceTableRowPriceTableRowItem) {
            // validation for constraint: itemType
            if (!$arrayOfPriceTableRowPriceTableRowItem instanceof \StructType\PriceTableRow) {
                $invalidValues[] = is_object($arrayOfPriceTableRowPriceTableRowItem) ? get_class($arrayOfPriceTableRowPriceTableRowItem) : sprintf('%s(%s)', gettype($arrayOfPriceTableRowPriceTableRowItem), var_export($arrayOfPriceTableRowPriceTableRowItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PriceTableRow property can only contain items of type \StructType\PriceTableRow, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PriceTableRow value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\PriceTableRow[] $priceTableRow
     * @return \ArrayType\ArrayOfPriceTableRow
     */
    public function setPriceTableRow(array $priceTableRow = array())
    {
        // validation for constraint: array
        if ('' !== ($priceTableRowArrayErrorMessage = self::validatePriceTableRowForArrayConstraintsFromSetPriceTableRow($priceTableRow))) {
            throw new \InvalidArgumentException($priceTableRowArrayErrorMessage, __LINE__);
        }
        if (is_null($priceTableRow) || (is_array($priceTableRow) && empty($priceTableRow))) {
            unset($this->PriceTableRow);
        } else {
            $this->PriceTableRow = $priceTableRow;
        }
        return $this;
    }
    /**
     * Add item to PriceTableRow value
     * @throws \InvalidArgumentException
     * @param \StructType\PriceTableRow $item
     * @return \ArrayType\ArrayOfPriceTableRow
     */
    public function addToPriceTableRow(\StructType\PriceTableRow $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PriceTableRow) {
            throw new \InvalidArgumentException(sprintf('The PriceTableRow property can only contain items of type \StructType\PriceTableRow, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PriceTableRow[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\PriceTableRow|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\PriceTableRow|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\PriceTableRow|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\PriceTableRow|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\PriceTableRow|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PriceTableRow
     */
    public function getAttributeName()
    {
        return 'PriceTableRow';
    }
}
