<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfProductCondition ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfProductCondition
 * @subpackage Arrays
 */
class ArrayOfProductCondition extends AbstractStructArrayBase
{
    /**
     * The ProductCondition
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ProductCondition[]
     */
    public $ProductCondition;
    /**
     * Constructor method for ArrayOfProductCondition
     * @uses ArrayOfProductCondition::setProductCondition()
     * @param \StructType\ProductCondition[] $productCondition
     */
    public function __construct(array $productCondition = array())
    {
        $this
            ->setProductCondition($productCondition);
    }
    /**
     * Get ProductCondition value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ProductCondition[]|null
     */
    public function getProductCondition()
    {
        return isset($this->ProductCondition) ? $this->ProductCondition : null;
    }
    /**
     * This method is responsible for validating the values passed to the setProductCondition method
     * This method is willingly generated in order to preserve the one-line inline validation within the setProductCondition method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateProductConditionForArrayConstraintsFromSetProductCondition(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfProductConditionProductConditionItem) {
            // validation for constraint: itemType
            if (!$arrayOfProductConditionProductConditionItem instanceof \StructType\ProductCondition) {
                $invalidValues[] = is_object($arrayOfProductConditionProductConditionItem) ? get_class($arrayOfProductConditionProductConditionItem) : sprintf('%s(%s)', gettype($arrayOfProductConditionProductConditionItem), var_export($arrayOfProductConditionProductConditionItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ProductCondition property can only contain items of type \StructType\ProductCondition, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ProductCondition value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ProductCondition[] $productCondition
     * @return \ArrayType\ArrayOfProductCondition
     */
    public function setProductCondition(array $productCondition = array())
    {
        // validation for constraint: array
        if ('' !== ($productConditionArrayErrorMessage = self::validateProductConditionForArrayConstraintsFromSetProductCondition($productCondition))) {
            throw new \InvalidArgumentException($productConditionArrayErrorMessage, __LINE__);
        }
        if (is_null($productCondition) || (is_array($productCondition) && empty($productCondition))) {
            unset($this->ProductCondition);
        } else {
            $this->ProductCondition = $productCondition;
        }
        return $this;
    }
    /**
     * Add item to ProductCondition value
     * @throws \InvalidArgumentException
     * @param \StructType\ProductCondition $item
     * @return \ArrayType\ArrayOfProductCondition
     */
    public function addToProductCondition(\StructType\ProductCondition $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ProductCondition) {
            throw new \InvalidArgumentException(sprintf('The ProductCondition property can only contain items of type \StructType\ProductCondition, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ProductCondition[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ProductCondition|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ProductCondition|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ProductCondition|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ProductCondition|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ProductCondition|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ProductCondition
     */
    public function getAttributeName()
    {
        return 'ProductCondition';
    }
}
