<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfSharedEntityAssociation ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfSharedEntityAssociation
 * @subpackage Arrays
 */
class ArrayOfSharedEntityAssociation extends AbstractStructArrayBase
{
    /**
     * The SharedEntityAssociation
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\SharedEntityAssociation[]
     */
    public $SharedEntityAssociation;
    /**
     * Constructor method for ArrayOfSharedEntityAssociation
     * @uses ArrayOfSharedEntityAssociation::setSharedEntityAssociation()
     * @param \StructType\SharedEntityAssociation[] $sharedEntityAssociation
     */
    public function __construct(array $sharedEntityAssociation = array())
    {
        $this
            ->setSharedEntityAssociation($sharedEntityAssociation);
    }
    /**
     * Get SharedEntityAssociation value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\SharedEntityAssociation[]|null
     */
    public function getSharedEntityAssociation()
    {
        return isset($this->SharedEntityAssociation) ? $this->SharedEntityAssociation : null;
    }
    /**
     * This method is responsible for validating the values passed to the setSharedEntityAssociation method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSharedEntityAssociation method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSharedEntityAssociationForArrayConstraintsFromSetSharedEntityAssociation(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfSharedEntityAssociationSharedEntityAssociationItem) {
            // validation for constraint: itemType
            if (!$arrayOfSharedEntityAssociationSharedEntityAssociationItem instanceof \StructType\SharedEntityAssociation) {
                $invalidValues[] = is_object($arrayOfSharedEntityAssociationSharedEntityAssociationItem) ? get_class($arrayOfSharedEntityAssociationSharedEntityAssociationItem) : sprintf('%s(%s)', gettype($arrayOfSharedEntityAssociationSharedEntityAssociationItem), var_export($arrayOfSharedEntityAssociationSharedEntityAssociationItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SharedEntityAssociation property can only contain items of type \StructType\SharedEntityAssociation, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SharedEntityAssociation value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\SharedEntityAssociation[] $sharedEntityAssociation
     * @return \ArrayType\ArrayOfSharedEntityAssociation
     */
    public function setSharedEntityAssociation(array $sharedEntityAssociation = array())
    {
        // validation for constraint: array
        if ('' !== ($sharedEntityAssociationArrayErrorMessage = self::validateSharedEntityAssociationForArrayConstraintsFromSetSharedEntityAssociation($sharedEntityAssociation))) {
            throw new \InvalidArgumentException($sharedEntityAssociationArrayErrorMessage, __LINE__);
        }
        if (is_null($sharedEntityAssociation) || (is_array($sharedEntityAssociation) && empty($sharedEntityAssociation))) {
            unset($this->SharedEntityAssociation);
        } else {
            $this->SharedEntityAssociation = $sharedEntityAssociation;
        }
        return $this;
    }
    /**
     * Add item to SharedEntityAssociation value
     * @throws \InvalidArgumentException
     * @param \StructType\SharedEntityAssociation $item
     * @return \ArrayType\ArrayOfSharedEntityAssociation
     */
    public function addToSharedEntityAssociation(\StructType\SharedEntityAssociation $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SharedEntityAssociation) {
            throw new \InvalidArgumentException(sprintf('The SharedEntityAssociation property can only contain items of type \StructType\SharedEntityAssociation, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SharedEntityAssociation[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\SharedEntityAssociation|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\SharedEntityAssociation|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\SharedEntityAssociation|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\SharedEntityAssociation|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\SharedEntityAssociation|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SharedEntityAssociation
     */
    public function getAttributeName()
    {
        return 'SharedEntityAssociation';
    }
}
