<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTargetSettingDetail ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfTargetSettingDetail
 * @subpackage Arrays
 */
class ArrayOfTargetSettingDetail extends AbstractStructArrayBase
{
    /**
     * The TargetSettingDetail
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TargetSettingDetail[]
     */
    public $TargetSettingDetail;
    /**
     * Constructor method for ArrayOfTargetSettingDetail
     * @uses ArrayOfTargetSettingDetail::setTargetSettingDetail()
     * @param \StructType\TargetSettingDetail[] $targetSettingDetail
     */
    public function __construct(array $targetSettingDetail = array())
    {
        $this
            ->setTargetSettingDetail($targetSettingDetail);
    }
    /**
     * Get TargetSettingDetail value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TargetSettingDetail[]|null
     */
    public function getTargetSettingDetail()
    {
        return isset($this->TargetSettingDetail) ? $this->TargetSettingDetail : null;
    }
    /**
     * This method is responsible for validating the values passed to the setTargetSettingDetail method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTargetSettingDetail method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTargetSettingDetailForArrayConstraintsFromSetTargetSettingDetail(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfTargetSettingDetailTargetSettingDetailItem) {
            // validation for constraint: itemType
            if (!$arrayOfTargetSettingDetailTargetSettingDetailItem instanceof \StructType\TargetSettingDetail) {
                $invalidValues[] = is_object($arrayOfTargetSettingDetailTargetSettingDetailItem) ? get_class($arrayOfTargetSettingDetailTargetSettingDetailItem) : sprintf('%s(%s)', gettype($arrayOfTargetSettingDetailTargetSettingDetailItem), var_export($arrayOfTargetSettingDetailTargetSettingDetailItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TargetSettingDetail property can only contain items of type \StructType\TargetSettingDetail, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TargetSettingDetail value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TargetSettingDetail[] $targetSettingDetail
     * @return \ArrayType\ArrayOfTargetSettingDetail
     */
    public function setTargetSettingDetail(array $targetSettingDetail = array())
    {
        // validation for constraint: array
        if ('' !== ($targetSettingDetailArrayErrorMessage = self::validateTargetSettingDetailForArrayConstraintsFromSetTargetSettingDetail($targetSettingDetail))) {
            throw new \InvalidArgumentException($targetSettingDetailArrayErrorMessage, __LINE__);
        }
        if (is_null($targetSettingDetail) || (is_array($targetSettingDetail) && empty($targetSettingDetail))) {
            unset($this->TargetSettingDetail);
        } else {
            $this->TargetSettingDetail = $targetSettingDetail;
        }
        return $this;
    }
    /**
     * Add item to TargetSettingDetail value
     * @throws \InvalidArgumentException
     * @param \StructType\TargetSettingDetail $item
     * @return \ArrayType\ArrayOfTargetSettingDetail
     */
    public function addToTargetSettingDetail(\StructType\TargetSettingDetail $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TargetSettingDetail) {
            throw new \InvalidArgumentException(sprintf('The TargetSettingDetail property can only contain items of type \StructType\TargetSettingDetail, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TargetSettingDetail[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TargetSettingDetail|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TargetSettingDetail|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TargetSettingDetail|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TargetSettingDetail|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TargetSettingDetail|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TargetSettingDetail
     */
    public function getAttributeName()
    {
        return 'TargetSettingDetail';
    }
}
