<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfUetTag ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfUetTag
 * @subpackage Arrays
 */
class ArrayOfUetTag extends AbstractStructArrayBase
{
    /**
     * The UetTag
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\UetTag[]
     */
    public $UetTag;
    /**
     * Constructor method for ArrayOfUetTag
     * @uses ArrayOfUetTag::setUetTag()
     * @param \StructType\UetTag[] $uetTag
     */
    public function __construct(array $uetTag = array())
    {
        $this
            ->setUetTag($uetTag);
    }
    /**
     * Get UetTag value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\UetTag[]|null
     */
    public function getUetTag()
    {
        return isset($this->UetTag) ? $this->UetTag : null;
    }
    /**
     * This method is responsible for validating the values passed to the setUetTag method
     * This method is willingly generated in order to preserve the one-line inline validation within the setUetTag method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateUetTagForArrayConstraintsFromSetUetTag(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfUetTagUetTagItem) {
            // validation for constraint: itemType
            if (!$arrayOfUetTagUetTagItem instanceof \StructType\UetTag) {
                $invalidValues[] = is_object($arrayOfUetTagUetTagItem) ? get_class($arrayOfUetTagUetTagItem) : sprintf('%s(%s)', gettype($arrayOfUetTagUetTagItem), var_export($arrayOfUetTagUetTagItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The UetTag property can only contain items of type \StructType\UetTag, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set UetTag value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\UetTag[] $uetTag
     * @return \ArrayType\ArrayOfUetTag
     */
    public function setUetTag(array $uetTag = array())
    {
        // validation for constraint: array
        if ('' !== ($uetTagArrayErrorMessage = self::validateUetTagForArrayConstraintsFromSetUetTag($uetTag))) {
            throw new \InvalidArgumentException($uetTagArrayErrorMessage, __LINE__);
        }
        if (is_null($uetTag) || (is_array($uetTag) && empty($uetTag))) {
            unset($this->UetTag);
        } else {
            $this->UetTag = $uetTag;
        }
        return $this;
    }
    /**
     * Add item to UetTag value
     * @throws \InvalidArgumentException
     * @param \StructType\UetTag $item
     * @return \ArrayType\ArrayOfUetTag
     */
    public function addToUetTag(\StructType\UetTag $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\UetTag) {
            throw new \InvalidArgumentException(sprintf('The UetTag property can only contain items of type \StructType\UetTag, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->UetTag[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\UetTag|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\UetTag|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\UetTag|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\UetTag|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\UetTag|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string UetTag
     */
    public function getAttributeName()
    {
        return 'UetTag';
    }
}
