<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfWebpageCondition ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfWebpageCondition
 * @subpackage Arrays
 */
class ArrayOfWebpageCondition extends AbstractStructArrayBase
{
    /**
     * The WebpageCondition
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\WebpageCondition[]
     */
    public $WebpageCondition;
    /**
     * Constructor method for ArrayOfWebpageCondition
     * @uses ArrayOfWebpageCondition::setWebpageCondition()
     * @param \StructType\WebpageCondition[] $webpageCondition
     */
    public function __construct(array $webpageCondition = array())
    {
        $this
            ->setWebpageCondition($webpageCondition);
    }
    /**
     * Get WebpageCondition value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\WebpageCondition[]|null
     */
    public function getWebpageCondition()
    {
        return isset($this->WebpageCondition) ? $this->WebpageCondition : null;
    }
    /**
     * This method is responsible for validating the values passed to the setWebpageCondition method
     * This method is willingly generated in order to preserve the one-line inline validation within the setWebpageCondition method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateWebpageConditionForArrayConstraintsFromSetWebpageCondition(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfWebpageConditionWebpageConditionItem) {
            // validation for constraint: itemType
            if (!$arrayOfWebpageConditionWebpageConditionItem instanceof \StructType\WebpageCondition) {
                $invalidValues[] = is_object($arrayOfWebpageConditionWebpageConditionItem) ? get_class($arrayOfWebpageConditionWebpageConditionItem) : sprintf('%s(%s)', gettype($arrayOfWebpageConditionWebpageConditionItem), var_export($arrayOfWebpageConditionWebpageConditionItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The WebpageCondition property can only contain items of type \StructType\WebpageCondition, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set WebpageCondition value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\WebpageCondition[] $webpageCondition
     * @return \ArrayType\ArrayOfWebpageCondition
     */
    public function setWebpageCondition(array $webpageCondition = array())
    {
        // validation for constraint: array
        if ('' !== ($webpageConditionArrayErrorMessage = self::validateWebpageConditionForArrayConstraintsFromSetWebpageCondition($webpageCondition))) {
            throw new \InvalidArgumentException($webpageConditionArrayErrorMessage, __LINE__);
        }
        if (is_null($webpageCondition) || (is_array($webpageCondition) && empty($webpageCondition))) {
            unset($this->WebpageCondition);
        } else {
            $this->WebpageCondition = $webpageCondition;
        }
        return $this;
    }
    /**
     * Add item to WebpageCondition value
     * @throws \InvalidArgumentException
     * @param \StructType\WebpageCondition $item
     * @return \ArrayType\ArrayOfWebpageCondition
     */
    public function addToWebpageCondition(\StructType\WebpageCondition $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\WebpageCondition) {
            throw new \InvalidArgumentException(sprintf('The WebpageCondition property can only contain items of type \StructType\WebpageCondition, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->WebpageCondition[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\WebpageCondition|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\WebpageCondition|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\WebpageCondition|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\WebpageCondition|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\WebpageCondition|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string WebpageCondition
     */
    public function getAttributeName()
    {
        return 'WebpageCondition';
    }
}
