<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'TextAd' => '\\StructType\\TextAd',
            'Ad' => '\\StructType\\Ad',
            'ArrayOfAppUrl' => '\\ArrayType\\ArrayOfAppUrl',
            'AppUrl' => '\\StructType\\AppUrl',
            'CustomParameters' => '\\StructType\\CustomParameters',
            'ArrayOfCustomParameter' => '\\ArrayType\\ArrayOfCustomParameter',
            'CustomParameter' => '\\StructType\\CustomParameter',
            'ProductAd' => '\\StructType\\ProductAd',
            'AppInstallAd' => '\\StructType\\AppInstallAd',
            'ExpandedTextAd' => '\\StructType\\ExpandedTextAd',
            'DynamicSearchAd' => '\\StructType\\DynamicSearchAd',
            'ResponsiveAd' => '\\StructType\\ResponsiveAd',
            'ArrayOfAssetLink' => '\\ArrayType\\ArrayOfAssetLink',
            'AssetLink' => '\\StructType\\AssetLink',
            'Asset' => '\\StructType\\Asset',
            'TextAsset' => '\\StructType\\TextAsset',
            'ImageAsset' => '\\StructType\\ImageAsset',
            'VideoAsset' => '\\StructType\\VideoAsset',
            'ResponsiveSearchAd' => '\\StructType\\ResponsiveSearchAd',
            'AddCampaignsRequest' => '\\StructType\\AddCampaignsRequest',
            'ArrayOfCampaign' => '\\ArrayType\\ArrayOfCampaign',
            'Campaign' => '\\StructType\\Campaign',
            'BiddingScheme' => '\\StructType\\BiddingScheme',
            'MaxClicksBiddingScheme' => '\\StructType\\MaxClicksBiddingScheme',
            'Bid' => '\\StructType\\Bid',
            'MaxConversionsBiddingScheme' => '\\StructType\\MaxConversionsBiddingScheme',
            'TargetCpaBiddingScheme' => '\\StructType\\TargetCpaBiddingScheme',
            'ManualCpcBiddingScheme' => '\\StructType\\ManualCpcBiddingScheme',
            'EnhancedCpcBiddingScheme' => '\\StructType\\EnhancedCpcBiddingScheme',
            'ManualCpvBiddingScheme' => '\\StructType\\ManualCpvBiddingScheme',
            'ManualCpmBiddingScheme' => '\\StructType\\ManualCpmBiddingScheme',
            'InheritFromParentBiddingScheme' => '\\StructType\\InheritFromParentBiddingScheme',
            'TargetRoasBiddingScheme' => '\\StructType\\TargetRoasBiddingScheme',
            'MaxRoasBiddingScheme' => '\\StructType\\MaxRoasBiddingScheme',
            'MaxConversionValueBiddingScheme' => '\\StructType\\MaxConversionValueBiddingScheme',
            'TargetImpressionShareBiddingScheme' => '\\StructType\\TargetImpressionShareBiddingScheme',
            'ArrayOfSetting' => '\\ArrayType\\ArrayOfSetting',
            'Setting' => '\\StructType\\Setting',
            'ShoppingSetting' => '\\StructType\\ShoppingSetting',
            'DynamicFeedSetting' => '\\StructType\\DynamicFeedSetting',
            'DynamicSearchAdsSetting' => '\\StructType\\DynamicSearchAdsSetting',
            'TargetSetting' => '\\StructType\\TargetSetting',
            'ArrayOfTargetSettingDetail' => '\\ArrayType\\ArrayOfTargetSettingDetail',
            'TargetSettingDetail' => '\\StructType\\TargetSettingDetail',
            'CoOpSetting' => '\\StructType\\CoOpSetting',
            'VerifiedTrackingSetting' => '\\StructType\\VerifiedTrackingSetting',
            'DisclaimerSetting' => '\\StructType\\DisclaimerSetting',
            'AddCampaignsResponse' => '\\StructType\\AddCampaignsResponse',
            'ArrayOfBatchError' => '\\ArrayType\\ArrayOfBatchError',
            'BatchError' => '\\StructType\\BatchError',
            'EditorialError' => '\\StructType\\EditorialError',
            'ApiFaultDetail' => '\\StructType\\ApiFaultDetail',
            'ArrayOfOperationError' => '\\ArrayType\\ArrayOfOperationError',
            'OperationError' => '\\StructType\\OperationError',
            'GetCampaignsByAccountIdRequest' => '\\StructType\\GetCampaignsByAccountIdRequest',
            'GetCampaignsByAccountIdResponse' => '\\StructType\\GetCampaignsByAccountIdResponse',
            'GetCampaignsByIdsRequest' => '\\StructType\\GetCampaignsByIdsRequest',
            'GetCampaignsByIdsResponse' => '\\StructType\\GetCampaignsByIdsResponse',
            'DeleteCampaignsRequest' => '\\StructType\\DeleteCampaignsRequest',
            'DeleteCampaignsResponse' => '\\StructType\\DeleteCampaignsResponse',
            'UpdateCampaignsRequest' => '\\StructType\\UpdateCampaignsRequest',
            'UpdateCampaignsResponse' => '\\StructType\\UpdateCampaignsResponse',
            'GetNegativeSitesByCampaignIdsRequest' => '\\StructType\\GetNegativeSitesByCampaignIdsRequest',
            'GetNegativeSitesByCampaignIdsResponse' => '\\StructType\\GetNegativeSitesByCampaignIdsResponse',
            'ArrayOfCampaignNegativeSites' => '\\ArrayType\\ArrayOfCampaignNegativeSites',
            'CampaignNegativeSites' => '\\StructType\\CampaignNegativeSites',
            'SetNegativeSitesToCampaignsRequest' => '\\StructType\\SetNegativeSitesToCampaignsRequest',
            'SetNegativeSitesToCampaignsResponse' => '\\StructType\\SetNegativeSitesToCampaignsResponse',
            'GetConfigValueRequest' => '\\StructType\\GetConfigValueRequest',
            'GetConfigValueResponse' => '\\StructType\\GetConfigValueResponse',
            'GetBSCCountriesRequest' => '\\StructType\\GetBSCCountriesRequest',
            'GetBSCCountriesResponse' => '\\StructType\\GetBSCCountriesResponse',
            'AddAdGroupsRequest' => '\\StructType\\AddAdGroupsRequest',
            'ArrayOfAdGroup' => '\\ArrayType\\ArrayOfAdGroup',
            'AdGroup' => '\\StructType\\AdGroup',
            'AdRotation' => '\\StructType\\AdRotation',
            'Date' => '\\StructType\\Date',
            'AddAdGroupsResponse' => '\\StructType\\AddAdGroupsResponse',
            'DeleteAdGroupsRequest' => '\\StructType\\DeleteAdGroupsRequest',
            'DeleteAdGroupsResponse' => '\\StructType\\DeleteAdGroupsResponse',
            'GetAdGroupsByIdsRequest' => '\\StructType\\GetAdGroupsByIdsRequest',
            'GetAdGroupsByIdsResponse' => '\\StructType\\GetAdGroupsByIdsResponse',
            'GetAdGroupsByCampaignIdRequest' => '\\StructType\\GetAdGroupsByCampaignIdRequest',
            'GetAdGroupsByCampaignIdResponse' => '\\StructType\\GetAdGroupsByCampaignIdResponse',
            'UpdateAdGroupsRequest' => '\\StructType\\UpdateAdGroupsRequest',
            'UpdateAdGroupsResponse' => '\\StructType\\UpdateAdGroupsResponse',
            'GetNegativeSitesByAdGroupIdsRequest' => '\\StructType\\GetNegativeSitesByAdGroupIdsRequest',
            'GetNegativeSitesByAdGroupIdsResponse' => '\\StructType\\GetNegativeSitesByAdGroupIdsResponse',
            'ArrayOfAdGroupNegativeSites' => '\\ArrayType\\ArrayOfAdGroupNegativeSites',
            'AdGroupNegativeSites' => '\\StructType\\AdGroupNegativeSites',
            'SetNegativeSitesToAdGroupsRequest' => '\\StructType\\SetNegativeSitesToAdGroupsRequest',
            'SetNegativeSitesToAdGroupsResponse' => '\\StructType\\SetNegativeSitesToAdGroupsResponse',
            'GetGeoLocationsFileUrlRequest' => '\\StructType\\GetGeoLocationsFileUrlRequest',
            'GetGeoLocationsFileUrlResponse' => '\\StructType\\GetGeoLocationsFileUrlResponse',
            'AddAdsRequest' => '\\StructType\\AddAdsRequest',
            'ArrayOfAd' => '\\ArrayType\\ArrayOfAd',
            'AddAdsResponse' => '\\StructType\\AddAdsResponse',
            'EditorialApiFaultDetail' => '\\StructType\\EditorialApiFaultDetail',
            'ArrayOfEditorialError' => '\\ArrayType\\ArrayOfEditorialError',
            'DeleteAdsRequest' => '\\StructType\\DeleteAdsRequest',
            'DeleteAdsResponse' => '\\StructType\\DeleteAdsResponse',
            'GetAdsByEditorialStatusRequest' => '\\StructType\\GetAdsByEditorialStatusRequest',
            'ArrayOfAdType' => '\\ArrayType\\ArrayOfAdType',
            'GetAdsByEditorialStatusResponse' => '\\StructType\\GetAdsByEditorialStatusResponse',
            'GetAdsByIdsRequest' => '\\StructType\\GetAdsByIdsRequest',
            'GetAdsByIdsResponse' => '\\StructType\\GetAdsByIdsResponse',
            'GetAdsByAdGroupIdRequest' => '\\StructType\\GetAdsByAdGroupIdRequest',
            'GetAdsByAdGroupIdResponse' => '\\StructType\\GetAdsByAdGroupIdResponse',
            'UpdateAdsRequest' => '\\StructType\\UpdateAdsRequest',
            'UpdateAdsResponse' => '\\StructType\\UpdateAdsResponse',
            'AddKeywordsRequest' => '\\StructType\\AddKeywordsRequest',
            'ArrayOfKeyword' => '\\ArrayType\\ArrayOfKeyword',
            'Keyword' => '\\StructType\\Keyword',
            'AddKeywordsResponse' => '\\StructType\\AddKeywordsResponse',
            'DeleteKeywordsRequest' => '\\StructType\\DeleteKeywordsRequest',
            'DeleteKeywordsResponse' => '\\StructType\\DeleteKeywordsResponse',
            'GetKeywordsByEditorialStatusRequest' => '\\StructType\\GetKeywordsByEditorialStatusRequest',
            'GetKeywordsByEditorialStatusResponse' => '\\StructType\\GetKeywordsByEditorialStatusResponse',
            'GetKeywordsByIdsRequest' => '\\StructType\\GetKeywordsByIdsRequest',
            'GetKeywordsByIdsResponse' => '\\StructType\\GetKeywordsByIdsResponse',
            'GetKeywordsByAdGroupIdRequest' => '\\StructType\\GetKeywordsByAdGroupIdRequest',
            'GetKeywordsByAdGroupIdResponse' => '\\StructType\\GetKeywordsByAdGroupIdResponse',
            'UpdateKeywordsRequest' => '\\StructType\\UpdateKeywordsRequest',
            'UpdateKeywordsResponse' => '\\StructType\\UpdateKeywordsResponse',
            'AppealEditorialRejectionsRequest' => '\\StructType\\AppealEditorialRejectionsRequest',
            'ArrayOfEntityIdToParentIdAssociation' => '\\ArrayType\\ArrayOfEntityIdToParentIdAssociation',
            'EntityIdToParentIdAssociation' => '\\StructType\\EntityIdToParentIdAssociation',
            'AppealEditorialRejectionsResponse' => '\\StructType\\AppealEditorialRejectionsResponse',
            'GetEditorialReasonsByIdsRequest' => '\\StructType\\GetEditorialReasonsByIdsRequest',
            'GetEditorialReasonsByIdsResponse' => '\\StructType\\GetEditorialReasonsByIdsResponse',
            'ArrayOfEditorialReasonCollection' => '\\ArrayType\\ArrayOfEditorialReasonCollection',
            'EditorialReasonCollection' => '\\StructType\\EditorialReasonCollection',
            'ArrayOfEditorialReason' => '\\ArrayType\\ArrayOfEditorialReason',
            'EditorialReason' => '\\StructType\\EditorialReason',
            'GetAccountMigrationStatusesRequest' => '\\StructType\\GetAccountMigrationStatusesRequest',
            'GetAccountMigrationStatusesResponse' => '\\StructType\\GetAccountMigrationStatusesResponse',
            'ArrayOfAccountMigrationStatusesInfo' => '\\ArrayType\\ArrayOfAccountMigrationStatusesInfo',
            'AccountMigrationStatusesInfo' => '\\StructType\\AccountMigrationStatusesInfo',
            'ArrayOfMigrationStatusInfo' => '\\ArrayType\\ArrayOfMigrationStatusInfo',
            'MigrationStatusInfo' => '\\StructType\\MigrationStatusInfo',
            'SetAccountPropertiesRequest' => '\\StructType\\SetAccountPropertiesRequest',
            'ArrayOfAccountProperty' => '\\ArrayType\\ArrayOfAccountProperty',
            'AccountProperty' => '\\StructType\\AccountProperty',
            'SetAccountPropertiesResponse' => '\\StructType\\SetAccountPropertiesResponse',
            'GetAccountPropertiesRequest' => '\\StructType\\GetAccountPropertiesRequest',
            'ArrayOfAccountPropertyName' => '\\ArrayType\\ArrayOfAccountPropertyName',
            'GetAccountPropertiesResponse' => '\\StructType\\GetAccountPropertiesResponse',
            'AddAdExtensionsRequest' => '\\StructType\\AddAdExtensionsRequest',
            'ArrayOfAdExtension' => '\\ArrayType\\ArrayOfAdExtension',
            'AdExtension' => '\\StructType\\AdExtension',
            'Schedule' => '\\StructType\\Schedule',
            'ArrayOfDayTime' => '\\ArrayType\\ArrayOfDayTime',
            'DayTime' => '\\StructType\\DayTime',
            'LocationAdExtension' => '\\StructType\\LocationAdExtension',
            'Address' => '\\StructType\\Address',
            'GeoPoint' => '\\StructType\\GeoPoint',
            'CallAdExtension' => '\\StructType\\CallAdExtension',
            'ImageAdExtension' => '\\StructType\\ImageAdExtension',
            'AppAdExtension' => '\\StructType\\AppAdExtension',
            'ReviewAdExtension' => '\\StructType\\ReviewAdExtension',
            'CalloutAdExtension' => '\\StructType\\CalloutAdExtension',
            'SitelinkAdExtension' => '\\StructType\\SitelinkAdExtension',
            'ActionAdExtension' => '\\StructType\\ActionAdExtension',
            'StructuredSnippetAdExtension' => '\\StructType\\StructuredSnippetAdExtension',
            'PriceAdExtension' => '\\StructType\\PriceAdExtension',
            'ArrayOfPriceTableRow' => '\\ArrayType\\ArrayOfPriceTableRow',
            'PriceTableRow' => '\\StructType\\PriceTableRow',
            'PromotionAdExtension' => '\\StructType\\PromotionAdExtension',
            'FilterLinkAdExtension' => '\\StructType\\FilterLinkAdExtension',
            'FlyerAdExtension' => '\\StructType\\FlyerAdExtension',
            'VideoAdExtension' => '\\StructType\\VideoAdExtension',
            'DisclaimerAdExtension' => '\\StructType\\DisclaimerAdExtension',
            'AddAdExtensionsResponse' => '\\StructType\\AddAdExtensionsResponse',
            'ArrayOfAdExtensionIdentity' => '\\ArrayType\\ArrayOfAdExtensionIdentity',
            'AdExtensionIdentity' => '\\StructType\\AdExtensionIdentity',
            'ArrayOfBatchErrorCollection' => '\\ArrayType\\ArrayOfBatchErrorCollection',
            'BatchErrorCollection' => '\\StructType\\BatchErrorCollection',
            'EditorialErrorCollection' => '\\StructType\\EditorialErrorCollection',
            'GetAdExtensionsByIdsRequest' => '\\StructType\\GetAdExtensionsByIdsRequest',
            'GetAdExtensionsByIdsResponse' => '\\StructType\\GetAdExtensionsByIdsResponse',
            'UpdateAdExtensionsRequest' => '\\StructType\\UpdateAdExtensionsRequest',
            'UpdateAdExtensionsResponse' => '\\StructType\\UpdateAdExtensionsResponse',
            'DeleteAdExtensionsRequest' => '\\StructType\\DeleteAdExtensionsRequest',
            'DeleteAdExtensionsResponse' => '\\StructType\\DeleteAdExtensionsResponse',
            'GetAdExtensionsEditorialReasonsRequest' => '\\StructType\\GetAdExtensionsEditorialReasonsRequest',
            'ArrayOfAdExtensionIdToEntityIdAssociation' => '\\ArrayType\\ArrayOfAdExtensionIdToEntityIdAssociation',
            'AdExtensionIdToEntityIdAssociation' => '\\StructType\\AdExtensionIdToEntityIdAssociation',
            'GetAdExtensionsEditorialReasonsResponse' => '\\StructType\\GetAdExtensionsEditorialReasonsResponse',
            'ArrayOfAdExtensionEditorialReasonCollection' => '\\ArrayType\\ArrayOfAdExtensionEditorialReasonCollection',
            'AdExtensionEditorialReasonCollection' => '\\StructType\\AdExtensionEditorialReasonCollection',
            'ArrayOfAdExtensionEditorialReason' => '\\ArrayType\\ArrayOfAdExtensionEditorialReason',
            'AdExtensionEditorialReason' => '\\StructType\\AdExtensionEditorialReason',
            'SetAdExtensionsAssociationsRequest' => '\\StructType\\SetAdExtensionsAssociationsRequest',
            'SetAdExtensionsAssociationsResponse' => '\\StructType\\SetAdExtensionsAssociationsResponse',
            'GetAdExtensionsAssociationsRequest' => '\\StructType\\GetAdExtensionsAssociationsRequest',
            'GetAdExtensionsAssociationsResponse' => '\\StructType\\GetAdExtensionsAssociationsResponse',
            'ArrayOfAdExtensionAssociationCollection' => '\\ArrayType\\ArrayOfAdExtensionAssociationCollection',
            'AdExtensionAssociationCollection' => '\\StructType\\AdExtensionAssociationCollection',
            'ArrayOfAdExtensionAssociation' => '\\ArrayType\\ArrayOfAdExtensionAssociation',
            'AdExtensionAssociation' => '\\StructType\\AdExtensionAssociation',
            'DeleteAdExtensionsAssociationsRequest' => '\\StructType\\DeleteAdExtensionsAssociationsRequest',
            'DeleteAdExtensionsAssociationsResponse' => '\\StructType\\DeleteAdExtensionsAssociationsResponse',
            'GetAdExtensionIdsByAccountIdRequest' => '\\StructType\\GetAdExtensionIdsByAccountIdRequest',
            'GetAdExtensionIdsByAccountIdResponse' => '\\StructType\\GetAdExtensionIdsByAccountIdResponse',
            'AddMediaRequest' => '\\StructType\\AddMediaRequest',
            'ArrayOfMedia' => '\\ArrayType\\ArrayOfMedia',
            'Media' => '\\StructType\\Media',
            'Image' => '\\StructType\\Image',
            'AddMediaResponse' => '\\StructType\\AddMediaResponse',
            'DeleteMediaRequest' => '\\StructType\\DeleteMediaRequest',
            'DeleteMediaResponse' => '\\StructType\\DeleteMediaResponse',
            'GetMediaMetaDataByAccountIdRequest' => '\\StructType\\GetMediaMetaDataByAccountIdRequest',
            'Paging' => '\\StructType\\Paging',
            'GetMediaMetaDataByAccountIdResponse' => '\\StructType\\GetMediaMetaDataByAccountIdResponse',
            'ArrayOfMediaMetaData' => '\\ArrayType\\ArrayOfMediaMetaData',
            'MediaMetaData' => '\\StructType\\MediaMetaData',
            'ArrayOfMediaRepresentation' => '\\ArrayType\\ArrayOfMediaRepresentation',
            'MediaRepresentation' => '\\StructType\\MediaRepresentation',
            'ImageMediaRepresentation' => '\\StructType\\ImageMediaRepresentation',
            'GetMediaMetaDataByIdsRequest' => '\\StructType\\GetMediaMetaDataByIdsRequest',
            'GetMediaMetaDataByIdsResponse' => '\\StructType\\GetMediaMetaDataByIdsResponse',
            'GetMediaAssociationsRequest' => '\\StructType\\GetMediaAssociationsRequest',
            'GetMediaAssociationsResponse' => '\\StructType\\GetMediaAssociationsResponse',
            'ArrayOfArrayOfMediaAssociation' => '\\ArrayType\\ArrayOfArrayOfMediaAssociation',
            'ArrayOfMediaAssociation' => '\\ArrayType\\ArrayOfMediaAssociation',
            'MediaAssociation' => '\\StructType\\MediaAssociation',
            'GetAdGroupCriterionsByIdsRequest' => '\\StructType\\GetAdGroupCriterionsByIdsRequest',
            'GetAdGroupCriterionsByIdsResponse' => '\\StructType\\GetAdGroupCriterionsByIdsResponse',
            'ArrayOfAdGroupCriterion' => '\\ArrayType\\ArrayOfAdGroupCriterion',
            'AdGroupCriterion' => '\\StructType\\AdGroupCriterion',
            'Criterion' => '\\StructType\\Criterion',
            'ProductPartition' => '\\StructType\\ProductPartition',
            'ProductCondition' => '\\StructType\\ProductCondition',
            'ProductScope' => '\\StructType\\ProductScope',
            'ArrayOfProductCondition' => '\\ArrayType\\ArrayOfProductCondition',
            'Webpage' => '\\StructType\\Webpage',
            'WebpageParameter' => '\\StructType\\WebpageParameter',
            'ArrayOfWebpageCondition' => '\\ArrayType\\ArrayOfWebpageCondition',
            'WebpageCondition' => '\\StructType\\WebpageCondition',
            'AgeCriterion' => '\\StructType\\AgeCriterion',
            'DeviceCriterion' => '\\StructType\\DeviceCriterion',
            'DayTimeCriterion' => '\\StructType\\DayTimeCriterion',
            'GenderCriterion' => '\\StructType\\GenderCriterion',
            'RadiusCriterion' => '\\StructType\\RadiusCriterion',
            'LocationCriterion' => '\\StructType\\LocationCriterion',
            'LocationIntentCriterion' => '\\StructType\\LocationIntentCriterion',
            'AudienceCriterion' => '\\StructType\\AudienceCriterion',
            'ProfileCriterion' => '\\StructType\\ProfileCriterion',
            'StoreCriterion' => '\\StructType\\StoreCriterion',
            'BiddableAdGroupCriterion' => '\\StructType\\BiddableAdGroupCriterion',
            'CriterionBid' => '\\StructType\\CriterionBid',
            'FixedBid' => '\\StructType\\FixedBid',
            'BidMultiplier' => '\\StructType\\BidMultiplier',
            'CriterionCashback' => '\\StructType\\CriterionCashback',
            'CashbackAdjustment' => '\\StructType\\CashbackAdjustment',
            'NegativeAdGroupCriterion' => '\\StructType\\NegativeAdGroupCriterion',
            'AddAdGroupCriterionsRequest' => '\\StructType\\AddAdGroupCriterionsRequest',
            'AddAdGroupCriterionsResponse' => '\\StructType\\AddAdGroupCriterionsResponse',
            'UpdateAdGroupCriterionsRequest' => '\\StructType\\UpdateAdGroupCriterionsRequest',
            'UpdateAdGroupCriterionsResponse' => '\\StructType\\UpdateAdGroupCriterionsResponse',
            'DeleteAdGroupCriterionsRequest' => '\\StructType\\DeleteAdGroupCriterionsRequest',
            'DeleteAdGroupCriterionsResponse' => '\\StructType\\DeleteAdGroupCriterionsResponse',
            'ApplyProductPartitionActionsRequest' => '\\StructType\\ApplyProductPartitionActionsRequest',
            'ArrayOfAdGroupCriterionAction' => '\\ArrayType\\ArrayOfAdGroupCriterionAction',
            'AdGroupCriterionAction' => '\\StructType\\AdGroupCriterionAction',
            'ApplyProductPartitionActionsResponse' => '\\StructType\\ApplyProductPartitionActionsResponse',
            'GetBMCStoresByCustomerIdRequest' => '\\StructType\\GetBMCStoresByCustomerIdRequest',
            'GetBMCStoresByCustomerIdResponse' => '\\StructType\\GetBMCStoresByCustomerIdResponse',
            'ArrayOfBMCStore' => '\\ArrayType\\ArrayOfBMCStore',
            'BMCStore' => '\\StructType\\BMCStore',
            'AddNegativeKeywordsToEntitiesRequest' => '\\StructType\\AddNegativeKeywordsToEntitiesRequest',
            'ArrayOfEntityNegativeKeyword' => '\\ArrayType\\ArrayOfEntityNegativeKeyword',
            'EntityNegativeKeyword' => '\\StructType\\EntityNegativeKeyword',
            'ArrayOfNegativeKeyword' => '\\ArrayType\\ArrayOfNegativeKeyword',
            'NegativeKeyword' => '\\StructType\\NegativeKeyword',
            'SharedListItem' => '\\StructType\\SharedListItem',
            'NegativeSite' => '\\StructType\\NegativeSite',
            'AddNegativeKeywordsToEntitiesResponse' => '\\StructType\\AddNegativeKeywordsToEntitiesResponse',
            'ArrayOfIdCollection' => '\\ArrayType\\ArrayOfIdCollection',
            'IdCollection' => '\\StructType\\IdCollection',
            'GetNegativeKeywordsByEntityIdsRequest' => '\\StructType\\GetNegativeKeywordsByEntityIdsRequest',
            'GetNegativeKeywordsByEntityIdsResponse' => '\\StructType\\GetNegativeKeywordsByEntityIdsResponse',
            'DeleteNegativeKeywordsFromEntitiesRequest' => '\\StructType\\DeleteNegativeKeywordsFromEntitiesRequest',
            'DeleteNegativeKeywordsFromEntitiesResponse' => '\\StructType\\DeleteNegativeKeywordsFromEntitiesResponse',
            'GetSharedEntitiesByAccountIdRequest' => '\\StructType\\GetSharedEntitiesByAccountIdRequest',
            'GetSharedEntitiesByAccountIdResponse' => '\\StructType\\GetSharedEntitiesByAccountIdResponse',
            'ArrayOfSharedEntity' => '\\ArrayType\\ArrayOfSharedEntity',
            'SharedEntity' => '\\StructType\\SharedEntity',
            'SharedList' => '\\StructType\\SharedList',
            'NegativeKeywordList' => '\\StructType\\NegativeKeywordList',
            'PlacementExclusionList' => '\\StructType\\PlacementExclusionList',
            'GetSharedEntitiesRequest' => '\\StructType\\GetSharedEntitiesRequest',
            'GetSharedEntitiesResponse' => '\\StructType\\GetSharedEntitiesResponse',
            'AddSharedEntityRequest' => '\\StructType\\AddSharedEntityRequest',
            'ArrayOfSharedListItem' => '\\ArrayType\\ArrayOfSharedListItem',
            'AddSharedEntityResponse' => '\\StructType\\AddSharedEntityResponse',
            'GetListItemsBySharedListRequest' => '\\StructType\\GetListItemsBySharedListRequest',
            'GetListItemsBySharedListResponse' => '\\StructType\\GetListItemsBySharedListResponse',
            'AddListItemsToSharedListRequest' => '\\StructType\\AddListItemsToSharedListRequest',
            'AddListItemsToSharedListResponse' => '\\StructType\\AddListItemsToSharedListResponse',
            'UpdateSharedEntitiesRequest' => '\\StructType\\UpdateSharedEntitiesRequest',
            'UpdateSharedEntitiesResponse' => '\\StructType\\UpdateSharedEntitiesResponse',
            'DeleteListItemsFromSharedListRequest' => '\\StructType\\DeleteListItemsFromSharedListRequest',
            'DeleteListItemsFromSharedListResponse' => '\\StructType\\DeleteListItemsFromSharedListResponse',
            'SetSharedEntityAssociationsRequest' => '\\StructType\\SetSharedEntityAssociationsRequest',
            'ArrayOfSharedEntityAssociation' => '\\ArrayType\\ArrayOfSharedEntityAssociation',
            'SharedEntityAssociation' => '\\StructType\\SharedEntityAssociation',
            'SetSharedEntityAssociationsResponse' => '\\StructType\\SetSharedEntityAssociationsResponse',
            'DeleteSharedEntityAssociationsRequest' => '\\StructType\\DeleteSharedEntityAssociationsRequest',
            'DeleteSharedEntityAssociationsResponse' => '\\StructType\\DeleteSharedEntityAssociationsResponse',
            'GetSharedEntityAssociationsBySharedEntityIdsRequest' => '\\StructType\\GetSharedEntityAssociationsBySharedEntityIdsRequest',
            'GetSharedEntityAssociationsBySharedEntityIdsResponse' => '\\StructType\\GetSharedEntityAssociationsBySharedEntityIdsResponse',
            'GetSharedEntityAssociationsByEntityIdsRequest' => '\\StructType\\GetSharedEntityAssociationsByEntityIdsRequest',
            'GetSharedEntityAssociationsByEntityIdsResponse' => '\\StructType\\GetSharedEntityAssociationsByEntityIdsResponse',
            'DeleteSharedEntitiesRequest' => '\\StructType\\DeleteSharedEntitiesRequest',
            'DeleteSharedEntitiesResponse' => '\\StructType\\DeleteSharedEntitiesResponse',
            'GetCampaignSizesByAccountIdRequest' => '\\StructType\\GetCampaignSizesByAccountIdRequest',
            'GetCampaignSizesByAccountIdResponse' => '\\StructType\\GetCampaignSizesByAccountIdResponse',
            'ArrayOfCampaignSize' => '\\ArrayType\\ArrayOfCampaignSize',
            'CampaignSize' => '\\StructType\\CampaignSize',
            'AddCampaignCriterionsRequest' => '\\StructType\\AddCampaignCriterionsRequest',
            'ArrayOfCampaignCriterion' => '\\ArrayType\\ArrayOfCampaignCriterion',
            'CampaignCriterion' => '\\StructType\\CampaignCriterion',
            'NegativeCampaignCriterion' => '\\StructType\\NegativeCampaignCriterion',
            'BiddableCampaignCriterion' => '\\StructType\\BiddableCampaignCriterion',
            'AddCampaignCriterionsResponse' => '\\StructType\\AddCampaignCriterionsResponse',
            'UpdateCampaignCriterionsRequest' => '\\StructType\\UpdateCampaignCriterionsRequest',
            'UpdateCampaignCriterionsResponse' => '\\StructType\\UpdateCampaignCriterionsResponse',
            'DeleteCampaignCriterionsRequest' => '\\StructType\\DeleteCampaignCriterionsRequest',
            'DeleteCampaignCriterionsResponse' => '\\StructType\\DeleteCampaignCriterionsResponse',
            'GetCampaignCriterionsByIdsRequest' => '\\StructType\\GetCampaignCriterionsByIdsRequest',
            'GetCampaignCriterionsByIdsResponse' => '\\StructType\\GetCampaignCriterionsByIdsResponse',
            'AddBudgetsRequest' => '\\StructType\\AddBudgetsRequest',
            'ArrayOfBudget' => '\\ArrayType\\ArrayOfBudget',
            'Budget' => '\\StructType\\Budget',
            'AddBudgetsResponse' => '\\StructType\\AddBudgetsResponse',
            'UpdateBudgetsRequest' => '\\StructType\\UpdateBudgetsRequest',
            'UpdateBudgetsResponse' => '\\StructType\\UpdateBudgetsResponse',
            'DeleteBudgetsRequest' => '\\StructType\\DeleteBudgetsRequest',
            'DeleteBudgetsResponse' => '\\StructType\\DeleteBudgetsResponse',
            'GetBudgetsByIdsRequest' => '\\StructType\\GetBudgetsByIdsRequest',
            'GetBudgetsByIdsResponse' => '\\StructType\\GetBudgetsByIdsResponse',
            'GetCampaignIdsByBudgetIdsRequest' => '\\StructType\\GetCampaignIdsByBudgetIdsRequest',
            'GetCampaignIdsByBudgetIdsResponse' => '\\StructType\\GetCampaignIdsByBudgetIdsResponse',
            'AddBidStrategiesRequest' => '\\StructType\\AddBidStrategiesRequest',
            'ArrayOfBidStrategy' => '\\ArrayType\\ArrayOfBidStrategy',
            'BidStrategy' => '\\StructType\\BidStrategy',
            'AddBidStrategiesResponse' => '\\StructType\\AddBidStrategiesResponse',
            'UpdateBidStrategiesRequest' => '\\StructType\\UpdateBidStrategiesRequest',
            'UpdateBidStrategiesResponse' => '\\StructType\\UpdateBidStrategiesResponse',
            'DeleteBidStrategiesRequest' => '\\StructType\\DeleteBidStrategiesRequest',
            'DeleteBidStrategiesResponse' => '\\StructType\\DeleteBidStrategiesResponse',
            'GetBidStrategiesByIdsRequest' => '\\StructType\\GetBidStrategiesByIdsRequest',
            'GetBidStrategiesByIdsResponse' => '\\StructType\\GetBidStrategiesByIdsResponse',
            'GetCampaignIdsByBidStrategyIdsRequest' => '\\StructType\\GetCampaignIdsByBidStrategyIdsRequest',
            'GetCampaignIdsByBidStrategyIdsResponse' => '\\StructType\\GetCampaignIdsByBidStrategyIdsResponse',
            'AddAudiencesRequest' => '\\StructType\\AddAudiencesRequest',
            'ArrayOfAudience' => '\\ArrayType\\ArrayOfAudience',
            'Audience' => '\\StructType\\Audience',
            'CustomerShare' => '\\StructType\\CustomerShare',
            'ArrayOfCustomerAccountShare' => '\\ArrayType\\ArrayOfCustomerAccountShare',
            'CustomerAccountShare' => '\\StructType\\CustomerAccountShare',
            'ArrayOfCustomerAccountShareAssociation' => '\\ArrayType\\ArrayOfCustomerAccountShareAssociation',
            'CustomerAccountShareAssociation' => '\\StructType\\CustomerAccountShareAssociation',
            'RemarketingList' => '\\StructType\\RemarketingList',
            'RemarketingRule' => '\\StructType\\RemarketingRule',
            'PageVisitorsRule' => '\\StructType\\PageVisitorsRule',
            'ArrayOfRuleItemGroup' => '\\ArrayType\\ArrayOfRuleItemGroup',
            'RuleItemGroup' => '\\StructType\\RuleItemGroup',
            'ArrayOfRuleItem' => '\\ArrayType\\ArrayOfRuleItem',
            'RuleItem' => '\\StructType\\RuleItem',
            'StringRuleItem' => '\\StructType\\StringRuleItem',
            'PageVisitorsWhoVisitedAnotherPageRule' => '\\StructType\\PageVisitorsWhoVisitedAnotherPageRule',
            'PageVisitorsWhoDidNotVisitAnotherPageRule' => '\\StructType\\PageVisitorsWhoDidNotVisitAnotherPageRule',
            'CustomEventsRule' => '\\StructType\\CustomEventsRule',
            'CustomAudience' => '\\StructType\\CustomAudience',
            'InMarketAudience' => '\\StructType\\InMarketAudience',
            'ProductAudience' => '\\StructType\\ProductAudience',
            'SimilarRemarketingList' => '\\StructType\\SimilarRemarketingList',
            'CombinedList' => '\\StructType\\CombinedList',
            'ArrayOfCombinationRule' => '\\ArrayType\\ArrayOfCombinationRule',
            'CombinationRule' => '\\StructType\\CombinationRule',
            'AddAudiencesResponse' => '\\StructType\\AddAudiencesResponse',
            'UpdateAudiencesRequest' => '\\StructType\\UpdateAudiencesRequest',
            'UpdateAudiencesResponse' => '\\StructType\\UpdateAudiencesResponse',
            'DeleteAudiencesRequest' => '\\StructType\\DeleteAudiencesRequest',
            'DeleteAudiencesResponse' => '\\StructType\\DeleteAudiencesResponse',
            'GetAudiencesByIdsRequest' => '\\StructType\\GetAudiencesByIdsRequest',
            'GetAudiencesByIdsResponse' => '\\StructType\\GetAudiencesByIdsResponse',
            'GetUetTagsByIdsRequest' => '\\StructType\\GetUetTagsByIdsRequest',
            'GetUetTagsByIdsResponse' => '\\StructType\\GetUetTagsByIdsResponse',
            'ArrayOfUetTag' => '\\ArrayType\\ArrayOfUetTag',
            'UetTag' => '\\StructType\\UetTag',
            'AddUetTagsRequest' => '\\StructType\\AddUetTagsRequest',
            'AddUetTagsResponse' => '\\StructType\\AddUetTagsResponse',
            'UpdateUetTagsRequest' => '\\StructType\\UpdateUetTagsRequest',
            'UpdateUetTagsResponse' => '\\StructType\\UpdateUetTagsResponse',
            'GetConversionGoalsByIdsRequest' => '\\StructType\\GetConversionGoalsByIdsRequest',
            'GetConversionGoalsByIdsResponse' => '\\StructType\\GetConversionGoalsByIdsResponse',
            'ArrayOfConversionGoal' => '\\ArrayType\\ArrayOfConversionGoal',
            'ConversionGoal' => '\\StructType\\ConversionGoal',
            'ConversionGoalRevenue' => '\\StructType\\ConversionGoalRevenue',
            'UrlGoal' => '\\StructType\\UrlGoal',
            'DurationGoal' => '\\StructType\\DurationGoal',
            'PagesViewedPerVisitGoal' => '\\StructType\\PagesViewedPerVisitGoal',
            'EventGoal' => '\\StructType\\EventGoal',
            'AppInstallGoal' => '\\StructType\\AppInstallGoal',
            'OfflineConversionGoal' => '\\StructType\\OfflineConversionGoal',
            'InStoreTransactionGoal' => '\\StructType\\InStoreTransactionGoal',
            'GetConversionGoalsByTagIdsRequest' => '\\StructType\\GetConversionGoalsByTagIdsRequest',
            'GetConversionGoalsByTagIdsResponse' => '\\StructType\\GetConversionGoalsByTagIdsResponse',
            'AddConversionGoalsRequest' => '\\StructType\\AddConversionGoalsRequest',
            'AddConversionGoalsResponse' => '\\StructType\\AddConversionGoalsResponse',
            'UpdateConversionGoalsRequest' => '\\StructType\\UpdateConversionGoalsRequest',
            'UpdateConversionGoalsResponse' => '\\StructType\\UpdateConversionGoalsResponse',
            'ApplyOfflineConversionsRequest' => '\\StructType\\ApplyOfflineConversionsRequest',
            'ArrayOfOfflineConversion' => '\\ArrayType\\ArrayOfOfflineConversion',
            'OfflineConversion' => '\\StructType\\OfflineConversion',
            'ApplyOfflineConversionsResponse' => '\\StructType\\ApplyOfflineConversionsResponse',
            'ApplyOfflineConversionAdjustmentsRequest' => '\\StructType\\ApplyOfflineConversionAdjustmentsRequest',
            'ArrayOfOfflineConversionAdjustment' => '\\ArrayType\\ArrayOfOfflineConversionAdjustment',
            'OfflineConversionAdjustment' => '\\StructType\\OfflineConversionAdjustment',
            'ApplyOfflineConversionAdjustmentsResponse' => '\\StructType\\ApplyOfflineConversionAdjustmentsResponse',
            'AddLabelsRequest' => '\\StructType\\AddLabelsRequest',
            'ArrayOfLabel' => '\\ArrayType\\ArrayOfLabel',
            'Label' => '\\StructType\\Label',
            'AddLabelsResponse' => '\\StructType\\AddLabelsResponse',
            'DeleteLabelsRequest' => '\\StructType\\DeleteLabelsRequest',
            'DeleteLabelsResponse' => '\\StructType\\DeleteLabelsResponse',
            'UpdateLabelsRequest' => '\\StructType\\UpdateLabelsRequest',
            'UpdateLabelsResponse' => '\\StructType\\UpdateLabelsResponse',
            'GetLabelsByIdsRequest' => '\\StructType\\GetLabelsByIdsRequest',
            'GetLabelsByIdsResponse' => '\\StructType\\GetLabelsByIdsResponse',
            'SetLabelAssociationsRequest' => '\\StructType\\SetLabelAssociationsRequest',
            'ArrayOfLabelAssociation' => '\\ArrayType\\ArrayOfLabelAssociation',
            'LabelAssociation' => '\\StructType\\LabelAssociation',
            'SetLabelAssociationsResponse' => '\\StructType\\SetLabelAssociationsResponse',
            'DeleteLabelAssociationsRequest' => '\\StructType\\DeleteLabelAssociationsRequest',
            'DeleteLabelAssociationsResponse' => '\\StructType\\DeleteLabelAssociationsResponse',
            'GetLabelAssociationsByEntityIdsRequest' => '\\StructType\\GetLabelAssociationsByEntityIdsRequest',
            'GetLabelAssociationsByEntityIdsResponse' => '\\StructType\\GetLabelAssociationsByEntityIdsResponse',
            'GetLabelAssociationsByLabelIdsRequest' => '\\StructType\\GetLabelAssociationsByLabelIdsRequest',
            'GetLabelAssociationsByLabelIdsResponse' => '\\StructType\\GetLabelAssociationsByLabelIdsResponse',
            'AddExperimentsRequest' => '\\StructType\\AddExperimentsRequest',
            'ArrayOfExperiment' => '\\ArrayType\\ArrayOfExperiment',
            'Experiment' => '\\StructType\\Experiment',
            'AddExperimentsResponse' => '\\StructType\\AddExperimentsResponse',
            'DeleteExperimentsRequest' => '\\StructType\\DeleteExperimentsRequest',
            'DeleteExperimentsResponse' => '\\StructType\\DeleteExperimentsResponse',
            'UpdateExperimentsRequest' => '\\StructType\\UpdateExperimentsRequest',
            'UpdateExperimentsResponse' => '\\StructType\\UpdateExperimentsResponse',
            'GetExperimentsByIdsRequest' => '\\StructType\\GetExperimentsByIdsRequest',
            'GetExperimentsByIdsResponse' => '\\StructType\\GetExperimentsByIdsResponse',
            'GetProfileDataFileUrlRequest' => '\\StructType\\GetProfileDataFileUrlRequest',
            'GetProfileDataFileUrlResponse' => '\\StructType\\GetProfileDataFileUrlResponse',
            'SearchCompaniesRequest' => '\\StructType\\SearchCompaniesRequest',
            'SearchCompaniesResponse' => '\\StructType\\SearchCompaniesResponse',
            'ArrayOfCompany' => '\\ArrayType\\ArrayOfCompany',
            'Company' => '\\StructType\\Company',
            'GetFileImportUploadUrlRequest' => '\\StructType\\GetFileImportUploadUrlRequest',
            'GetFileImportUploadUrlResponse' => '\\StructType\\GetFileImportUploadUrlResponse',
            'AddImportJobsRequest' => '\\StructType\\AddImportJobsRequest',
            'ArrayOfImportJob' => '\\ArrayType\\ArrayOfImportJob',
            'ImportJob' => '\\StructType\\ImportJob',
            'Frequency' => '\\StructType\\Frequency',
            'ImportOption' => '\\StructType\\ImportOption',
            'GoogleImportOption' => '\\StructType\\GoogleImportOption',
            'ImportSearchAndReplaceForStringProperty' => '\\StructType\\ImportSearchAndReplaceForStringProperty',
            'FileImportOption' => '\\StructType\\FileImportOption',
            'GoogleImportJob' => '\\StructType\\GoogleImportJob',
            'ArrayOfCampaignAdGroupIds' => '\\ArrayType\\ArrayOfCampaignAdGroupIds',
            'CampaignAdGroupIds' => '\\StructType\\CampaignAdGroupIds',
            'FileImportJob' => '\\StructType\\FileImportJob',
            'AddImportJobsResponse' => '\\StructType\\AddImportJobsResponse',
            'GetImportResultsRequest' => '\\StructType\\GetImportResultsRequest',
            'GetImportResultsResponse' => '\\StructType\\GetImportResultsResponse',
            'ArrayOfImportResult' => '\\ArrayType\\ArrayOfImportResult',
            'ImportResult' => '\\StructType\\ImportResult',
            'ArrayOfImportEntityStatistics' => '\\ArrayType\\ArrayOfImportEntityStatistics',
            'ImportEntityStatistics' => '\\StructType\\ImportEntityStatistics',
            'GetImportJobsByIdsRequest' => '\\StructType\\GetImportJobsByIdsRequest',
            'GetImportJobsByIdsResponse' => '\\StructType\\GetImportJobsByIdsResponse',
            'DeleteImportJobsRequest' => '\\StructType\\DeleteImportJobsRequest',
            'DeleteImportJobsResponse' => '\\StructType\\DeleteImportJobsResponse',
            'GetImportEntityIdsMappingRequest' => '\\StructType\\GetImportEntityIdsMappingRequest',
            'GetImportEntityIdsMappingResponse' => '\\StructType\\GetImportEntityIdsMappingResponse',
            'UpdateImportJobsRequest' => '\\StructType\\UpdateImportJobsRequest',
            'UpdateImportJobsResponse' => '\\StructType\\UpdateImportJobsResponse',
            'AddVideosRequest' => '\\StructType\\AddVideosRequest',
            'ArrayOfVideo' => '\\ArrayType\\ArrayOfVideo',
            'Video' => '\\StructType\\Video',
            'AddVideosResponse' => '\\StructType\\AddVideosResponse',
            'DeleteVideosRequest' => '\\StructType\\DeleteVideosRequest',
            'DeleteVideosResponse' => '\\StructType\\DeleteVideosResponse',
            'GetVideosByIdsRequest' => '\\StructType\\GetVideosByIdsRequest',
            'GetVideosByIdsResponse' => '\\StructType\\GetVideosByIdsResponse',
            'UpdateVideosRequest' => '\\StructType\\UpdateVideosRequest',
            'UpdateVideosResponse' => '\\StructType\\UpdateVideosResponse',
            'ArrayOfstring' => '\\ArrayType\\ArrayOfstring',
            'ArrayOfKeyValueOfstringstring' => '\\ArrayType\\ArrayOfKeyValueOfstringstring',
            'KeyValueOfstringstring' => '\\StructType\\KeyValueOfstringstring',
            'ArrayOflong' => '\\ArrayType\\ArrayOflong',
            'ArrayOfKeyValuePairOfstringstring' => '\\ArrayType\\ArrayOfKeyValuePairOfstringstring',
            'KeyValuePairOfstringstring' => '\\StructType\\KeyValuePairOfstringstring',
            'ArrayOfArrayOfKeyValuePairOfstringstring' => '\\ArrayType\\ArrayOfArrayOfKeyValuePairOfstringstring',
            'ArrayOfKeyValuePairOflonglong' => '\\ArrayType\\ArrayOfKeyValuePairOflonglong',
            'KeyValuePairOflonglong' => '\\StructType\\KeyValuePairOflonglong',
            'ArrayOfNullableOflong' => '\\ArrayType\\ArrayOfNullableOflong',
            'AdApiFaultDetail' => '\\StructType\\AdApiFaultDetail',
            'ApplicationFault' => '\\StructType\\ApplicationFault',
            'ArrayOfAdApiError' => '\\ArrayType\\ArrayOfAdApiError',
            'AdApiError' => '\\StructType\\AdApiError',
        );
    }
}
