<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AddBidStrategiesResponse StructType
 * @subpackage Structs
 */
class AddBidStrategiesResponse extends AbstractStructBase
{
    /**
     * The BidStrategyIds
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfNullableOflong
     */
    public $BidStrategyIds;
    /**
     * The PartialErrors
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfBatchError
     */
    public $PartialErrors;
    /**
     * Constructor method for AddBidStrategiesResponse
     * @uses AddBidStrategiesResponse::setBidStrategyIds()
     * @uses AddBidStrategiesResponse::setPartialErrors()
     * @param \ArrayType\ArrayOfNullableOflong $bidStrategyIds
     * @param \ArrayType\ArrayOfBatchError $partialErrors
     */
    public function __construct(\ArrayType\ArrayOfNullableOflong $bidStrategyIds = null, \ArrayType\ArrayOfBatchError $partialErrors = null)
    {
        $this
            ->setBidStrategyIds($bidStrategyIds)
            ->setPartialErrors($partialErrors);
    }
    /**
     * Get BidStrategyIds value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfNullableOflong|null
     */
    public function getBidStrategyIds()
    {
        return isset($this->BidStrategyIds) ? $this->BidStrategyIds : null;
    }
    /**
     * Set BidStrategyIds value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfNullableOflong $bidStrategyIds
     * @return \StructType\AddBidStrategiesResponse
     */
    public function setBidStrategyIds(\ArrayType\ArrayOfNullableOflong $bidStrategyIds = null)
    {
        if (is_null($bidStrategyIds) || (is_array($bidStrategyIds) && empty($bidStrategyIds))) {
            unset($this->BidStrategyIds);
        } else {
            $this->BidStrategyIds = $bidStrategyIds;
        }
        return $this;
    }
    /**
     * Get PartialErrors value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfBatchError|null
     */
    public function getPartialErrors()
    {
        return isset($this->PartialErrors) ? $this->PartialErrors : null;
    }
    /**
     * Set PartialErrors value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfBatchError $partialErrors
     * @return \StructType\AddBidStrategiesResponse
     */
    public function setPartialErrors(\ArrayType\ArrayOfBatchError $partialErrors = null)
    {
        if (is_null($partialErrors) || (is_array($partialErrors) && empty($partialErrors))) {
            unset($this->PartialErrors);
        } else {
            $this->PartialErrors = $partialErrors;
        }
        return $this;
    }
}
