<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AddNegativeKeywordsToEntitiesResponse StructType
 * @subpackage Structs
 */
class AddNegativeKeywordsToEntitiesResponse extends AbstractStructBase
{
    /**
     * The NegativeKeywordIds
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfIdCollection
     */
    public $NegativeKeywordIds;
    /**
     * The NestedPartialErrors
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfBatchErrorCollection
     */
    public $NestedPartialErrors;
    /**
     * Constructor method for AddNegativeKeywordsToEntitiesResponse
     * @uses AddNegativeKeywordsToEntitiesResponse::setNegativeKeywordIds()
     * @uses AddNegativeKeywordsToEntitiesResponse::setNestedPartialErrors()
     * @param \ArrayType\ArrayOfIdCollection $negativeKeywordIds
     * @param \ArrayType\ArrayOfBatchErrorCollection $nestedPartialErrors
     */
    public function __construct(\ArrayType\ArrayOfIdCollection $negativeKeywordIds = null, \ArrayType\ArrayOfBatchErrorCollection $nestedPartialErrors = null)
    {
        $this
            ->setNegativeKeywordIds($negativeKeywordIds)
            ->setNestedPartialErrors($nestedPartialErrors);
    }
    /**
     * Get NegativeKeywordIds value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfIdCollection|null
     */
    public function getNegativeKeywordIds()
    {
        return isset($this->NegativeKeywordIds) ? $this->NegativeKeywordIds : null;
    }
    /**
     * Set NegativeKeywordIds value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfIdCollection $negativeKeywordIds
     * @return \StructType\AddNegativeKeywordsToEntitiesResponse
     */
    public function setNegativeKeywordIds(\ArrayType\ArrayOfIdCollection $negativeKeywordIds = null)
    {
        if (is_null($negativeKeywordIds) || (is_array($negativeKeywordIds) && empty($negativeKeywordIds))) {
            unset($this->NegativeKeywordIds);
        } else {
            $this->NegativeKeywordIds = $negativeKeywordIds;
        }
        return $this;
    }
    /**
     * Get NestedPartialErrors value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfBatchErrorCollection|null
     */
    public function getNestedPartialErrors()
    {
        return isset($this->NestedPartialErrors) ? $this->NestedPartialErrors : null;
    }
    /**
     * Set NestedPartialErrors value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfBatchErrorCollection $nestedPartialErrors
     * @return \StructType\AddNegativeKeywordsToEntitiesResponse
     */
    public function setNestedPartialErrors(\ArrayType\ArrayOfBatchErrorCollection $nestedPartialErrors = null)
    {
        if (is_null($nestedPartialErrors) || (is_array($nestedPartialErrors) && empty($nestedPartialErrors))) {
            unset($this->NestedPartialErrors);
        } else {
            $this->NestedPartialErrors = $nestedPartialErrors;
        }
        return $this;
    }
}
