<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AgeCriterion StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:AgeCriterion
 * @subpackage Structs
 */
class AgeCriterion extends Criterion
{
    /**
     * The AgeRange
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $AgeRange;
    /**
     * Constructor method for AgeCriterion
     * @uses AgeCriterion::setAgeRange()
     * @param string $ageRange
     */
    public function __construct($ageRange = null)
    {
        $this
            ->setAgeRange($ageRange);
    }
    /**
     * Get AgeRange value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getAgeRange()
    {
        return isset($this->AgeRange) ? $this->AgeRange : null;
    }
    /**
     * Set AgeRange value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @uses \EnumType\AgeRange::valueIsValid()
     * @uses \EnumType\AgeRange::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $ageRange
     * @return \StructType\AgeCriterion
     */
    public function setAgeRange($ageRange = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\AgeRange::valueIsValid($ageRange)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\AgeRange', is_array($ageRange) ? implode(', ', $ageRange) : var_export($ageRange, true), implode(', ', \EnumType\AgeRange::getValidValues())), __LINE__);
        }
        if (is_null($ageRange) || (is_array($ageRange) && empty($ageRange))) {
            unset($this->AgeRange);
        } else {
            $this->AgeRange = $ageRange;
        }
        return $this;
    }
}
