<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AppInstallAd StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:AppInstallAd
 * @subpackage Structs
 */
class AppInstallAd extends Ad
{
    /**
     * The AppPlatform
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $AppPlatform;
    /**
     * The AppStoreId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $AppStoreId;
    /**
     * The Text
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Text;
    /**
     * The Title
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Title;
    /**
     * Constructor method for AppInstallAd
     * @uses AppInstallAd::setAppPlatform()
     * @uses AppInstallAd::setAppStoreId()
     * @uses AppInstallAd::setText()
     * @uses AppInstallAd::setTitle()
     * @param string $appPlatform
     * @param string $appStoreId
     * @param string $text
     * @param string $title
     */
    public function __construct($appPlatform = null, $appStoreId = null, $text = null, $title = null)
    {
        $this
            ->setAppPlatform($appPlatform)
            ->setAppStoreId($appStoreId)
            ->setText($text)
            ->setTitle($title);
    }
    /**
     * Get AppPlatform value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getAppPlatform()
    {
        return isset($this->AppPlatform) ? $this->AppPlatform : null;
    }
    /**
     * Set AppPlatform value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $appPlatform
     * @return \StructType\AppInstallAd
     */
    public function setAppPlatform($appPlatform = null)
    {
        // validation for constraint: string
        if (!is_null($appPlatform) && !is_string($appPlatform)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($appPlatform, true), gettype($appPlatform)), __LINE__);
        }
        if (is_null($appPlatform) || (is_array($appPlatform) && empty($appPlatform))) {
            unset($this->AppPlatform);
        } else {
            $this->AppPlatform = $appPlatform;
        }
        return $this;
    }
    /**
     * Get AppStoreId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getAppStoreId()
    {
        return isset($this->AppStoreId) ? $this->AppStoreId : null;
    }
    /**
     * Set AppStoreId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $appStoreId
     * @return \StructType\AppInstallAd
     */
    public function setAppStoreId($appStoreId = null)
    {
        // validation for constraint: string
        if (!is_null($appStoreId) && !is_string($appStoreId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($appStoreId, true), gettype($appStoreId)), __LINE__);
        }
        if (is_null($appStoreId) || (is_array($appStoreId) && empty($appStoreId))) {
            unset($this->AppStoreId);
        } else {
            $this->AppStoreId = $appStoreId;
        }
        return $this;
    }
    /**
     * Get Text value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getText()
    {
        return isset($this->Text) ? $this->Text : null;
    }
    /**
     * Set Text value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $text
     * @return \StructType\AppInstallAd
     */
    public function setText($text = null)
    {
        // validation for constraint: string
        if (!is_null($text) && !is_string($text)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($text, true), gettype($text)), __LINE__);
        }
        if (is_null($text) || (is_array($text) && empty($text))) {
            unset($this->Text);
        } else {
            $this->Text = $text;
        }
        return $this;
    }
    /**
     * Get Title value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getTitle()
    {
        return isset($this->Title) ? $this->Title : null;
    }
    /**
     * Set Title value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $title
     * @return \StructType\AppInstallAd
     */
    public function setTitle($title = null)
    {
        // validation for constraint: string
        if (!is_null($title) && !is_string($title)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($title, true), gettype($title)), __LINE__);
        }
        if (is_null($title) || (is_array($title) && empty($title))) {
            unset($this->Title);
        } else {
            $this->Title = $title;
        }
        return $this;
    }
}
