<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AppInstallGoal StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:AppInstallGoal
 * @subpackage Structs
 */
class AppInstallGoal extends ConversionGoal
{
    /**
     * The AppPlatform
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $AppPlatform;
    /**
     * The AppStoreId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $AppStoreId;
    /**
     * Constructor method for AppInstallGoal
     * @uses AppInstallGoal::setAppPlatform()
     * @uses AppInstallGoal::setAppStoreId()
     * @param string $appPlatform
     * @param string $appStoreId
     */
    public function __construct($appPlatform = null, $appStoreId = null)
    {
        $this
            ->setAppPlatform($appPlatform)
            ->setAppStoreId($appStoreId);
    }
    /**
     * Get AppPlatform value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getAppPlatform()
    {
        return isset($this->AppPlatform) ? $this->AppPlatform : null;
    }
    /**
     * Set AppPlatform value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $appPlatform
     * @return \StructType\AppInstallGoal
     */
    public function setAppPlatform($appPlatform = null)
    {
        // validation for constraint: string
        if (!is_null($appPlatform) && !is_string($appPlatform)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($appPlatform, true), gettype($appPlatform)), __LINE__);
        }
        if (is_null($appPlatform) || (is_array($appPlatform) && empty($appPlatform))) {
            unset($this->AppPlatform);
        } else {
            $this->AppPlatform = $appPlatform;
        }
        return $this;
    }
    /**
     * Get AppStoreId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getAppStoreId()
    {
        return isset($this->AppStoreId) ? $this->AppStoreId : null;
    }
    /**
     * Set AppStoreId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $appStoreId
     * @return \StructType\AppInstallGoal
     */
    public function setAppStoreId($appStoreId = null)
    {
        // validation for constraint: string
        if (!is_null($appStoreId) && !is_string($appStoreId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($appStoreId, true), gettype($appStoreId)), __LINE__);
        }
        if (is_null($appStoreId) || (is_array($appStoreId) && empty($appStoreId))) {
            unset($this->AppStoreId);
        } else {
            $this->AppStoreId = $appStoreId;
        }
        return $this;
    }
}
