<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AppUrl StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:AppUrl
 * @subpackage Structs
 */
class AppUrl extends AbstractStructBase
{
    /**
     * The OsType
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $OsType;
    /**
     * The Url
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Url;
    /**
     * Constructor method for AppUrl
     * @uses AppUrl::setOsType()
     * @uses AppUrl::setUrl()
     * @param string $osType
     * @param string $url
     */
    public function __construct($osType = null, $url = null)
    {
        $this
            ->setOsType($osType)
            ->setUrl($url);
    }
    /**
     * Get OsType value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getOsType()
    {
        return isset($this->OsType) ? $this->OsType : null;
    }
    /**
     * Set OsType value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $osType
     * @return \StructType\AppUrl
     */
    public function setOsType($osType = null)
    {
        // validation for constraint: string
        if (!is_null($osType) && !is_string($osType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($osType, true), gettype($osType)), __LINE__);
        }
        if (is_null($osType) || (is_array($osType) && empty($osType))) {
            unset($this->OsType);
        } else {
            $this->OsType = $osType;
        }
        return $this;
    }
    /**
     * Get Url value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getUrl()
    {
        return isset($this->Url) ? $this->Url : null;
    }
    /**
     * Set Url value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $url
     * @return \StructType\AppUrl
     */
    public function setUrl($url = null)
    {
        // validation for constraint: string
        if (!is_null($url) && !is_string($url)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($url, true), gettype($url)), __LINE__);
        }
        if (is_null($url) || (is_array($url) && empty($url))) {
            unset($this->Url);
        } else {
            $this->Url = $url;
        }
        return $this;
    }
}
