<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for BidMultiplier StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:BidMultiplier
 * @subpackage Structs
 */
class BidMultiplier extends CriterionBid
{
    /**
     * The Multiplier
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $Multiplier;
    /**
     * Constructor method for BidMultiplier
     * @uses BidMultiplier::setMultiplier()
     * @param float $multiplier
     */
    public function __construct($multiplier = null)
    {
        $this
            ->setMultiplier($multiplier);
    }
    /**
     * Get Multiplier value
     * @return float|null
     */
    public function getMultiplier()
    {
        return $this->Multiplier;
    }
    /**
     * Set Multiplier value
     * @param float $multiplier
     * @return \StructType\BidMultiplier
     */
    public function setMultiplier($multiplier = null)
    {
        // validation for constraint: float
        if (!is_null($multiplier) && !(is_float($multiplier) || is_numeric($multiplier))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($multiplier, true), gettype($multiplier)), __LINE__);
        }
        $this->Multiplier = $multiplier;
        return $this;
    }
}
