<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for BiddableCampaignCriterion StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:BiddableCampaignCriterion
 * @subpackage Structs
 */
class BiddableCampaignCriterion extends CampaignCriterion
{
    /**
     * The CriterionBid
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\CriterionBid
     */
    public $CriterionBid;
    /**
     * The CriterionCashback
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\CriterionCashback
     */
    public $CriterionCashback;
    /**
     * Constructor method for BiddableCampaignCriterion
     * @uses BiddableCampaignCriterion::setCriterionBid()
     * @uses BiddableCampaignCriterion::setCriterionCashback()
     * @param \StructType\CriterionBid $criterionBid
     * @param \StructType\CriterionCashback $criterionCashback
     */
    public function __construct(\StructType\CriterionBid $criterionBid = null, \StructType\CriterionCashback $criterionCashback = null)
    {
        $this
            ->setCriterionBid($criterionBid)
            ->setCriterionCashback($criterionCashback);
    }
    /**
     * Get CriterionBid value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\CriterionBid|null
     */
    public function getCriterionBid()
    {
        return isset($this->CriterionBid) ? $this->CriterionBid : null;
    }
    /**
     * Set CriterionBid value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\CriterionBid $criterionBid
     * @return \StructType\BiddableCampaignCriterion
     */
    public function setCriterionBid(\StructType\CriterionBid $criterionBid = null)
    {
        if (is_null($criterionBid) || (is_array($criterionBid) && empty($criterionBid))) {
            unset($this->CriterionBid);
        } else {
            $this->CriterionBid = $criterionBid;
        }
        return $this;
    }
    /**
     * Get CriterionCashback value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\CriterionCashback|null
     */
    public function getCriterionCashback()
    {
        return isset($this->CriterionCashback) ? $this->CriterionCashback : null;
    }
    /**
     * Set CriterionCashback value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\CriterionCashback $criterionCashback
     * @return \StructType\BiddableCampaignCriterion
     */
    public function setCriterionCashback(\StructType\CriterionCashback $criterionCashback = null)
    {
        if (is_null($criterionCashback) || (is_array($criterionCashback) && empty($criterionCashback))) {
            unset($this->CriterionCashback);
        } else {
            $this->CriterionCashback = $criterionCashback;
        }
        return $this;
    }
}
