<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CombinedList StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:CombinedList
 * @subpackage Structs
 */
class CombinedList extends Audience
{
    /**
     * The CombinationRules
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfCombinationRule
     */
    public $CombinationRules;
    /**
     * Constructor method for CombinedList
     * @uses CombinedList::setCombinationRules()
     * @param \ArrayType\ArrayOfCombinationRule $combinationRules
     */
    public function __construct(\ArrayType\ArrayOfCombinationRule $combinationRules = null)
    {
        $this
            ->setCombinationRules($combinationRules);
    }
    /**
     * Get CombinationRules value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfCombinationRule|null
     */
    public function getCombinationRules()
    {
        return isset($this->CombinationRules) ? $this->CombinationRules : null;
    }
    /**
     * Set CombinationRules value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfCombinationRule $combinationRules
     * @return \StructType\CombinedList
     */
    public function setCombinationRules(\ArrayType\ArrayOfCombinationRule $combinationRules = null)
    {
        if (is_null($combinationRules) || (is_array($combinationRules) && empty($combinationRules))) {
            unset($this->CombinationRules);
        } else {
            $this->CombinationRules = $combinationRules;
        }
        return $this;
    }
}
