<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CustomParameters StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:CustomParameters
 * @subpackage Structs
 */
class CustomParameters extends AbstractStructBase
{
    /**
     * The Parameters
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfCustomParameter
     */
    public $Parameters;
    /**
     * Constructor method for CustomParameters
     * @uses CustomParameters::setParameters()
     * @param \ArrayType\ArrayOfCustomParameter $parameters
     */
    public function __construct(\ArrayType\ArrayOfCustomParameter $parameters = null)
    {
        $this
            ->setParameters($parameters);
    }
    /**
     * Get Parameters value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfCustomParameter|null
     */
    public function getParameters()
    {
        return isset($this->Parameters) ? $this->Parameters : null;
    }
    /**
     * Set Parameters value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfCustomParameter $parameters
     * @return \StructType\CustomParameters
     */
    public function setParameters(\ArrayType\ArrayOfCustomParameter $parameters = null)
    {
        if (is_null($parameters) || (is_array($parameters) && empty($parameters))) {
            unset($this->Parameters);
        } else {
            $this->Parameters = $parameters;
        }
        return $this;
    }
}
