<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DynamicFeedSetting StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:DynamicFeedSetting
 * @subpackage Structs
 */
class DynamicFeedSetting extends Setting
{
    /**
     * The FeedId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $FeedId;
    /**
     * Constructor method for DynamicFeedSetting
     * @uses DynamicFeedSetting::setFeedId()
     * @param int $feedId
     */
    public function __construct($feedId = null)
    {
        $this
            ->setFeedId($feedId);
    }
    /**
     * Get FeedId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getFeedId()
    {
        return isset($this->FeedId) ? $this->FeedId : null;
    }
    /**
     * Set FeedId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $feedId
     * @return \StructType\DynamicFeedSetting
     */
    public function setFeedId($feedId = null)
    {
        // validation for constraint: int
        if (!is_null($feedId) && !(is_int($feedId) || ctype_digit($feedId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($feedId, true), gettype($feedId)), __LINE__);
        }
        if (is_null($feedId) || (is_array($feedId) && empty($feedId))) {
            unset($this->FeedId);
        } else {
            $this->FeedId = $feedId;
        }
        return $this;
    }
}
