<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DynamicSearchAd StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:DynamicSearchAd
 * @subpackage Structs
 */
class DynamicSearchAd extends Ad
{
    /**
     * The Path1
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Path1;
    /**
     * The Path2
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Path2;
    /**
     * The Text
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Text;
    /**
     * The TextPart2
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $TextPart2;
    /**
     * Constructor method for DynamicSearchAd
     * @uses DynamicSearchAd::setPath1()
     * @uses DynamicSearchAd::setPath2()
     * @uses DynamicSearchAd::setText()
     * @uses DynamicSearchAd::setTextPart2()
     * @param string $path1
     * @param string $path2
     * @param string $text
     * @param string $textPart2
     */
    public function __construct($path1 = null, $path2 = null, $text = null, $textPart2 = null)
    {
        $this
            ->setPath1($path1)
            ->setPath2($path2)
            ->setText($text)
            ->setTextPart2($textPart2);
    }
    /**
     * Get Path1 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getPath1()
    {
        return isset($this->Path1) ? $this->Path1 : null;
    }
    /**
     * Set Path1 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $path1
     * @return \StructType\DynamicSearchAd
     */
    public function setPath1($path1 = null)
    {
        // validation for constraint: string
        if (!is_null($path1) && !is_string($path1)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($path1, true), gettype($path1)), __LINE__);
        }
        if (is_null($path1) || (is_array($path1) && empty($path1))) {
            unset($this->Path1);
        } else {
            $this->Path1 = $path1;
        }
        return $this;
    }
    /**
     * Get Path2 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getPath2()
    {
        return isset($this->Path2) ? $this->Path2 : null;
    }
    /**
     * Set Path2 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $path2
     * @return \StructType\DynamicSearchAd
     */
    public function setPath2($path2 = null)
    {
        // validation for constraint: string
        if (!is_null($path2) && !is_string($path2)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($path2, true), gettype($path2)), __LINE__);
        }
        if (is_null($path2) || (is_array($path2) && empty($path2))) {
            unset($this->Path2);
        } else {
            $this->Path2 = $path2;
        }
        return $this;
    }
    /**
     * Get Text value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getText()
    {
        return isset($this->Text) ? $this->Text : null;
    }
    /**
     * Set Text value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $text
     * @return \StructType\DynamicSearchAd
     */
    public function setText($text = null)
    {
        // validation for constraint: string
        if (!is_null($text) && !is_string($text)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($text, true), gettype($text)), __LINE__);
        }
        if (is_null($text) || (is_array($text) && empty($text))) {
            unset($this->Text);
        } else {
            $this->Text = $text;
        }
        return $this;
    }
    /**
     * Get TextPart2 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getTextPart2()
    {
        return isset($this->TextPart2) ? $this->TextPart2 : null;
    }
    /**
     * Set TextPart2 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $textPart2
     * @return \StructType\DynamicSearchAd
     */
    public function setTextPart2($textPart2 = null)
    {
        // validation for constraint: string
        if (!is_null($textPart2) && !is_string($textPart2)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($textPart2, true), gettype($textPart2)), __LINE__);
        }
        if (is_null($textPart2) || (is_array($textPart2) && empty($textPart2))) {
            unset($this->TextPart2);
        } else {
            $this->TextPart2 = $textPart2;
        }
        return $this;
    }
}
