<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for EditorialApiFaultDetail StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:EditorialApiFaultDetail
 * @subpackage Structs
 */
class EditorialApiFaultDetail extends ApplicationFault
{
    /**
     * The BatchErrors
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfBatchError
     */
    public $BatchErrors;
    /**
     * The EditorialErrors
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfEditorialError
     */
    public $EditorialErrors;
    /**
     * The OperationErrors
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfOperationError
     */
    public $OperationErrors;
    /**
     * Constructor method for EditorialApiFaultDetail
     * @uses EditorialApiFaultDetail::setBatchErrors()
     * @uses EditorialApiFaultDetail::setEditorialErrors()
     * @uses EditorialApiFaultDetail::setOperationErrors()
     * @param \ArrayType\ArrayOfBatchError $batchErrors
     * @param \ArrayType\ArrayOfEditorialError $editorialErrors
     * @param \ArrayType\ArrayOfOperationError $operationErrors
     */
    public function __construct(\ArrayType\ArrayOfBatchError $batchErrors = null, \ArrayType\ArrayOfEditorialError $editorialErrors = null, \ArrayType\ArrayOfOperationError $operationErrors = null)
    {
        $this
            ->setBatchErrors($batchErrors)
            ->setEditorialErrors($editorialErrors)
            ->setOperationErrors($operationErrors);
    }
    /**
     * Get BatchErrors value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfBatchError|null
     */
    public function getBatchErrors()
    {
        return isset($this->BatchErrors) ? $this->BatchErrors : null;
    }
    /**
     * Set BatchErrors value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfBatchError $batchErrors
     * @return \StructType\EditorialApiFaultDetail
     */
    public function setBatchErrors(\ArrayType\ArrayOfBatchError $batchErrors = null)
    {
        if (is_null($batchErrors) || (is_array($batchErrors) && empty($batchErrors))) {
            unset($this->BatchErrors);
        } else {
            $this->BatchErrors = $batchErrors;
        }
        return $this;
    }
    /**
     * Get EditorialErrors value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfEditorialError|null
     */
    public function getEditorialErrors()
    {
        return isset($this->EditorialErrors) ? $this->EditorialErrors : null;
    }
    /**
     * Set EditorialErrors value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfEditorialError $editorialErrors
     * @return \StructType\EditorialApiFaultDetail
     */
    public function setEditorialErrors(\ArrayType\ArrayOfEditorialError $editorialErrors = null)
    {
        if (is_null($editorialErrors) || (is_array($editorialErrors) && empty($editorialErrors))) {
            unset($this->EditorialErrors);
        } else {
            $this->EditorialErrors = $editorialErrors;
        }
        return $this;
    }
    /**
     * Get OperationErrors value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfOperationError|null
     */
    public function getOperationErrors()
    {
        return isset($this->OperationErrors) ? $this->OperationErrors : null;
    }
    /**
     * Set OperationErrors value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfOperationError $operationErrors
     * @return \StructType\EditorialApiFaultDetail
     */
    public function setOperationErrors(\ArrayType\ArrayOfOperationError $operationErrors = null)
    {
        if (is_null($operationErrors) || (is_array($operationErrors) && empty($operationErrors))) {
            unset($this->OperationErrors);
        } else {
            $this->OperationErrors = $operationErrors;
        }
        return $this;
    }
}
