<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ExpandedTextAd StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ExpandedTextAd
 * @subpackage Structs
 */
class ExpandedTextAd extends Ad
{
    /**
     * The Domain
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Domain;
    /**
     * The Path1
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Path1;
    /**
     * The Path2
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Path2;
    /**
     * The Text
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Text;
    /**
     * The TextPart2
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $TextPart2;
    /**
     * The TitlePart1
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $TitlePart1;
    /**
     * The TitlePart2
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $TitlePart2;
    /**
     * The TitlePart3
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $TitlePart3;
    /**
     * Constructor method for ExpandedTextAd
     * @uses ExpandedTextAd::setDomain()
     * @uses ExpandedTextAd::setPath1()
     * @uses ExpandedTextAd::setPath2()
     * @uses ExpandedTextAd::setText()
     * @uses ExpandedTextAd::setTextPart2()
     * @uses ExpandedTextAd::setTitlePart1()
     * @uses ExpandedTextAd::setTitlePart2()
     * @uses ExpandedTextAd::setTitlePart3()
     * @param string $domain
     * @param string $path1
     * @param string $path2
     * @param string $text
     * @param string $textPart2
     * @param string $titlePart1
     * @param string $titlePart2
     * @param string $titlePart3
     */
    public function __construct($domain = null, $path1 = null, $path2 = null, $text = null, $textPart2 = null, $titlePart1 = null, $titlePart2 = null, $titlePart3 = null)
    {
        $this
            ->setDomain($domain)
            ->setPath1($path1)
            ->setPath2($path2)
            ->setText($text)
            ->setTextPart2($textPart2)
            ->setTitlePart1($titlePart1)
            ->setTitlePart2($titlePart2)
            ->setTitlePart3($titlePart3);
    }
    /**
     * Get Domain value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDomain()
    {
        return isset($this->Domain) ? $this->Domain : null;
    }
    /**
     * Set Domain value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $domain
     * @return \StructType\ExpandedTextAd
     */
    public function setDomain($domain = null)
    {
        // validation for constraint: string
        if (!is_null($domain) && !is_string($domain)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($domain, true), gettype($domain)), __LINE__);
        }
        if (is_null($domain) || (is_array($domain) && empty($domain))) {
            unset($this->Domain);
        } else {
            $this->Domain = $domain;
        }
        return $this;
    }
    /**
     * Get Path1 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getPath1()
    {
        return isset($this->Path1) ? $this->Path1 : null;
    }
    /**
     * Set Path1 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $path1
     * @return \StructType\ExpandedTextAd
     */
    public function setPath1($path1 = null)
    {
        // validation for constraint: string
        if (!is_null($path1) && !is_string($path1)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($path1, true), gettype($path1)), __LINE__);
        }
        if (is_null($path1) || (is_array($path1) && empty($path1))) {
            unset($this->Path1);
        } else {
            $this->Path1 = $path1;
        }
        return $this;
    }
    /**
     * Get Path2 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getPath2()
    {
        return isset($this->Path2) ? $this->Path2 : null;
    }
    /**
     * Set Path2 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $path2
     * @return \StructType\ExpandedTextAd
     */
    public function setPath2($path2 = null)
    {
        // validation for constraint: string
        if (!is_null($path2) && !is_string($path2)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($path2, true), gettype($path2)), __LINE__);
        }
        if (is_null($path2) || (is_array($path2) && empty($path2))) {
            unset($this->Path2);
        } else {
            $this->Path2 = $path2;
        }
        return $this;
    }
    /**
     * Get Text value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getText()
    {
        return isset($this->Text) ? $this->Text : null;
    }
    /**
     * Set Text value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $text
     * @return \StructType\ExpandedTextAd
     */
    public function setText($text = null)
    {
        // validation for constraint: string
        if (!is_null($text) && !is_string($text)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($text, true), gettype($text)), __LINE__);
        }
        if (is_null($text) || (is_array($text) && empty($text))) {
            unset($this->Text);
        } else {
            $this->Text = $text;
        }
        return $this;
    }
    /**
     * Get TextPart2 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getTextPart2()
    {
        return isset($this->TextPart2) ? $this->TextPart2 : null;
    }
    /**
     * Set TextPart2 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $textPart2
     * @return \StructType\ExpandedTextAd
     */
    public function setTextPart2($textPart2 = null)
    {
        // validation for constraint: string
        if (!is_null($textPart2) && !is_string($textPart2)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($textPart2, true), gettype($textPart2)), __LINE__);
        }
        if (is_null($textPart2) || (is_array($textPart2) && empty($textPart2))) {
            unset($this->TextPart2);
        } else {
            $this->TextPart2 = $textPart2;
        }
        return $this;
    }
    /**
     * Get TitlePart1 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getTitlePart1()
    {
        return isset($this->TitlePart1) ? $this->TitlePart1 : null;
    }
    /**
     * Set TitlePart1 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $titlePart1
     * @return \StructType\ExpandedTextAd
     */
    public function setTitlePart1($titlePart1 = null)
    {
        // validation for constraint: string
        if (!is_null($titlePart1) && !is_string($titlePart1)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($titlePart1, true), gettype($titlePart1)), __LINE__);
        }
        if (is_null($titlePart1) || (is_array($titlePart1) && empty($titlePart1))) {
            unset($this->TitlePart1);
        } else {
            $this->TitlePart1 = $titlePart1;
        }
        return $this;
    }
    /**
     * Get TitlePart2 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getTitlePart2()
    {
        return isset($this->TitlePart2) ? $this->TitlePart2 : null;
    }
    /**
     * Set TitlePart2 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $titlePart2
     * @return \StructType\ExpandedTextAd
     */
    public function setTitlePart2($titlePart2 = null)
    {
        // validation for constraint: string
        if (!is_null($titlePart2) && !is_string($titlePart2)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($titlePart2, true), gettype($titlePart2)), __LINE__);
        }
        if (is_null($titlePart2) || (is_array($titlePart2) && empty($titlePart2))) {
            unset($this->TitlePart2);
        } else {
            $this->TitlePart2 = $titlePart2;
        }
        return $this;
    }
    /**
     * Get TitlePart3 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getTitlePart3()
    {
        return isset($this->TitlePart3) ? $this->TitlePart3 : null;
    }
    /**
     * Set TitlePart3 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $titlePart3
     * @return \StructType\ExpandedTextAd
     */
    public function setTitlePart3($titlePart3 = null)
    {
        // validation for constraint: string
        if (!is_null($titlePart3) && !is_string($titlePart3)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($titlePart3, true), gettype($titlePart3)), __LINE__);
        }
        if (is_null($titlePart3) || (is_array($titlePart3) && empty($titlePart3))) {
            unset($this->TitlePart3);
        } else {
            $this->TitlePart3 = $titlePart3;
        }
        return $this;
    }
}
