<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GenderCriterion StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:GenderCriterion
 * @subpackage Structs
 */
class GenderCriterion extends Criterion
{
    /**
     * The GenderType
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $GenderType;
    /**
     * Constructor method for GenderCriterion
     * @uses GenderCriterion::setGenderType()
     * @param string $genderType
     */
    public function __construct($genderType = null)
    {
        $this
            ->setGenderType($genderType);
    }
    /**
     * Get GenderType value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getGenderType()
    {
        return isset($this->GenderType) ? $this->GenderType : null;
    }
    /**
     * Set GenderType value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @uses \EnumType\GenderType::valueIsValid()
     * @uses \EnumType\GenderType::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $genderType
     * @return \StructType\GenderCriterion
     */
    public function setGenderType($genderType = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\GenderType::valueIsValid($genderType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\GenderType', is_array($genderType) ? implode(', ', $genderType) : var_export($genderType, true), implode(', ', \EnumType\GenderType::getValidValues())), __LINE__);
        }
        if (is_null($genderType) || (is_array($genderType) && empty($genderType))) {
            unset($this->GenderType);
        } else {
            $this->GenderType = $genderType;
        }
        return $this;
    }
}
