<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetCampaignIdsByBudgetIdsResponse StructType
 * @subpackage Structs
 */
class GetCampaignIdsByBudgetIdsResponse extends AbstractStructBase
{
    /**
     * The CampaignIdCollection
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfIdCollection
     */
    public $CampaignIdCollection;
    /**
     * The PartialErrors
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfBatchError
     */
    public $PartialErrors;
    /**
     * Constructor method for GetCampaignIdsByBudgetIdsResponse
     * @uses GetCampaignIdsByBudgetIdsResponse::setCampaignIdCollection()
     * @uses GetCampaignIdsByBudgetIdsResponse::setPartialErrors()
     * @param \ArrayType\ArrayOfIdCollection $campaignIdCollection
     * @param \ArrayType\ArrayOfBatchError $partialErrors
     */
    public function __construct(\ArrayType\ArrayOfIdCollection $campaignIdCollection = null, \ArrayType\ArrayOfBatchError $partialErrors = null)
    {
        $this
            ->setCampaignIdCollection($campaignIdCollection)
            ->setPartialErrors($partialErrors);
    }
    /**
     * Get CampaignIdCollection value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfIdCollection|null
     */
    public function getCampaignIdCollection()
    {
        return isset($this->CampaignIdCollection) ? $this->CampaignIdCollection : null;
    }
    /**
     * Set CampaignIdCollection value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfIdCollection $campaignIdCollection
     * @return \StructType\GetCampaignIdsByBudgetIdsResponse
     */
    public function setCampaignIdCollection(\ArrayType\ArrayOfIdCollection $campaignIdCollection = null)
    {
        if (is_null($campaignIdCollection) || (is_array($campaignIdCollection) && empty($campaignIdCollection))) {
            unset($this->CampaignIdCollection);
        } else {
            $this->CampaignIdCollection = $campaignIdCollection;
        }
        return $this;
    }
    /**
     * Get PartialErrors value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfBatchError|null
     */
    public function getPartialErrors()
    {
        return isset($this->PartialErrors) ? $this->PartialErrors : null;
    }
    /**
     * Set PartialErrors value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfBatchError $partialErrors
     * @return \StructType\GetCampaignIdsByBudgetIdsResponse
     */
    public function setPartialErrors(\ArrayType\ArrayOfBatchError $partialErrors = null)
    {
        if (is_null($partialErrors) || (is_array($partialErrors) && empty($partialErrors))) {
            unset($this->PartialErrors);
        } else {
            $this->PartialErrors = $partialErrors;
        }
        return $this;
    }
}
