<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ImportJob StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ImportJob
 * @subpackage Structs
 */
class ImportJob extends AbstractStructBase
{
    /**
     * The CreatedByUserId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $CreatedByUserId;
    /**
     * The CreatedByUserName
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $CreatedByUserName;
    /**
     * The CreatedDateTimeInUTC
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $CreatedDateTimeInUTC;
    /**
     * The Frequency
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Frequency
     */
    public $Frequency;
    /**
     * The Id
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $Id;
    /**
     * The ImportOption
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ImportOption
     */
    public $ImportOption;
    /**
     * The LastRunTimeInUTC
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $LastRunTimeInUTC;
    /**
     * The Name
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Name;
    /**
     * The NotificationEmail
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $NotificationEmail;
    /**
     * The NotificationType
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $NotificationType;
    /**
     * The Status
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Status;
    /**
     * The Type
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Type;
    /**
     * Constructor method for ImportJob
     * @uses ImportJob::setCreatedByUserId()
     * @uses ImportJob::setCreatedByUserName()
     * @uses ImportJob::setCreatedDateTimeInUTC()
     * @uses ImportJob::setFrequency()
     * @uses ImportJob::setId()
     * @uses ImportJob::setImportOption()
     * @uses ImportJob::setLastRunTimeInUTC()
     * @uses ImportJob::setName()
     * @uses ImportJob::setNotificationEmail()
     * @uses ImportJob::setNotificationType()
     * @uses ImportJob::setStatus()
     * @uses ImportJob::setType()
     * @param int $createdByUserId
     * @param string $createdByUserName
     * @param string $createdDateTimeInUTC
     * @param \StructType\Frequency $frequency
     * @param int $id
     * @param \StructType\ImportOption $importOption
     * @param string $lastRunTimeInUTC
     * @param string $name
     * @param string $notificationEmail
     * @param string $notificationType
     * @param string $status
     * @param string $type
     */
    public function __construct($createdByUserId = null, $createdByUserName = null, $createdDateTimeInUTC = null, \StructType\Frequency $frequency = null, $id = null, \StructType\ImportOption $importOption = null, $lastRunTimeInUTC = null, $name = null, $notificationEmail = null, $notificationType = null, $status = null, $type = null)
    {
        $this
            ->setCreatedByUserId($createdByUserId)
            ->setCreatedByUserName($createdByUserName)
            ->setCreatedDateTimeInUTC($createdDateTimeInUTC)
            ->setFrequency($frequency)
            ->setId($id)
            ->setImportOption($importOption)
            ->setLastRunTimeInUTC($lastRunTimeInUTC)
            ->setName($name)
            ->setNotificationEmail($notificationEmail)
            ->setNotificationType($notificationType)
            ->setStatus($status)
            ->setType($type);
    }
    /**
     * Get CreatedByUserId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getCreatedByUserId()
    {
        return isset($this->CreatedByUserId) ? $this->CreatedByUserId : null;
    }
    /**
     * Set CreatedByUserId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $createdByUserId
     * @return \StructType\ImportJob
     */
    public function setCreatedByUserId($createdByUserId = null)
    {
        // validation for constraint: int
        if (!is_null($createdByUserId) && !(is_int($createdByUserId) || ctype_digit($createdByUserId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($createdByUserId, true), gettype($createdByUserId)), __LINE__);
        }
        if (is_null($createdByUserId) || (is_array($createdByUserId) && empty($createdByUserId))) {
            unset($this->CreatedByUserId);
        } else {
            $this->CreatedByUserId = $createdByUserId;
        }
        return $this;
    }
    /**
     * Get CreatedByUserName value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCreatedByUserName()
    {
        return isset($this->CreatedByUserName) ? $this->CreatedByUserName : null;
    }
    /**
     * Set CreatedByUserName value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $createdByUserName
     * @return \StructType\ImportJob
     */
    public function setCreatedByUserName($createdByUserName = null)
    {
        // validation for constraint: string
        if (!is_null($createdByUserName) && !is_string($createdByUserName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($createdByUserName, true), gettype($createdByUserName)), __LINE__);
        }
        if (is_null($createdByUserName) || (is_array($createdByUserName) && empty($createdByUserName))) {
            unset($this->CreatedByUserName);
        } else {
            $this->CreatedByUserName = $createdByUserName;
        }
        return $this;
    }
    /**
     * Get CreatedDateTimeInUTC value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCreatedDateTimeInUTC()
    {
        return isset($this->CreatedDateTimeInUTC) ? $this->CreatedDateTimeInUTC : null;
    }
    /**
     * Set CreatedDateTimeInUTC value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $createdDateTimeInUTC
     * @return \StructType\ImportJob
     */
    public function setCreatedDateTimeInUTC($createdDateTimeInUTC = null)
    {
        // validation for constraint: string
        if (!is_null($createdDateTimeInUTC) && !is_string($createdDateTimeInUTC)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($createdDateTimeInUTC, true), gettype($createdDateTimeInUTC)), __LINE__);
        }
        if (is_null($createdDateTimeInUTC) || (is_array($createdDateTimeInUTC) && empty($createdDateTimeInUTC))) {
            unset($this->CreatedDateTimeInUTC);
        } else {
            $this->CreatedDateTimeInUTC = $createdDateTimeInUTC;
        }
        return $this;
    }
    /**
     * Get Frequency value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Frequency|null
     */
    public function getFrequency()
    {
        return isset($this->Frequency) ? $this->Frequency : null;
    }
    /**
     * Set Frequency value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\Frequency $frequency
     * @return \StructType\ImportJob
     */
    public function setFrequency(\StructType\Frequency $frequency = null)
    {
        if (is_null($frequency) || (is_array($frequency) && empty($frequency))) {
            unset($this->Frequency);
        } else {
            $this->Frequency = $frequency;
        }
        return $this;
    }
    /**
     * Get Id value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getId()
    {
        return isset($this->Id) ? $this->Id : null;
    }
    /**
     * Set Id value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $id
     * @return \StructType\ImportJob
     */
    public function setId($id = null)
    {
        // validation for constraint: int
        if (!is_null($id) && !(is_int($id) || ctype_digit($id))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($id, true), gettype($id)), __LINE__);
        }
        if (is_null($id) || (is_array($id) && empty($id))) {
            unset($this->Id);
        } else {
            $this->Id = $id;
        }
        return $this;
    }
    /**
     * Get ImportOption value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ImportOption|null
     */
    public function getImportOption()
    {
        return isset($this->ImportOption) ? $this->ImportOption : null;
    }
    /**
     * Set ImportOption value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\ImportOption $importOption
     * @return \StructType\ImportJob
     */
    public function setImportOption(\StructType\ImportOption $importOption = null)
    {
        if (is_null($importOption) || (is_array($importOption) && empty($importOption))) {
            unset($this->ImportOption);
        } else {
            $this->ImportOption = $importOption;
        }
        return $this;
    }
    /**
     * Get LastRunTimeInUTC value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getLastRunTimeInUTC()
    {
        return isset($this->LastRunTimeInUTC) ? $this->LastRunTimeInUTC : null;
    }
    /**
     * Set LastRunTimeInUTC value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $lastRunTimeInUTC
     * @return \StructType\ImportJob
     */
    public function setLastRunTimeInUTC($lastRunTimeInUTC = null)
    {
        // validation for constraint: string
        if (!is_null($lastRunTimeInUTC) && !is_string($lastRunTimeInUTC)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($lastRunTimeInUTC, true), gettype($lastRunTimeInUTC)), __LINE__);
        }
        if (is_null($lastRunTimeInUTC) || (is_array($lastRunTimeInUTC) && empty($lastRunTimeInUTC))) {
            unset($this->LastRunTimeInUTC);
        } else {
            $this->LastRunTimeInUTC = $lastRunTimeInUTC;
        }
        return $this;
    }
    /**
     * Get Name value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getName()
    {
        return isset($this->Name) ? $this->Name : null;
    }
    /**
     * Set Name value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $name
     * @return \StructType\ImportJob
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($name, true), gettype($name)), __LINE__);
        }
        if (is_null($name) || (is_array($name) && empty($name))) {
            unset($this->Name);
        } else {
            $this->Name = $name;
        }
        return $this;
    }
    /**
     * Get NotificationEmail value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getNotificationEmail()
    {
        return isset($this->NotificationEmail) ? $this->NotificationEmail : null;
    }
    /**
     * Set NotificationEmail value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $notificationEmail
     * @return \StructType\ImportJob
     */
    public function setNotificationEmail($notificationEmail = null)
    {
        // validation for constraint: string
        if (!is_null($notificationEmail) && !is_string($notificationEmail)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($notificationEmail, true), gettype($notificationEmail)), __LINE__);
        }
        if (is_null($notificationEmail) || (is_array($notificationEmail) && empty($notificationEmail))) {
            unset($this->NotificationEmail);
        } else {
            $this->NotificationEmail = $notificationEmail;
        }
        return $this;
    }
    /**
     * Get NotificationType value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getNotificationType()
    {
        return isset($this->NotificationType) ? $this->NotificationType : null;
    }
    /**
     * Set NotificationType value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $notificationType
     * @return \StructType\ImportJob
     */
    public function setNotificationType($notificationType = null)
    {
        // validation for constraint: string
        if (!is_null($notificationType) && !is_string($notificationType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($notificationType, true), gettype($notificationType)), __LINE__);
        }
        if (is_null($notificationType) || (is_array($notificationType) && empty($notificationType))) {
            unset($this->NotificationType);
        } else {
            $this->NotificationType = $notificationType;
        }
        return $this;
    }
    /**
     * Get Status value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getStatus()
    {
        return isset($this->Status) ? $this->Status : null;
    }
    /**
     * Set Status value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $status
     * @return \StructType\ImportJob
     */
    public function setStatus($status = null)
    {
        // validation for constraint: string
        if (!is_null($status) && !is_string($status)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($status, true), gettype($status)), __LINE__);
        }
        if (is_null($status) || (is_array($status) && empty($status))) {
            unset($this->Status);
        } else {
            $this->Status = $status;
        }
        return $this;
    }
    /**
     * Get Type value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getType()
    {
        return isset($this->Type) ? $this->Type : null;
    }
    /**
     * Set Type value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $type
     * @return \StructType\ImportJob
     */
    public function setType($type = null)
    {
        // validation for constraint: string
        if (!is_null($type) && !is_string($type)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($type, true), gettype($type)), __LINE__);
        }
        if (is_null($type) || (is_array($type) && empty($type))) {
            unset($this->Type);
        } else {
            $this->Type = $type;
        }
        return $this;
    }
}
