<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ImportSearchAndReplaceForStringProperty StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ImportSearchAndReplaceForStringProperty
 * @subpackage Structs
 */
class ImportSearchAndReplaceForStringProperty extends AbstractStructBase
{
    /**
     * The ReplaceString
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ReplaceString;
    /**
     * The SearchString
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $SearchString;
    /**
     * Constructor method for ImportSearchAndReplaceForStringProperty
     * @uses ImportSearchAndReplaceForStringProperty::setReplaceString()
     * @uses ImportSearchAndReplaceForStringProperty::setSearchString()
     * @param string $replaceString
     * @param string $searchString
     */
    public function __construct($replaceString = null, $searchString = null)
    {
        $this
            ->setReplaceString($replaceString)
            ->setSearchString($searchString);
    }
    /**
     * Get ReplaceString value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getReplaceString()
    {
        return isset($this->ReplaceString) ? $this->ReplaceString : null;
    }
    /**
     * Set ReplaceString value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $replaceString
     * @return \StructType\ImportSearchAndReplaceForStringProperty
     */
    public function setReplaceString($replaceString = null)
    {
        // validation for constraint: string
        if (!is_null($replaceString) && !is_string($replaceString)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($replaceString, true), gettype($replaceString)), __LINE__);
        }
        if (is_null($replaceString) || (is_array($replaceString) && empty($replaceString))) {
            unset($this->ReplaceString);
        } else {
            $this->ReplaceString = $replaceString;
        }
        return $this;
    }
    /**
     * Get SearchString value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getSearchString()
    {
        return isset($this->SearchString) ? $this->SearchString : null;
    }
    /**
     * Set SearchString value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $searchString
     * @return \StructType\ImportSearchAndReplaceForStringProperty
     */
    public function setSearchString($searchString = null)
    {
        // validation for constraint: string
        if (!is_null($searchString) && !is_string($searchString)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($searchString, true), gettype($searchString)), __LINE__);
        }
        if (is_null($searchString) || (is_array($searchString) && empty($searchString))) {
            unset($this->SearchString);
        } else {
            $this->SearchString = $searchString;
        }
        return $this;
    }
}
