<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for OfflineConversionAdjustment StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:OfflineConversionAdjustment
 * @subpackage Structs
 */
class OfflineConversionAdjustment extends AbstractStructBase
{
    /**
     * The AdjustmentCurrencyCode
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $AdjustmentCurrencyCode;
    /**
     * The AdjustmentTime
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $AdjustmentTime;
    /**
     * The AdjustmentType
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $AdjustmentType;
    /**
     * The AdjustmentValue
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var float
     */
    public $AdjustmentValue;
    /**
     * The ConversionName
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ConversionName;
    /**
     * The ConversionTime
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $ConversionTime;
    /**
     * The MicrosoftClickId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $MicrosoftClickId;
    /**
     * Constructor method for OfflineConversionAdjustment
     * @uses OfflineConversionAdjustment::setAdjustmentCurrencyCode()
     * @uses OfflineConversionAdjustment::setAdjustmentTime()
     * @uses OfflineConversionAdjustment::setAdjustmentType()
     * @uses OfflineConversionAdjustment::setAdjustmentValue()
     * @uses OfflineConversionAdjustment::setConversionName()
     * @uses OfflineConversionAdjustment::setConversionTime()
     * @uses OfflineConversionAdjustment::setMicrosoftClickId()
     * @param string $adjustmentCurrencyCode
     * @param string $adjustmentTime
     * @param string $adjustmentType
     * @param float $adjustmentValue
     * @param string $conversionName
     * @param string $conversionTime
     * @param string $microsoftClickId
     */
    public function __construct($adjustmentCurrencyCode = null, $adjustmentTime = null, $adjustmentType = null, $adjustmentValue = null, $conversionName = null, $conversionTime = null, $microsoftClickId = null)
    {
        $this
            ->setAdjustmentCurrencyCode($adjustmentCurrencyCode)
            ->setAdjustmentTime($adjustmentTime)
            ->setAdjustmentType($adjustmentType)
            ->setAdjustmentValue($adjustmentValue)
            ->setConversionName($conversionName)
            ->setConversionTime($conversionTime)
            ->setMicrosoftClickId($microsoftClickId);
    }
    /**
     * Get AdjustmentCurrencyCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getAdjustmentCurrencyCode()
    {
        return isset($this->AdjustmentCurrencyCode) ? $this->AdjustmentCurrencyCode : null;
    }
    /**
     * Set AdjustmentCurrencyCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $adjustmentCurrencyCode
     * @return \StructType\OfflineConversionAdjustment
     */
    public function setAdjustmentCurrencyCode($adjustmentCurrencyCode = null)
    {
        // validation for constraint: string
        if (!is_null($adjustmentCurrencyCode) && !is_string($adjustmentCurrencyCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($adjustmentCurrencyCode, true), gettype($adjustmentCurrencyCode)), __LINE__);
        }
        if (is_null($adjustmentCurrencyCode) || (is_array($adjustmentCurrencyCode) && empty($adjustmentCurrencyCode))) {
            unset($this->AdjustmentCurrencyCode);
        } else {
            $this->AdjustmentCurrencyCode = $adjustmentCurrencyCode;
        }
        return $this;
    }
    /**
     * Get AdjustmentTime value
     * @return string|null
     */
    public function getAdjustmentTime()
    {
        return $this->AdjustmentTime;
    }
    /**
     * Set AdjustmentTime value
     * @param string $adjustmentTime
     * @return \StructType\OfflineConversionAdjustment
     */
    public function setAdjustmentTime($adjustmentTime = null)
    {
        // validation for constraint: string
        if (!is_null($adjustmentTime) && !is_string($adjustmentTime)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($adjustmentTime, true), gettype($adjustmentTime)), __LINE__);
        }
        $this->AdjustmentTime = $adjustmentTime;
        return $this;
    }
    /**
     * Get AdjustmentType value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getAdjustmentType()
    {
        return isset($this->AdjustmentType) ? $this->AdjustmentType : null;
    }
    /**
     * Set AdjustmentType value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $adjustmentType
     * @return \StructType\OfflineConversionAdjustment
     */
    public function setAdjustmentType($adjustmentType = null)
    {
        // validation for constraint: string
        if (!is_null($adjustmentType) && !is_string($adjustmentType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($adjustmentType, true), gettype($adjustmentType)), __LINE__);
        }
        if (is_null($adjustmentType) || (is_array($adjustmentType) && empty($adjustmentType))) {
            unset($this->AdjustmentType);
        } else {
            $this->AdjustmentType = $adjustmentType;
        }
        return $this;
    }
    /**
     * Get AdjustmentValue value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return float|null
     */
    public function getAdjustmentValue()
    {
        return isset($this->AdjustmentValue) ? $this->AdjustmentValue : null;
    }
    /**
     * Set AdjustmentValue value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param float $adjustmentValue
     * @return \StructType\OfflineConversionAdjustment
     */
    public function setAdjustmentValue($adjustmentValue = null)
    {
        // validation for constraint: float
        if (!is_null($adjustmentValue) && !(is_float($adjustmentValue) || is_numeric($adjustmentValue))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($adjustmentValue, true), gettype($adjustmentValue)), __LINE__);
        }
        if (is_null($adjustmentValue) || (is_array($adjustmentValue) && empty($adjustmentValue))) {
            unset($this->AdjustmentValue);
        } else {
            $this->AdjustmentValue = $adjustmentValue;
        }
        return $this;
    }
    /**
     * Get ConversionName value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getConversionName()
    {
        return isset($this->ConversionName) ? $this->ConversionName : null;
    }
    /**
     * Set ConversionName value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $conversionName
     * @return \StructType\OfflineConversionAdjustment
     */
    public function setConversionName($conversionName = null)
    {
        // validation for constraint: string
        if (!is_null($conversionName) && !is_string($conversionName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($conversionName, true), gettype($conversionName)), __LINE__);
        }
        if (is_null($conversionName) || (is_array($conversionName) && empty($conversionName))) {
            unset($this->ConversionName);
        } else {
            $this->ConversionName = $conversionName;
        }
        return $this;
    }
    /**
     * Get ConversionTime value
     * @return string|null
     */
    public function getConversionTime()
    {
        return $this->ConversionTime;
    }
    /**
     * Set ConversionTime value
     * @param string $conversionTime
     * @return \StructType\OfflineConversionAdjustment
     */
    public function setConversionTime($conversionTime = null)
    {
        // validation for constraint: string
        if (!is_null($conversionTime) && !is_string($conversionTime)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($conversionTime, true), gettype($conversionTime)), __LINE__);
        }
        $this->ConversionTime = $conversionTime;
        return $this;
    }
    /**
     * Get MicrosoftClickId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getMicrosoftClickId()
    {
        return isset($this->MicrosoftClickId) ? $this->MicrosoftClickId : null;
    }
    /**
     * Set MicrosoftClickId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $microsoftClickId
     * @return \StructType\OfflineConversionAdjustment
     */
    public function setMicrosoftClickId($microsoftClickId = null)
    {
        // validation for constraint: string
        if (!is_null($microsoftClickId) && !is_string($microsoftClickId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($microsoftClickId, true), gettype($microsoftClickId)), __LINE__);
        }
        if (is_null($microsoftClickId) || (is_array($microsoftClickId) && empty($microsoftClickId))) {
            unset($this->MicrosoftClickId);
        } else {
            $this->MicrosoftClickId = $microsoftClickId;
        }
        return $this;
    }
}
