<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PageVisitorsRule StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:PageVisitorsRule
 * @subpackage Structs
 */
class PageVisitorsRule extends RemarketingRule
{
    /**
     * The NormalForm
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $NormalForm;
    /**
     * The RuleItemGroups
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfRuleItemGroup
     */
    public $RuleItemGroups;
    /**
     * Constructor method for PageVisitorsRule
     * @uses PageVisitorsRule::setNormalForm()
     * @uses PageVisitorsRule::setRuleItemGroups()
     * @param string $normalForm
     * @param \ArrayType\ArrayOfRuleItemGroup $ruleItemGroups
     */
    public function __construct($normalForm = null, \ArrayType\ArrayOfRuleItemGroup $ruleItemGroups = null)
    {
        $this
            ->setNormalForm($normalForm)
            ->setRuleItemGroups($ruleItemGroups);
    }
    /**
     * Get NormalForm value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getNormalForm()
    {
        return isset($this->NormalForm) ? $this->NormalForm : null;
    }
    /**
     * Set NormalForm value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @uses \EnumType\NormalForm::valueIsValid()
     * @uses \EnumType\NormalForm::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $normalForm
     * @return \StructType\PageVisitorsRule
     */
    public function setNormalForm($normalForm = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\NormalForm::valueIsValid($normalForm)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\NormalForm', is_array($normalForm) ? implode(', ', $normalForm) : var_export($normalForm, true), implode(', ', \EnumType\NormalForm::getValidValues())), __LINE__);
        }
        if (is_null($normalForm) || (is_array($normalForm) && empty($normalForm))) {
            unset($this->NormalForm);
        } else {
            $this->NormalForm = $normalForm;
        }
        return $this;
    }
    /**
     * Get RuleItemGroups value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfRuleItemGroup|null
     */
    public function getRuleItemGroups()
    {
        return isset($this->RuleItemGroups) ? $this->RuleItemGroups : null;
    }
    /**
     * Set RuleItemGroups value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfRuleItemGroup $ruleItemGroups
     * @return \StructType\PageVisitorsRule
     */
    public function setRuleItemGroups(\ArrayType\ArrayOfRuleItemGroup $ruleItemGroups = null)
    {
        if (is_null($ruleItemGroups) || (is_array($ruleItemGroups) && empty($ruleItemGroups))) {
            unset($this->RuleItemGroups);
        } else {
            $this->RuleItemGroups = $ruleItemGroups;
        }
        return $this;
    }
}
