<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PagesViewedPerVisitGoal StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:PagesViewedPerVisitGoal
 * @subpackage Structs
 */
class PagesViewedPerVisitGoal extends ConversionGoal
{
    /**
     * The MinimumPagesViewed
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $MinimumPagesViewed;
    /**
     * Constructor method for PagesViewedPerVisitGoal
     * @uses PagesViewedPerVisitGoal::setMinimumPagesViewed()
     * @param int $minimumPagesViewed
     */
    public function __construct($minimumPagesViewed = null)
    {
        $this
            ->setMinimumPagesViewed($minimumPagesViewed);
    }
    /**
     * Get MinimumPagesViewed value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getMinimumPagesViewed()
    {
        return isset($this->MinimumPagesViewed) ? $this->MinimumPagesViewed : null;
    }
    /**
     * Set MinimumPagesViewed value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $minimumPagesViewed
     * @return \StructType\PagesViewedPerVisitGoal
     */
    public function setMinimumPagesViewed($minimumPagesViewed = null)
    {
        // validation for constraint: int
        if (!is_null($minimumPagesViewed) && !(is_int($minimumPagesViewed) || ctype_digit($minimumPagesViewed))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($minimumPagesViewed, true), gettype($minimumPagesViewed)), __LINE__);
        }
        if (is_null($minimumPagesViewed) || (is_array($minimumPagesViewed) && empty($minimumPagesViewed))) {
            unset($this->MinimumPagesViewed);
        } else {
            $this->MinimumPagesViewed = $minimumPagesViewed;
        }
        return $this;
    }
}
