<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RuleItemGroup StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:RuleItemGroup
 * @subpackage Structs
 */
class RuleItemGroup extends AbstractStructBase
{
    /**
     * The Items
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfRuleItem
     */
    public $Items;
    /**
     * Constructor method for RuleItemGroup
     * @uses RuleItemGroup::setItems()
     * @param \ArrayType\ArrayOfRuleItem $items
     */
    public function __construct(\ArrayType\ArrayOfRuleItem $items = null)
    {
        $this
            ->setItems($items);
    }
    /**
     * Get Items value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfRuleItem|null
     */
    public function getItems()
    {
        return isset($this->Items) ? $this->Items : null;
    }
    /**
     * Set Items value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfRuleItem $items
     * @return \StructType\RuleItemGroup
     */
    public function setItems(\ArrayType\ArrayOfRuleItem $items = null)
    {
        if (is_null($items) || (is_array($items) && empty($items))) {
            unset($this->Items);
        } else {
            $this->Items = $items;
        }
        return $this;
    }
}
