<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TargetRoasBiddingScheme StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:TargetRoasBiddingScheme
 * @subpackage Structs
 */
class TargetRoasBiddingScheme extends BiddingScheme
{
    /**
     * The MaxCpc
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Bid
     */
    public $MaxCpc;
    /**
     * The TargetRoas
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var float
     */
    public $TargetRoas;
    /**
     * Constructor method for TargetRoasBiddingScheme
     * @uses TargetRoasBiddingScheme::setMaxCpc()
     * @uses TargetRoasBiddingScheme::setTargetRoas()
     * @param \StructType\Bid $maxCpc
     * @param float $targetRoas
     */
    public function __construct(\StructType\Bid $maxCpc = null, $targetRoas = null)
    {
        $this
            ->setMaxCpc($maxCpc)
            ->setTargetRoas($targetRoas);
    }
    /**
     * Get MaxCpc value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Bid|null
     */
    public function getMaxCpc()
    {
        return isset($this->MaxCpc) ? $this->MaxCpc : null;
    }
    /**
     * Set MaxCpc value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\Bid $maxCpc
     * @return \StructType\TargetRoasBiddingScheme
     */
    public function setMaxCpc(\StructType\Bid $maxCpc = null)
    {
        if (is_null($maxCpc) || (is_array($maxCpc) && empty($maxCpc))) {
            unset($this->MaxCpc);
        } else {
            $this->MaxCpc = $maxCpc;
        }
        return $this;
    }
    /**
     * Get TargetRoas value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return float|null
     */
    public function getTargetRoas()
    {
        return isset($this->TargetRoas) ? $this->TargetRoas : null;
    }
    /**
     * Set TargetRoas value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param float $targetRoas
     * @return \StructType\TargetRoasBiddingScheme
     */
    public function setTargetRoas($targetRoas = null)
    {
        // validation for constraint: float
        if (!is_null($targetRoas) && !(is_float($targetRoas) || is_numeric($targetRoas))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($targetRoas, true), gettype($targetRoas)), __LINE__);
        }
        if (is_null($targetRoas) || (is_array($targetRoas) && empty($targetRoas))) {
            unset($this->TargetRoas);
        } else {
            $this->TargetRoas = $targetRoas;
        }
        return $this;
    }
}
