<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for VerifiedTrackingSetting StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:VerifiedTrackingSetting
 * @subpackage Structs
 */
class VerifiedTrackingSetting extends Setting
{
    /**
     * The Details
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfArrayOfKeyValuePairOfstringstring
     */
    public $Details;
    /**
     * Constructor method for VerifiedTrackingSetting
     * @uses VerifiedTrackingSetting::setDetails()
     * @param \ArrayType\ArrayOfArrayOfKeyValuePairOfstringstring $details
     */
    public function __construct(\ArrayType\ArrayOfArrayOfKeyValuePairOfstringstring $details = null)
    {
        $this
            ->setDetails($details);
    }
    /**
     * Get Details value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfArrayOfKeyValuePairOfstringstring|null
     */
    public function getDetails()
    {
        return isset($this->Details) ? $this->Details : null;
    }
    /**
     * Set Details value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfArrayOfKeyValuePairOfstringstring $details
     * @return \StructType\VerifiedTrackingSetting
     */
    public function setDetails(\ArrayType\ArrayOfArrayOfKeyValuePairOfstringstring $details = null)
    {
        if (is_null($details) || (is_array($details) && empty($details))) {
            unset($this->Details);
        } else {
            $this->Details = $details;
        }
        return $this;
    }
}
